package edu.gwu.blaise.version2.backend.packagers;
import edu.gwu.blaise.version2.transmission.*;
import edu.gwu.blaise.version2.backend.queries.*;
import edu.gwu.servlets.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*; 
import java.util.Vector;
import java.util.StringTokenizer;
/**
 * Performs a get query and handles the packaging of query data into 
 * a form that is appropriate for transmission.
 * 
 * @author Michael Gaiman
 * @version 2 Jan 19, 2004
 */
/*
 * Please note:  All Actual SQL-type stuff is marked by //------SQL Here------ tags.
 */
public class PackageGet extends Packager{

    public PackageGet(String commandType, HttpServletRequest request, String limitBy){
        super(commandType,request,limitBy);
    }

    public byte[] execute(boolean b){/*this method is useless in this context, but it has to be in here*/
        //this method should never be called, but it has to be here.  try to send an error message with the proper
        //encoding, otherwise send one with whatever encoding we can get
        try{
            return new ResultWriter(false,"","This method isn't supposed to be called here.").toString().getBytes("UTF-8");
        }catch(java.io.UnsupportedEncodingException e){
            return new ResultWriter(false,"","This method isn't supposed to be called here.").toString().getBytes();
        }
    }

    /**
     * Performs the actual query and packaging.
     * @return The result from the query in a form that is appropriate for transmission.
     */
    public String execute(){
        //first, make sure that this is a valid query.
        if(request==null){
            return new ResultWriter(false,"","An Internal Server Error Occurred, please report to administrator."+
                                             " (No request object in PackageGet.)").toString();
        }
        if(commandType==null){
            return new ResultWriter(false,"","An Internal Server Error Occurred, please report to Administrator."+
                                            " (No commandType object in PackageGet.)").toString();
        }
        //check to see that it is one of the three valid limitBys
        if(limitBy==null){
            return new ResultWriter(false,"","An Internal Server Error Occurred, please report to Administrator."+
                                            " (No limitBy object in PackageGet.)").toString();
        }
        else if(limitBy.equals(PackagingConstants.LIMIT_writer)){
        }
        else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
        }
        else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
        }
        else{
            return new ResultWriter(false,"","An Internal Server Error Occurred, please report to Administrator."+
                                            " (invalid limitBy object in PackageGet.)").toString();
        }
        BaseServlet.writeLog("PackageGet: "+limitBy+" is doing: "+commandType);
        Long limitID=null;//passed to the query
        Vector IDs=null;
        String table=null;
        //now handle the request (also check for invalid commandType, and invalid commandType/limitBy combination)
        if(commandType.equals(TransmissionConstants.getWriter)){
            //format the request properly for the limitBy
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
            //only one writerID allowed.
                if(request.getParameter("writerID")==null){
                    return new ResultWriter(false,"","Required writerID parameter missing.").toString();
                }
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("writerID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid writerID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one writerID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                    table=PackagingConstants.TABLE_writer;
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                IDs=getLongVector(request.getParameter("writerID"));
                table=PackagingConstants.TABLE_writer;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("graderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid graderID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one graderID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("writerID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid writerID format.").toString();
                }
                table=PackagingConstants.TABLE_writer;
            }
        }
        else if(commandType.equals(TransmissionConstants.getGrader)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
            //only one graderID allowed.
                if(request.getParameter("graderID")==null){
                    return new ResultWriter(false,"","Required graderID parameter missing.").toString();
                }
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("graderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid graderID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one graderID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                    table=PackagingConstants.TABLE_grader;
                }    
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("graderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid graderID format.").toString();
                }
                table=PackagingConstants.TABLE_grader;
            }
            
        }
        else if(commandType.equals(TransmissionConstants.getCourse)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                try{
                    IDs=getLongVector(request.getParameter("courseID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid courseID format.").toString();
                }
                table=PackagingConstants.TABLE_course;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("writerID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid writerID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one writerID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                try{
                    IDs=getLongVector(request.getParameter("courseID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid courseID format.").toString();
                }
                table=PackagingConstants.TABLE_course;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("graderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid graderID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one graderID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("courseID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid courseID format.").toString();
                }
                table=PackagingConstants.TABLE_course;
            }
        }
        else if(commandType.equals(TransmissionConstants.getUniversity)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                return new 
                ResultWriter(false,"","Access Denied.  Graders may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("universityID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid universityID format.").toString();
                }
                table=PackagingConstants.TABLE_university;
            }
        }
        else if(commandType.equals(TransmissionConstants.getAdmin)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                return new 
                ResultWriter(false,"","Access Denied.  Graders may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("adminID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid adminID format.").toString();
                }
                table=PackagingConstants.TABLE_admin;
            }
        }
        else if(commandType.equals(TransmissionConstants.getCourseToGrader)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                return new 
                ResultWriter(false,"","Access Denied.  Graders may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("courseToGraderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid courseToGraderID format.").toString();
                }
                table=PackagingConstants.TABLE_ctg;
            }
        }
        else if(commandType.equals(TransmissionConstants.getCourseToWriter)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                return new 
                ResultWriter(false,"","Access Denied.  Graders may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("courseToWriterID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid courseToWriterID format.").toString();
                }
                table=PackagingConstants.TABLE_ctw;
            }
        }
        else if(commandType.equals(TransmissionConstants.getCheckout)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                return new 
                ResultWriter(false,"","Access Denied.  Graders may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("checkoutID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid checkoutID format.").toString();
                }
                table=PackagingConstants.TABLE_checkout;
            }
        }
        else if(commandType.equals(TransmissionConstants.getEmailQueue)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                return new 
                ResultWriter(false,"","Access Denied.  Graders may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("queueID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid queue format.").toString();
                }
                table=PackagingConstants.TABLE_eq;
            }
        }
        else if(commandType.equals(TransmissionConstants.getAssignment)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                try{
                    IDs=getLongVector(request.getParameter("assignID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid assignID format.").toString();
                }
                table=PackagingConstants.TABLE_assignment;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("writerID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid writerID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one writerID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                try{
                    IDs=getLongVector(request.getParameter("assignID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid assignID format.").toString();
                }
                table=PackagingConstants.TABLE_assignment;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("graderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid graderID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one graderID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("assignID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid assignID format.").toString();
                }
                table=PackagingConstants.TABLE_assignment;
            }
        }
        else if(commandType.equals(TransmissionConstants.getDraftStructure)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                try{
                    IDs=getLongVector(request.getParameter("draftStructureID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid assignID format.").toString();
                }
                table=PackagingConstants.TABLE_ds;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("writerID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid writerID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one writerID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                try{
                    IDs=getLongVector(request.getParameter("draftStructureID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid draftStructureID format.").toString();
                }
                table=PackagingConstants.TABLE_ds;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("graderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid graderID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one graderID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("draftStructureID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid draftStructureID format.").toString();
                }
                table=PackagingConstants.TABLE_ds;
            }
        }
        else if(commandType.equals(TransmissionConstants.getStaging)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                try{
                    IDs=getLongVector(request.getParameter("stagingID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid stagingID format.").toString();
                }
                table=PackagingConstants.TABLE_staging;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("graderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid graderID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one graderID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("stagingID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid stagingID format.").toString();
                }
                table=PackagingConstants.TABLE_staging;
            }
        }
        else if(commandType.equals(TransmissionConstants.getWriterAsGrader)){
            if(limitBy.equals(PackagingConstants.LIMIT_writer)){
                return new 
                ResultWriter(false,"","Access Denied.  Writers may not perform desired action.").toString();                
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_grader)){
                try{
                    IDs=getLongVector(request.getParameter("writerAsGraderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid writerAsGraderID format.").toString();
                }
                table=PackagingConstants.TABLE_wag;
                //get limitID
                Vector v=null;
                try{
                    v=getLongVector(request.getParameter("graderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid graderID format.").toString();
                }
                if(v==null || v.size()!=1){
                    return new ResultWriter(false,"","Exacly one graderID required.").toString();
                }
                else{
                    limitID=(Long)v.firstElement();
                }
            }
            else if(limitBy.equals(PackagingConstants.LIMIT_admin)){
                try{
                    IDs=getLongVector(request.getParameter("writerAsGraderID"));
                }catch(NumberFormatException e){
                    return new ResultWriter(false,"","Invalid writerAsGraderID format.").toString();
                }
                table=PackagingConstants.TABLE_wag;
            }
        }

        else if(commandType.equals(TransmissionConstants.getPaperFull)){
            //papers aren't handled in this class...if we're here then the servlet has a bug.
            BaseServlet.writeLog("GET PAPERFULL REQUEST SENT TO PACKAGEGET! limitBy:"+limitBy);
            return new ResultWriter(false,"","Internal Server error detected.  Please notify an Administrator."+
                                                "getPaper request sent to PackageGet").toString();
        }
        else if(commandType.equals(TransmissionConstants.getPaperHeader)){
            //papers aren't handled in this class...if we're here then the servlet has a bug.
            BaseServlet.writeLog("GET PAPERHEADER REQUEST SENT TO PACKAGEGET! limitBy:"+limitBy);
            return new ResultWriter(false,"","Internal Server error detected.  Please notify an Administrator."+
                                                "getPaperHeader request sent to PackageGet").toString();
        }
        else{
            return new ResultWriter(false,"","Invalid command: "+commandType).toString();
        }
        
        //----------------SQL HERE----------------------
        //Now perform the query.  
        GetQuery gq=new GetQuery(IDs,table,limitBy,limitID);
        String results=null;
        try{
            ResultSet rs=gq.execute();
            results=WriteResults(rs);//puts it into a nicely formated (for transmission) table.
        }
        catch(SQLException e){//an error occurred.  Tell user some info, and log it.
            ResultWriter dbError= new ResultWriter(false,"","A database error has occurred. ");
            dbError.append(e.getMessage());
            StringBuffer ex=new StringBuffer(e.getMessage());
            while((e=e.getNextException())!=null){
                ex.append(e.getMessage());
            }
            //from edu.gwu.servlets
            BaseServlet.writeLog("Database error occurred in PackageGet:"+ex.toString()+
                " With parameters:" +" IDs:"+IDs +" table:"+table +
                " limitBy:"+limitBy +" limitID:"+limitID);
            return dbError.toString();//return the error message...
        }
        catch(NullPointerException n){//GetQuery will return null if any of the parameter were wrong
            return new ResultWriter(false,"","An internal server error occurred."+
                                    " Please report to an Administrator.").toString();
        }
        finally{
            gq.free();//let the connection return to the pool.
        }
        
        return results;
    }
    
    ///////////////////////////////////////////////////
    //
    // Utility Methods
    //
    ///////////////////////////////////////////////////    
    
    /**
     * pulls any and all ids from the string, and returns them in Long form packaged in a Vector.
     * @param id The String containing all the IDs. (may be null, or empty).
     * @return the IDs packed in a Vector in Long form. (<code>null</code> if param id is null or empty).
     */
    private Vector getLongVector(String id) throws NumberFormatException{
        Vector v=null;
        if(id!=null && !id.equals("")){
            StringTokenizer st=new StringTokenizer(id,TransmissionConstants.ID_SEPARATOR);
            v=new Vector();
            while(st.hasMoreTokens()){
                v.add(new Long(st.nextToken()));
            }
        }
        return v;
    }
    
    /**
     * pulls any and all ids from the string, and returns them in Integer form packaged in a Vector.
     * @param id The String containing all the IDs. (may be null, or empty).
     * @return the IDs packed in a Vector in Integer form. (<code>null</code> if param id is null or empty).
     */
    private Vector getIntegerVector(String id) throws NumberFormatException{
        Vector v=null;
        if(id!=null && !id.equals("")){
            StringTokenizer st=new StringTokenizer(id,TransmissionConstants.ID_SEPARATOR);
            v=new Vector();
            while(st.hasMoreTokens()){
                v.add(new Integer(st.nextToken()));
            }
        }
        return v;
    }
    
    /**
     * Converts The result set into a {@link edu.gwu.Blaise.version2.transmission.ResultWriter}
     * and then returns the String of it.
     * @param rs The ResultSet to get the data from.
     * @return String appropriate for transmission back to the user.
     */
    private String WriteResults(ResultSet rs) throws SQLException{
    //----------------SQL HERE-------------------------------
        ResultWriter out=new ResultWriter();
        ResultSetMetaData rsmd=rs.getMetaData();//gets column names and numCols
        
        int numCols=rsmd.getColumnCount();
        boolean[] passwordColumn=new boolean[numCols];//do not release passwords columns
        for(int i=0;i<numCols;i++){//initialize array
            passwordColumn[i]=false;
        }
        
        //set the format
        StringBuffer format=new StringBuffer();
        for(int i=1;i<=numCols;i++){
            if(rsmd.getColumnLabel(i).equalsIgnoreCase("password")){
            //do not release password columns
                passwordColumn[i-1]=true;
                continue;
            }
            format.append(rsmd.getColumnLabel(i));
            if(i<numCols){
            //don't append column separator after last column.
                format.append(TransmissionConstants.COL_SEPARATOR);
            }
        }
        format.append(TransmissionConstants.ROW_SEPARATOR);
        out.setFormat(format.toString());
        
        //get the data
        while(rs.next()){
            for(int i=1;i<=numCols;i++){
                if(passwordColumn[i-1]){
                //do not release password columns
                    continue;
                }
                
                /*Object o=rs.getObject(i);
                if(o!=null){
                    out.append(o.toString());
                }
                else{
                    out.append("null");
                }*/
                out.append(rs.getString(i));
                if(i<numCols){
                //don't append column separator after last column.
                    out.append(TransmissionConstants.COL_SEPARATOR);
                }
            }
            if(!rs.isLast()){
                out.append(TransmissionConstants.ROW_SEPARATOR);
            }
        }
        //all the results have been gotten...so it was successful
        out.setStatus(true);
        return out.toString();
    }
}
