package edu.gwu.blaise.version2.backend.queries;
import edu.gwu.servlets.*;
import edu.gwu.blaise.version2.backend.util.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;
/**
 * Performs a editAssignment query.  Please note, all error checking needs to be in the
 * caller as this class does no error checking on its parameters.
 * @author Jared Kiraly
 * @version 2 5/19/2004
 */
public class EditAssignmentQuery implements SetQuery{
    
    Long assignID=		null;
    Long courseID=		null;
    String name=		null;
    Integer numDrafts=		null;
    Integer assignNum=		null;
    
    /** Our pooled connection. */
    Connection c=StaticContext.getSQLConnection();
    
  public EditAssignmentQuery(Long assignID,
                         Long courseID,
                         String name,
                         Integer numDrafts,
                         Integer assignNum){
        //in the non-String, non-Vector objects, null values are not checked for.
        this.assignID=assignID;
        this.courseID=courseID;
        this.name=name;
        this.numDrafts=numDrafts;
        this.assignNum=assignNum;
        
        if(assignID==null){
            throw new IllegalArgumentException("EditAssignmentQuery: writerID required.");
        }
        
        //the connection wasn't available. (too busy, or something).
        if(c==null){
            throw new NoConnectionException();
        }
    }
    
    public int execute() throws SQLException{
        int update=0;
        try{
        /*UPDATE comment SET courseID=?, name=?, numDrafts=?, assignNum=? WHERE assignID=?;
        */
            StringBuffer sqlCommand=new StringBuffer("UPDATE assignment SET");
            if(courseID!=null){
                sqlCommand.append(" courseID=?,");
            }
            if(name!=null){
                sqlCommand.append(" name=?,");
            }
            if(numDrafts!=null){
                sqlCommand.append(" numDrafts=?,");
            }
            if(assignNum!=null){
                sqlCommand.append(" assignNum=?,");
            }
            sqlCommand.deleteCharAt(sqlCommand.length()-1);
            sqlCommand.append(" WHERE assignID=?;");
            //prepare the statement.
            PreparedStatement ps=c.prepareStatement(sqlCommand.toString());
            ps.clearParameters();
            
            int currentIndex=1;
            //fill in the ?s
            if(courseID!=null){
                ps.setLong(currentIndex,courseID.longValue());
                currentIndex++;
            }
            if(name!=null){
                ps.setString(currentIndex,name);
                currentIndex++;
            }
            if(numDrafts!=null){
                ps.setInt(currentIndex,numDrafts.intValue());
                currentIndex++;
            }
            if(assignNum!=null){
                ps.setInt(currentIndex,assignNum.intValue());
                currentIndex++;
            }
            
            ps.setLong(currentIndex, assignID.longValue());
            
            //everything is filled in.  Do this shiznit...
            update=ps.executeUpdate();
        }finally{
            StaticContext.freeSQLConnection(c);
        }            
        return update;
    }
}
