package edu.gwu.blaise.version2.backend.queries;
import edu.gwu.servlets.*;
import edu.gwu.blaise.version2.backend.util.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;
/**
 * Performs a editCourseToGrader query.  Please note, all error checking needs to be in the
 * caller as this class does no error checking on its parameters.
 * @author Jared Kiraly
 * @version 2 5/19/2004
 */
public class EditCourseToGraderQuery implements SetQuery{
    Long courseToGraderID=	null;
    Long courseID=		null;
    Long graderID=		null;
    
    /** Our pooled connection. */
    Connection c=StaticContext.getSQLConnection();
    
  public EditCourseToGraderQuery(Long courseToGraderID,
                         Long courseID,
                         Long graderID){
        //in the non-String, non-Vector objects, null values are not checked for.
        this.courseToGraderID=courseToGraderID;
        this.graderID=graderID;
        this.courseID=courseID;    
        
        if(courseToGraderID==null){
            throw new IllegalArgumentException("EditCourseToGraderQuery: courseToGraderID required.");
        }
        
        //the connection wasn't available. (too busy, or something).
        if(c==null){
            throw new NoConnectionException();
        }
    }
    
    public int execute() throws SQLException{
        int update=0;
        try{
        /*UPDATE course_to_grader SET courseID=?, graderID=? WHERE courseToGraderID=?;
        */
            StringBuffer sqlCommand=new StringBuffer("UPDATE course_to_grader SET");
            if(courseID!=null){
                sqlCommand.append(" courseID=?,");
            }
            if(graderID!=null){
                sqlCommand.append(" graderID=?,");
            }
    
            sqlCommand.deleteCharAt(sqlCommand.length()-1);
            sqlCommand.append(" WHERE courseToGraderID=?;");
            //prepare the statement.
            PreparedStatement ps=c.prepareStatement(sqlCommand.toString());
            ps.clearParameters();
            
            int currentIndex=1;
            //fill in the ?s
            if(courseID!=null){
                ps.setLong(currentIndex,courseID.longValue());
                currentIndex++;
            }
            if(graderID!=null){
                ps.setLong(currentIndex,graderID.longValue());
                currentIndex++;
            }
            
            ps.setLong(currentIndex, courseToGraderID.longValue());
            
            //everything is filled in.  Do this shiznit...
            update=ps.executeUpdate();
        }finally{
            StaticContext.freeSQLConnection(c);
        }            
        return update;
    }
}
