package edu.gwu.blaise.version2.backend.queries;
import edu.gwu.servlets.*;
import edu.gwu.blaise.version2.backend.util.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;
/**
 * Performs a editCourseToWriter query.  Please note, all error checking needs to be in the
 * caller as this class does no error checking on its parameters.
 * @author Jared Kiraly
 * @version 2 5/19/2004
 */
public class EditCourseToWriterQuery implements SetQuery{
    Long courseToWriterID=	null;
    Long courseID=		null;
    Long writerID=		null;
    
    /** Our pooled connection. */
    Connection c=StaticContext.getSQLConnection();
    
  public EditCourseToWriterQuery(Long courseToWriterID,
                         Long courseID,
                         Long writerID){
        //in the non-String, non-Vector objects, null values are not checked for.
        this.courseToWriterID=courseToWriterID;
        this.writerID=writerID;
        this.courseID=courseID;    
        
        if(courseToWriterID==null){
            throw new IllegalArgumentException("EditCourseToWriterQuery: courseToWriterID required.");
        }
        
        //the connection wasn't available. (too busy, or something).
        if(c==null){
            throw new NoConnectionException();
        }
    }
    
    public int execute() throws SQLException{
        int update=0;
        try{
        /*UPDATE course_to_writer SET courseID=?, writerID=? WHERE courseToWriterID=?;
        */
            StringBuffer sqlCommand=new StringBuffer("UPDATE course_to_writer SET");
            if(courseID!=null){
                sqlCommand.append(" courseID=?,");
            }
            if(writerID!=null){
                sqlCommand.append(" writerID=?,");
            }
    
            sqlCommand.deleteCharAt(sqlCommand.length()-1);
            sqlCommand.append(" WHERE courseToWriterID=?;");
            //prepare the statement.
            PreparedStatement ps=c.prepareStatement(sqlCommand.toString());
            ps.clearParameters();
            
            int currentIndex=1;
            //fill in the ?s
            if(courseID!=null){
                ps.setLong(currentIndex,courseID.longValue());
                currentIndex++;
            }
            if(writerID!=null){
                ps.setLong(currentIndex,writerID.longValue());
                currentIndex++;
            }
            
            ps.setLong(currentIndex, courseToWriterID.longValue());
            
            //everything is filled in.  Do this shiznit...
            update=ps.executeUpdate();
        }finally{
            StaticContext.freeSQLConnection(c);
        }            
        return update;
    }
}
