package edu.gwu.blaise.version2.backend.queries;
import edu.gwu.servlets.*;
import edu.gwu.blaise.version2.backend.util.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;
/**
 * Performs a editPaper query.  Please note, all error checking needs to be in the
 * caller as this class does no error checking on its parameters.
 * @author Jared Kiraly
 * @version 2 5/19/2004
 */
public class EditPaperQuery implements SetQuery{
    
    Long paperID=		null;
    Long assignID=		null;
    
    /** Our pooled connection. */
    Connection c=StaticContext.getSQLConnection();
    
  public EditPaperQuery(Long paperID,
                         Long assignID){
        //in the non-String, non-Vector objects, null values are not checked for.
        this.paperID=paperID;
        this.assignID=assignID;
        
        if(paperID==null){
            throw new IllegalArgumentException("EditPaperQuery: paperID required.");
        }
        
        //the connection wasn't available. (too busy, or something).
        if(c==null){
            throw new NoConnectionException();
        }
    }
    
    public int execute() throws SQLException{
        int update=0;
        try{
        /*UPDATE paper SET assignID=? WHERE paperID=?;
        */
            StringBuffer sqlCommand=new StringBuffer("UPDATE paper SET");
            if(assignID!=null){
                sqlCommand.append(" assignID=?");
            }
            sqlCommand.append(" WHERE paperID=?;");
            //prepare the statement.
            PreparedStatement ps=c.prepareStatement(sqlCommand.toString());
            ps.clearParameters();
            
            int currentIndex=1;
            //fill in the ?s
            if(assignID!=null){
                ps.setInt(currentIndex,assignID.intValue());
                currentIndex++;
            }
            
            ps.setLong(currentIndex, paperID.longValue());
            
            //everything is filled in.  Do this shiznit...
            update=ps.executeUpdate();
        }finally{
            StaticContext.freeSQLConnection(c);
        }            
        return update;
    }
}
