package edu.gwu.blaise.version2.backend.queries;
import java.sql.*;
/**
 * The interface that all GetXXXIDQuery classes implement.
 * @author Michael Gaiman
 * @version 2 1/20/2004
 */
public interface GetIDQuery {
    /**
     * Performs the lookup.  It first assembles the correct sql statement,
     * then it does the query and returns the ResultSet.
     * @return The ResultSet containing the results from the query.
     */
    public ResultSet execute() throws SQLException;
    /**
     * The ResultSet is linked to a Connection, so the Connection cannot be
     * freed until use of the ResultSet is completed.  Call this method to free the connection.
     * <p>Generally this method call should be in a finally block (from the try catch block for SQLException).</p>
     */
    public void free();
}
