package edu.gwu.blaise.version2.backend.queries;

import edu.gwu.servlets.*;
import edu.gwu.blaise.version2.backend.util.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;
/**
 * Performs a newWriterAsGrader query.  Please note, all error checking needs to be in the
 * caller as this class does no error checking on its parameters.
 * @author Jared Kiraly
 * @version 2 5/24/2004
 */
public class NewWriterAsGraderQuery implements NewQuery{
    Long draftStructureID=	null;
    Long writerAsWriterID=	null;
    Long writerAsGraderID=	null;
    Long courseID=		null;
    final String statement="INSERT INTO writer_as_grader VALUES(null,?,?,?,?,\"N\");";
    final String lastIDStatement="SELECT LAST_INSERT_ID();";
    Long lastID=		null;
    
    /** Our pooled connection. */
    Connection c=StaticContext.getSQLConnection();
    
    public NewWriterAsGraderQuery(Long draftStructureID,
                                  Long writerAsGraderID,
                                  Long writerAsWriterID,
                                  Long courseID){
        this.draftStructureID=draftStructureID;
        this.writerAsGraderID=writerAsGraderID;
        this.writerAsWriterID=writerAsWriterID;
        this.courseID=courseID;
        
        //the connection wasn't available. (too busy, or something).
        if(c==null){
            throw new NoConnectionException();
        }
    }
    
    public int execute() throws SQLException{
        int i=0;
        try{
            //prepare the statement.
            if(BaseServlet.debugOn()){//from edu.gwu.servlets
                BaseServlet.writeDebug(
                    "NewWriterAsGraderQuery: for parameters: ( draftStructureID: "+draftStructureID+
                    " writerAsGraderID: "+writerAsGraderID+" writerAsWriterID:"+writerAsWriterID+
                    " courseID: "+courseID+") the following statement was assembled: "+statement    
                );
            }
            PreparedStatement ps=c.prepareStatement(statement);
            ps.clearParameters();
            //fill in the ?s
            ps.setLong(1,draftStructureID.longValue());
            ps.setLong(2,writerAsGraderID.longValue());
            ps.setLong(3,writerAsWriterID.longValue());
            ps.setLong(4,courseID.longValue());
                    
            //everything is filled in.  Do this shiznit...
            i=ps.executeUpdate();
            
            //get the last ID.
            ps=c.prepareStatement(lastIDStatement);
            ResultSet rs=ps.executeQuery();
            if(rs.next()){
                lastID=new Long(rs.getLong(1));
            }
        //return the connection to the pool
        }finally{
            StaticContext.freeSQLConnection(c);
        }
        return i;
    }
    
    public Long getLastInsertID(){
        return lastID;
    }
}
