package edu.gwu.blaise.version2.backend.queries;

import edu.gwu.servlets.*;
import edu.gwu.blaise.version2.backend.util.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;
/**
 * Performs a newWriter query.  Please note, all error checking needs to be in the
 * caller as this class does no error checking on its parameters.
 * @author Jared Kiraly
 * @version 2 5/18/2004
 */

public class NewWriterQuery implements NewQuery{
    Integer universityID=	null;
    String studentIdentifier=	null;
    String firstName=		null;
    String lastName=		null;
    String email=		null;
    String userName=		null;
    String password=		null;
    String userNameType=	null;
    final String statement="INSERT INTO writer VALUES(null,?,?,?,?,?,?,?,?,now());";
    final String lastIDStatement="SELECT LAST_INSERT_ID();";
    Long lastID=		null;
    
    /** Our pooled connection. */
    Connection c=StaticContext.getSQLConnection();
    
    public NewWriterQuery(Integer universityID, String studentIdentifier, String firstName, String lastName, String email, String userName, String password, String userNameType){
        this.universityID=universityID;
        this.studentIdentifier=studentIdentifier;
        this.firstName=firstName;
        this.lastName=lastName;
        this.email=email;
        this.userName=userName;
        this.password=password;
        this.userNameType=userNameType;        
        
        //the connection wasn't available. (too busy, or something).
        if(c==null){
            throw new NoConnectionException();
        }
    }
    
    public int execute() throws SQLException{
        int i=0;
        try{
            //prepare the statement.
            if(BaseServlet.debugOn()){//from edu.gwu.servlets
                BaseServlet.writeDebug(
                    "NewWriterQuery: for parameters: ( universityID:"+universityID+" studentIdentifier: "+studentIdentifier+
                    " firstName: "+firstName+" lastName: "+lastName+" email: "+email+" userName: "+
                    userName+" password: "+password+" userNameType: "+userNameType+") the following statement was assembled: "+statement
                );
            }
            PreparedStatement ps=c.prepareStatement(statement);
            ps.clearParameters();
            //fill in the ?s
            ps.setInt(1,universityID.intValue());
            ps.setString(2,studentIdentifier);
            ps.setString(3,firstName);
            ps.setString(4,lastName);
            ps.setString(5,email);
            ps.setString(6,userName);
            ps.setString(7,password);
            ps.setString(8,userNameType);
                    
            //everything is filled in.  Do this shiznit...
            i=ps.executeUpdate();
            
            //get the last ID.
            ps=c.prepareStatement(lastIDStatement);
            ResultSet rs=ps.executeQuery();
            if(rs.next()){
                lastID=new Long(rs.getLong(1));
            }
        //return the connection to the pool
        }finally{
            StaticContext.freeSQLConnection(c);
        }
        return i;
    }
    
    public Long getLastInsertID(){
        return lastID;
    }
}
