package edu.gwu.blaise.version2.backend.queries;
import edu.gwu.servlets.*;
import edu.gwu.blaise.version2.backend.util.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;

public class SetHasBeenDownloadedQuery implements SetQuery{
    
    Long paperID=		null;
    String hasBeenDownloaded=		null;
    
    /** Our pooled connection. */
    Connection c=StaticContext.getSQLConnection();
    
  public SetHasBeenDownloadedQuery(Long paperID,
                         String hasBeenDownloaded){
        //in the non-String, non-Vector objects, null values are not checked for.
        this.paperID=paperID;
        this.hasBeenDownloaded=hasBeenDownloaded;
        if(paperID==null){
            throw new IllegalArgumentException("SetHasBeenDownloadedQuery: paperID required.");
        }
        
        //the connection wasn't available. (too busy, or something).
        if(c==null){
            throw new NoConnectionException();
        }
    }
    
    public int execute() throws SQLException{
        int update=0;
        try{
        /*UPDATE paper SET hasBeenDownloaded=?;
        */
            StringBuffer sqlCommand=new StringBuffer("UPDATE paper SET");
            sqlCommand.append(" hasBeenDownloaded=?");
            sqlCommand.append(" WHERE paperID=?;");
            //prepare the statement.
            PreparedStatement ps=c.prepareStatement(sqlCommand.toString());
            ps.clearParameters();
            
            int currentIndex=1;
            //fill in the ?
            if(hasBeenDownloaded!=null){
                ps.setString(currentIndex,hasBeenDownloaded);
                currentIndex++;
            }
            else{
                ps.setString(currentIndex,"N");
            }
            
            ps.setLong(currentIndex, paperID.longValue());
            
            //everything is filled in.  Do this shiznit...
            update=ps.executeUpdate();
        }finally{
            StaticContext.freeSQLConnection(c);
        }            
        return update;
    }
}
