package edu.gwu.blaise.version2.backend.queries;
import edu.gwu.servlets.*;
import edu.gwu.blaise.version2.backend.util.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;
/**
 * Performs a editEmailQueue query.  Please note, all error checking needs to be in the
 * caller as this class does no error checking on its parameters.
 * @author Jared Kiraly
 * @version 2 6/10/2004
 */
public class SetPapersToBeSentQuery implements SetQuery{
    
    Vector emailQueueID=		null;
    
    /** Our pooled connection. */
    Connection c=StaticContext.getSQLConnection();
    
  public SetPapersToBeSentQuery(Vector emailQueueID){
        //in the non-String, non-Vector objects, null values are not checked for.
        this.emailQueueID=emailQueueID;
        if(emailQueueID==null){
            throw new IllegalArgumentException("EditEmailQueueQuery: emailQueueID required.");
        }
        
        //the connection wasn't available. (too busy, or something).
        if(c==null){
            throw new NoConnectionException();
        }
    }
    
    public int execute() throws SQLException{
        int update=0;
        try{
        /*UPDATE emailQueue SET wait="N" WHERE (emailQueueID=? OR emailQueueID=?);
        */
            StringBuffer sqlCommand=new StringBuffer("UPDATE emailQueue SET wait=?");
            int size=emailQueueID.size();
            sqlCommand.append(" (emailQueueID=?");	//the first one doesn't have an OR infront
            for(int i=1;i<size;i++){
                sqlCommand.append(" OR");		//the next ones do.
                sqlCommand.append(" emailQueueID=?");
            }
            sqlCommand.append(")");
            //prepare the statement.
            PreparedStatement ps=c.prepareStatement(sqlCommand.toString());
            ps.clearParameters();
            
            int currentIndex=1;
            //fill in the ?s
            Long val=null;
            ps.setString(currentIndex,"N");
            for(int i=0;i<size;i++){
                val=(Long)emailQueueID.elementAt(i);
                ps.setLong(currentIndex,val.longValue());
                currentIndex++;
            }
            
            //everything is filled in.  Do this shiznit...
            update=ps.executeUpdate();
        }finally{
            StaticContext.freeSQLConnection(c);
        }            
        return update;
    }
}
