package edu.gwu.blaise.version2.backend.util;
import edu.gwu.blaise.version2.backend.queries.*;
import edu.gwu.blaise.version2.documents.*;
import edu.gwu.blaise.version2.backend.packagers.*;
import edu.gwu.blaise.version2.util.*;
import edu.gwu.servlets.*;
import java.sql.*; 
import java.util.Vector;

public class Blaise_PaperVectorGetter{
    GetQuery gq=null;
    Blaise_Paper bp;
    Vector papers=new Vector();
    Vector courseIDs=new Vector();
    Vector writerIDs=new Vector();
    Long id;
    int pSize;
    Vector pIDs = new Vector();
    String limitBy = "";
    Long limitID = null;    
    Vector aIDs=new Vector();

    public Blaise_PaperVectorGetter(Vector pIDs, String limitBy, Long limitID){
        this.pIDs = pIDs;
        this.limitBy = limitBy;
        this.limitID = limitID;
    }

    /**
     * Returns a Vector of Blaise_Papers with all relevant parts (no Drafts, no filename, etc) from a Vector of paperIDs.
     */
    public Vector getBlaise_PaperVector() throws SQLException{
        //------------------SQL HERE---------------------------
        if(BaseServlet.debugOn()){
            BaseServlet.writeDebug("getBlaise_PaperVector: parameters, pIDs:"+pIDs+" limitBy:"+limitBy+" limitID:"+limitID);
        }
        
        //execute query to get stuff from paper table
        try{
            gq=new GetQuery(pIDs,PackagingConstants.TABLE_paper,limitBy,limitID);
            ResultSet rs=gq.execute();
            while(rs.next()){
                bp=new Blaise_Paper();
                bp.setVersion(rs.getString("version"));
                bp.setPaperID(rs.getString("paperID"));
                //add the writerID to the Vector of writerIDs for lookup later
                id=new Long(rs.getLong("writerID"));
                writerIDs.add(id);
                bp.setWriterID(id.toString());
                bp.setUniversityID(rs.getString("universityID"));
                id=new Long(rs.getLong("courseID"));
                courseIDs.add(id);
                bp.setCourseID(id.toString());
                id=new Long(rs.getLong("assignID"));
                aIDs.add(id);
                bp.setAssignmentID(id.toString());
                papers.add(bp);
            }
            
            //execute query to get stuff from writer table
            gq.free();
            gq=new GetQuery(writerIDs,PackagingConstants.TABLE_writer,limitBy,limitID);
            rs=gq.execute();
            pSize=papers.size();
            while(rs.next()){
                //for each paper check to see if this is its writer.  If so, add the info.
                for(int i=0;i<pSize;i++){
                    bp=(Blaise_Paper)papers.get(i);
                    if(rs.getString("writerID").equals(bp.getWriterID())){
                        bp.setFirst(rs.getString("firstName"));
                        bp.setLast(rs.getString("lastName"));
                        bp.setStudentIdentifier(rs.getString("studentIdentifier"));
                        bp.setEmail(rs.getString("email"));
                    }
                }
            }
            
            //execute query to get stuff from course table
            gq.free();
            gq=new GetQuery(courseIDs,PackagingConstants.TABLE_course,limitBy,limitID);
            rs=gq.execute();
            while(rs.next()){
                //for each paper check to see if this is its course.  If so, add the info.
                for(int i=0;i<pSize;i++){
                    bp=(Blaise_Paper)papers.get(i);
                    if(rs.getString("courseID").equals(bp.getCourseID())){
                        bp.setDept(rs.getString("dept"));
                        bp.setNumber(rs.getString("number"));
                        bp.setSection(rs.getString("section"));
                        bp.setYear(rs.getString("year"));
                        bp.setSemester(rs.getString("semester"));
                    }
                }
            }
            
            //execute query to get stuff from assignment table
            gq.free();
            gq=new GetQuery(aIDs,PackagingConstants.TABLE_assignment,limitBy,limitID);
            rs=gq.execute();
            while(rs.next()){
                //for each paper check to see if this is its assignment.  If so, add the info.
                for(int i=0;i<pSize;i++){
                    bp=(Blaise_Paper)papers.get(i);
                    if(rs.getString("assignID").equals(bp.getAssignmentID())){
                        bp.setAssignmentName(rs.getString("name"));
                        bp.setAssignmentNumber(rs.getString("assignNum"));
                    }
                }
            }            
        }finally{
            if(gq!=null){
                gq.free();//no matter what, the connection should get freed.
            }
        }
        return papers;
    }
}
