package edu.gwu.blaise.version2.backend.util;
/**
 * Signals that no connection to the database was available.
 * @author Michael Gaiman
 * @version 2 1/20/2004
 */
public class NoConnectionException extends RuntimeException {

  String errorPre = "The database is currently busy.  Please try again later.";
  String error = null;

  public NoConnectionException (String error)
  {
    super(error);
    this.error = error;
  }

  public NoConnectionException ()
  {
    super();
  }
 
  /**
   * Prints the error message.  The default message is 
   * "The database is currently busy.  Please try again later."
   */
  public String toString ()
  {
    StringBuffer s=new StringBuffer(errorPre);
    if(error!=null){
        s.append(" ( ");
        s.append(error);
        s.append(" )");
    }
    return s.toString();
  }
}
