package edu.gwu.blaise.version2.backend.util;
import edu.gwu.blaise.version2.backend.queries.*;
import java.util.*;
import java.sql.*;

/** 
 *  Creates writer as grader entries for a draft structure
 */
public class WriterAsGraderCreator{
    long kval=0;
    Long k=null;
    Long courseID=null;
    Long draftStructureID=null;

    public WriterAsGraderCreator(Long courseID,Long draftStructureID,Long k){
        this.courseID=courseID;
        this.draftStructureID=draftStructureID;
        kval=k.longValue();
    }
    
    public WriterAsGraderCreator(Long courseID,Long draftStructureID){
        this.courseID=courseID;
        this.draftStructureID=draftStructureID;
    }
    
    public boolean create(){
        Vector v=new Vector();
        v.add(courseID);
        Vector wIDs=new Vector();
        GetWriterIDQuery gwID=new GetWriterIDQuery(null,null,null,null,null,null,null,null,v,null);
        try{
            ResultSet rs=gwID.execute();
            while(rs.next()){
                wIDs.add(new Long(rs.getLong(1)));
            }
        }catch(SQLException e){
            return false;
        }
        
        Long wagID=null;
        Long wawID=null;
        //a k value that is >= the course size (minus one, because writers can't grade their own papers), or <= zero signifies peer review all
        if(kval<=0 || kval>=(wIDs.size()-1)){
            for(int i=0;i<wIDs.size();i++){
                wawID=(Long)wIDs.elementAt(i);
                for(int j=0;j<wIDs.size();j++){
                    if(j!=i){
                        wagID=(Long)wIDs.elementAt(j);
                        try{
                            NewWriterAsGraderQuery nwag=new NewWriterAsGraderQuery(draftStructureID,wagID,wawID,courseID);
                            int ret=nwag.execute();
                            if(ret==0){
                                 return false;
                            }
                        }catch(SQLException e){
                            return false;
                        }catch(NoConnectionException e){
                            return false;
                        }
                    }
                }
            }
        }
        //otherwise, we do peer review random
        else{
            Random r=new Random();
            Vector wv=null;
            Long l=null;
            int ra=0;
            for(int i=0;i<wIDs.size();i++){
                wv=new Vector();
                for(int k=0;k<wIDs.size();k++){
                    l=(Long)wIDs.elementAt(k);
                    wv.add(l);
                }
                wawID=(Long)wIDs.elementAt(i);
                wv.removeElementAt(i);
                for(int j=0;j<kval;j++){
                    ra=r.nextInt(wv.size());
                    wagID=(Long)wv.remove(ra);
                    try{
                        NewWriterAsGraderQuery nwag=new NewWriterAsGraderQuery(draftStructureID,wagID,wawID,courseID);
                        int ret=nwag.execute();
                        if(ret==0){
                             return false;
                        }
                    }catch(SQLException e){
                        return false;
                    }catch(NoConnectionException e){
                        return false;
                    }                    
                }
            }        
        }
        return true;
    }
}
