package edu.gwu.blaise.version2.backend.webaccess;
import edu.gwu.servlets.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import edu.gwu.blaise.version2.transmission.*;
import edu.gwu.blaise.version2.documents.*;
import edu.gwu.blaise.version2.backend.packagers.*;
import edu.gwu.blaise.version2.backend.util.*;
import edu.gwu.blaise.version2.backend.queries.*;
import java.sql.*; 
import org.apache.commons.fileupload.*;

/**
 * This is the servlet module that gives the student
 * web access to the data on blaiseserver. 
 *
 * @author Jared Kiraly
 * @version 2 7/7/2004
 */
public class GraderWebAccess extends BaseServlet{
	private GraderLoginQuery glq;
	private edu.gwu.blaise.version2.transmission.Grader gID;
	private String password=null;
	private String userName=null;
	private String uID=null;
	
	public GraderWebAccess(){
	}
	
	public void doGet (HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
		doPost(req,res);
	}

	public void doPost (HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
		String command=req.getParameter("command");
		
		if(command==null){
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out, req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			//will need more error checking
			if(!FileUpload.isMultipartContent(req)){//if there was some sort of a problem
				//print out the error message
				out.print("<center><h3>Invalid filename</h3></center><p>");
				out.print("</TD></TR></TABLE>");			
			}else{
				byte[] b=this.doSubmit(out, req);
				byte[] first=DualByteArray.extractFirst(b);
				Properties p=DualByteArray.toProperties(first);
				String stat=p.getProperty("status");
				if(stat.equals(TransmissionConstants.SUCCESS)){
					out.print("<center><h3>Paper Submitted Successfully</h3></center><p>");
					out.print("</TD></TR></TABLE>");								
				}else{
					out.print("<center><h3>Error</h3><p></center>");
					out.print(p.getProperty("message"));
					out.print("</TD></TR></TABLE>");									
				}				
			}
			printFooterInfo(out, req);
			out.flush();
			out.close();
		}		
		else if(command.equals("login")){
		//log in the user and display the welcome screen
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			boolean b=this.doLogin(out,req);
			if(b){
				this.doTables(out,req);
				this.getCourses(out,req);
				out.print("</TD><TD>");
				this.welcomeScreen(out,req);
				out.print("</TD></TR></TABLE>");
				printFooterInfo(out,req);
				out.flush();
				out.close();
			}
			else{//login failed, probably a bad password.  Make this look like the login screen  
			   out.print("<CENTER><h3>Invalid User Name or Password.  Please try again.</h3>");
			   out.print("<IMG SRC=\""+TransmissionConstants.logoFileLocation+"\"><br>");
			   out.print("<FORM ACTION=\"GraderWebAccess\" NAME=\"FRM1\" METHOD=\"POST\">");
			   out.print("Username:<INPUT TYPE=\"TEXT\" NAME=\"userName\" VALUE=\""+req.getParameter("userName")+"\"><br><br>");
			   out.print("Password:<INPUT TYPE=\"PASSWORD\" NAME=\"password\"><br>");
			   out.print("University: <SELECT NAME=\"universityID\">");
			   out.print("<OPTION VALUE=\"1\">Hogwarts</OPTION> <OPTION VALUE=\"2\">Springfield</OPTION>");
			   out.print("</SELECT><p>");
			   out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"Log In\" VALUE=\"Log In\">");
			   out.print("<INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"login\">");
			   out.print("</FORM></CENTER>");
			}
		}
		else if(command.equals("doCourse")){
		//display the data for the selected course
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.doCourse(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();
		}
		// previously not used feature, may be buggy
		else if(command.equals("doCheckout")){
		//download the selected paper for grading
			byte[] b=this.doCheckout(req);
			byte[] first=DualByteArray.extractFirst(b);
			Properties p=DualByteArray.toProperties(first);
			String stat=p.getProperty("status");
			if(stat.equals(TransmissionConstants.SUCCESS)){
				Blaise_Paper bp=null;
				try{
					bp=BlaiseFile.byteArrayToPaper(DualByteArray.extractSecond(b));
				}catch(IOException e){
					res.setContentType("text/html");
					PrintWriter out=res.getWriter();
					printHeaderInfo(out,req);
					out.print("<h2>An error has occurred that prevented the paper from being checked out:</h2><p>");
					out.print("Download paper query returned in an unknown format.  Please notify an administrator.");
					this.doTables(out,req);
					this.getCourses(out,req);
					out.print("</TD><TD>");
					this.doCourse(out,req);
					out.print("</TD></TR></TABLE>");
					printFooterInfo(out,req);
					out.flush();
					out.close();
					return;
				}
				Vector v=bp.getDrafts();
				if(v.size()==1){//if this paper has only one external draft, return the paper in the format of the draft
					Blaise_Draft bd=(Blaise_Draft)v.firstElement();
					if(bd.hasExternalBody()){
						res.setContentType("application/octet-stream");
						ServletOutputStream out=res.getOutputStream();
						out.write(bd.getExternalBody());
						out.flush();
						out.close();
					}else{//the paper is in blaise format, continue as usual
						res.setContentType("application/octet-stream");
						ServletOutputStream out=res.getOutputStream();
						out.write(DualByteArray.extractSecond(b));
						out.flush();
						out.close();
					}
				}else{
					res.setContentType("application/octet-stream");
					ServletOutputStream out=res.getOutputStream();
					out.write(DualByteArray.extractSecond(b));				
					out.flush();
					out.close();
				}
			}else{
			//download wasn't successful, print an error message above the course data screen
				res.setContentType("text/html");
				PrintWriter out=res.getWriter();
				printHeaderInfo(out,req);
				out.print("<h2>An error has occurred that prevented the paper from being downloaded:</h2><p>");
				String s=p.getProperty("message");
				String message=null;
				ResultReader rr=new ResultReader(s);
				boolean caught=false;
				try{
					rr.parse();
				}catch(ParseResultException e){
					caught=true;
					message=
					"Check out paper query returned in an unknown format.  Please notify an administrator.";
				}
				if(!caught){
					message=rr.getBody();
				}
				out.print("<h2>"+message+"</h2>");
				this.doTables(out,req);
				this.getCourses(out,req);
				out.print("</TD><TD>");
				this.doCourse(out,req);
				out.print("</TD></TR></TABLE>");
				printFooterInfo(out,req);
				out.flush();
				out.close();				
			}
		}
		
		else if(command.equals("doAssignment")){
			//print the stats of the selected assignment
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			//javascript function asking about deletion
			out.print("<script language=\"Javascript\"> function confirmDelete(){");
			out.print(" var agree=confirm(\"Are you sure you want to delete this?\"); ");
			out.print("if(agree){ return true; } else{ return false; }}</script>");
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.doAssignment(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("addAssignment")){
			//display the screen to add an assignment
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.addAssignment(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("addedAssignment")){
			//actually add the assignment
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.addedAssignment(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("editAssignment")){
			//display the screen to edit an assignment
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			//javascript function asking about editing
			out.print("<script language=\"Javascript\"> function confirmDelete(){");
			out.print(" var agree=confirm(\"Are you sure you want to make these changes?\"); ");
			out.print("if(agree){ return true; } else{ return false; }}</script>");
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.editAssignment(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("editedAssignment")){
			//actually edit the assignment
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.editedAssignment(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("deleteAssignment")){
			//delete the selected assignment
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.deleteAssignment(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("addDS")){
			//display the screen to add a draft structure
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			out.print("<script language=\"Javascript\"> function confirmDelete(){");
			out.print(" var agree=confirm(\"Are you sure you want to make these changes?\"); ");
			out.print("if(agree){ return true; } else{ return false; }}</script>");
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.addDS(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("addedDS")){
			//actually add the draft structure
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.addedDS(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("editDS")){
			//display the screen to edit a draft structure
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			//javascript function asking about editing
			out.print("<script language=\"Javascript\"> function confirmDelete(){");
			out.print(" var agree=confirm(\"Are you sure you want to make these changes?\"); ");
			out.print("if(agree){ return true; } else{ return false; }}</script>");
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.editDS(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("editedDS")){
			//actually edit the draft structure
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.editedDS(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else if(command.equals("deleteDS")){
			//delete a draft structure
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			this.deleteDS(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();			
		}
		else{//bad command name.  This is certainly odd.
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			out.print("<center>");
			out.print("<IMG SRC=\""+TransmissionConstants.logoFileLocation+"\"><br>");
			out.print("<h2>Error: an invalid command type was submitted: "+command+".  Please notify an administrator.</h2><p>");
			out.print("</center>");
			printFooterInfo(out,req);
			out.flush();
			out.close();				
		}
	}
	
	//for checkin
	private byte[] doSubmit(PrintWriter out, HttpServletRequest req){
		// Create a new file upload handler and parse the request
		DiskFileUpload upload = new DiskFileUpload();
		FileItem item;
		Iterator iter;
		List fileItems;
		boolean isFile=false;
		boolean finishLater=false;
		
		try{
			fileItems = upload.parseRequest(req);
			iter = fileItems.iterator();
		}catch(FileUploadException e){
			//may have to change this error message
			return PackagePaper.sendMessage(false, "An error has occurred, please contact the administrator (error code #1).<p>"+e.toString());
		}
		Blaise_Paper bp=new Blaise_Paper();
		Properties p=new Properties();
		String name=null;
		byte[] extFile=new byte[0];
		String draftNum=null;
		String paperID=null;
		String draftID=null;
		
		//all uploaded items handled here
		while (iter.hasNext()) {
			item = (FileItem) iter.next();
			if (item.isFormField()) {
				String str=item.getString();
				if(str.startsWith("pID")){
					paperID=str.substring(3);
				}else if(str.startsWith("gID")){
					//I think this is just a placeholder, but it may be needed later
				}else if(str.startsWith("dID")){
					draftID=str.substring(3);
				}else{
					draftNum=str;
				}				
			}else{
				//this will only work for one paper - shouldnt be a problem
				isFile=true;
				//get filename
				name=item.getName();
				
				//this is simpler if it is a BlaiseFile
				if(name.endsWith(".bls")){
					//include the graderID in the tempfile name to prevent conflicts
//					File f=new File("gtemp"+gID.getGraderID()+".tmp");
					File f=null;
					try{
						f=File.createTempFile("gtemp"+gID.getGraderID(),".tmp");
					}catch(IOException e){
							return PackagePaper.sendMessage(false, "An error has occurred, please contact the administrator (error code #2c).<p>"+e.toString());
					}
					BlaiseFile bf=null;
					try{
						item.write(f);
						bf=new BlaiseFile(bp, f, new BackendFileHandler());
						bf.openPaper();
					}catch(IOException e){
						//may have to change this error message 
						return PackagePaper.sendMessage(false, "An error has occurred, please contact the administrator (error code #2a).<p>"+e.toString());
					}catch(Exception e){
						//may have to change this error message 
						return PackagePaper.sendMessage(false, "An error has occurred, please contact the administrator (error code #2b).<p>"+e.toString());
					}
					bp=bf.getPaper();	
				}else{
					//just set the flag here and get the file later because it needs a draftNum, which may not have been gotten yet
					finishLater=true;
					extFile=item.get();
 				}
		    }
		}

		//only done if this is a non-blaise document
		if(finishLater){
			/*checkin no longer has to be a .bls file
			if(!isSubmit){
				return PackagePaper.sendMessage(false, "Checked in paper must be a .bls file");
			}*/
			
//I'm not sure this check is necessary
			if(draftNum==null || draftNum.equals("")){
				//this means that the draft number wasn't entered and this is not a .bls file
				return PackagePaper.sendMessage(false, "Please enter a draft number.<p>");
			}
			
			if(paperID==null || paperID.equals("")){//it would be strange if this happened.  this is the only reason I can think of.
					return PackagePaper.sendMessage(false, "An error has occurred.  You are checking in a paper that hasn't been checked out. (error code #3a)");							
			}
			
			//get the paper from the database
			Properties p2=new Properties();
			p2.put("graderID",Long.toString(gID.getGraderID()));
			p2.put("paperID",paperID);
			PackagePaper pp2=new PackagePaper(TransmissionConstants.getPaperFull, req, PackagingConstants.LIMIT_grader, null, p2, null);
			byte[] paper=pp2.execute(true);
			
			//check for success
			byte[] first=DualByteArray.extractFirst(paper);
			p2=DualByteArray.toProperties(first);
			String stat=p2.getProperty("status");
			if(stat==null){
				return PackagePaper.sendMessage(false, "Error transmitting paper.");
			}else if(stat.equals(TransmissionConstants.FAILURE)){
				//is this message correct?
				return PackagePaper.sendMessage(false, "No paper specified.");
			}
			
			try{
				bp=BlaiseFile.byteArrayToPaper(paper);
			}catch(IOException e){
				return PackagePaper.sendMessage(false, "An error has occurred while getting the paper (error code #4): "+e.toString());
			}
			
			//get the drafts of this paper and add the checked in external draft as a comment			
			Vector v=bp.getDrafts();
			int draftNumber=-1;
			try{
				draftNumber=Integer.parseInt(draftNum);
			}catch(NumberFormatException e){
				draftNumber=1;
BaseServlet.writeLog("Draft number incorrectly specified as: "+draftNum+".");
//				return PackagePaper.sendMessage(false, "Invalid draft number specified.");
			}
			
			Blaise_Draft bd=(Blaise_Draft)v.elementAt(draftNumber-1);
			
			Blaise_Comment bc=new Blaise_Comment();
			bc.setExternalBody(extFile);
			bc.setExternalBodyFilename(name);
			bc.setGraderID(gID.getGraderID()+"");
			if(paperID!=null){
				bc.setPaperID(paperID);
			}
			bc.setDraftID(bd.getDraftID());
			bc.setGraderName(gID.getFirstName()+" "+gID.getLastName());
			bc.setIsPublic("YES");
			bd.addComment(bc);
			
			bd.setIsModified("YES");
			v.setElementAt(bd, draftNumber-1);
			
			bp.setDrafts(v);
		}
				
		if(isFile){	
			PackagePaper pp;
			p.put("graderID",Long.toString(gID.getGraderID()));			
			bp.setUniversityID(Integer.toString(gID.getUniversityID()));
			if(paperID!=null){
				bp.setPaperID(paperID);
			}
			pp=new PackagePaper(TransmissionConstants.checkInPaper, req, PackagingConstants.LIMIT_grader, null, p, bp);				
			return pp.execute(true);
		}else{
			return PackagePaper.sendMessage(false, "No file specified.");
		}
	}

	/** Display all of the info for the selected assignment */
	private void doAssignment(PrintWriter out,HttpServletRequest req){
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Assignment assi=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			if(Long.toString(a.getAssignID()).equals(req.getParameter("assignID"))){
				assi=a;
			}
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("</FORM>");

		//show the draft structures in a different table column from the assignment list
		out.print("</TD><TD valign=\"top\">");
		out.print("<b>Assignment Number "+assi.assignNum()+": "+assi.name()+"</b><p>");
		out.print("In course: "+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"<p>");
		out.print("<FORM NAME=\"frmEditA\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"editA\" VALUE=\"Edit Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"editAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+req.getParameter("assignID")+"\">");
		out.print("</FORM>");

		out.print("<FORM NAME=\"frmEditA\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"deleteA\" VALUE=\"Delete Assignment\" onClick=\"return confirmDelete()\"><p>");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"deleteAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+req.getParameter("assignID")+"\">");
		out.print("</FORM>");
		
		out.print("<br><b>Draft Structures:</b><p><br>");
		Vector v=assi.getDraftStructure();
		DraftStructure ds=null;
		for(int j=0;j<v.size();j++){
			ds=(DraftStructure)v.elementAt(j);
			out.print("<b>Draft Number "+ds.getDraftNum()+"</b><p> Grading Type: "+ds.getGradingType()+"<p>");
			out.print("Due Date: "+ds.noChangeDate()+"<p>");
			out.print("<FORM NAME=\"frmTheDS"+j+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"ds"+j+"\" VALUE=\"Edit\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"editDS\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"draftStructureID\" VALUE=\""+Long.toString(ds.getDraftStructureID())+"\">");
			out.print("</FORM>");

			out.print("<FORM NAME=\"frmDS"+j+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"DS"+j+"\" VALUE=\"Delete\" onClick=\"return confirmDelete()\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"deleteDS\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"draftStructureID\" VALUE=\""+Long.toString(ds.getDraftStructureID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"numDrafts\" VALUE=\""+Integer.toString(assi.numDrafts())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"draftNum\" VALUE=\""+Long.toString(ds.getDraftNum())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}
		out.print("<FORM NAME=\"frmNewDS\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewDS\" VALUE=\"Add a Draft Structure\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addDS\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
		out.print("</FORM>");
		
		//print out the papers for this assignment
		out.print("</TD><TD>");
		out.print("Papers for <b>Assignment Number "+assi.assignNum()+"</b><p>");
		GetPaperIDQuery gpidq=null;
		GetQuery gq=null;
		try{
			Vector aID=new Vector();
			aID.add(new Long(assi.getAssignID()));
			Vector grID=new Vector();
			grID.add(new Long(gID.getGraderID()));
			//didn't bother sending universityID or courseID, since the assignID supersedes both of those
			gpidq=new GetPaperIDQuery(null, null, null, null, grID, null, null, null, null, null, PackagingConstants.LIMIT_grader, aID, null, null);
			ResultSet rs=gpidq.execute();
			gpidq.free();
			ResultSet rd;
			Vector vect=new Vector();
			long paperID;
			while(rs.next()){
				//get writer information for each paper
				vect.clear();
				paperID=rs.getLong("paperID");
				vect.add(new Long(paperID));
				gq=new GetQuery(vect, PackagingConstants.TABLE_paper, PackagingConstants.LIMIT_grader, new Long(gID.getGraderID()));
				rd=gq.execute();
				rd.next();
				gq.free();
				vect.clear();
				vect.add(new Long(rd.getLong("writerID")));
				gq=new GetQuery(vect, PackagingConstants.TABLE_writer, PackagingConstants.LIMIT_grader, new Long(gID.getGraderID()));
				rd=gq.execute();
				rd.next();
				gq.free();
				
				//have the writer information, now print out the paper
				out.print("<li>Paper for: "+rd.getString("firstName")+" "+rd.getString("lastName"));
				out.print("<FORM NAME=\"frmCheckout\" ACTION=\"GraderWebAccess\" METHOD=\"POST\">");
				out.print("<INPUT TYPE=\"hidden\" NAME=\"paperID\" VALUE=\""+paperID+"\">");
				out.print("<INPUT TYPE=\"hidden\" NAME=\"graderID\" VALUE=\""+gID.getGraderID()+"\">");
				out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doCheckout\">");
				out.print("<INPUT TYPE=\"submit\" NAME=\"Checkout\" VALUE=\"Checkout\"><p>");
				out.print("</FORM>");
				
				out.print("Check in this paper:<p>");
				out.print("<FORM NAME=\"frmCheckout\" ACTION=\"GraderWebAccess\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">");
				out.print("<INPUT TYPE=\"hidden\" NAME=\"paperID\" VALUE=\"pID"+paperID+"\">");				
				out.print("<INPUT TYPE=\"hidden\" NAME=\"writerID\" VALUE=\"gID"+gID.getGraderID()+"\">");
				out.print("Draft number of this paper (if paper is non blaise document):");
				out.print("<INPUT TYPE=\"text\" name=\"draftNum\" size=\"2\"><p>");
				out.print("<INPUT TYPE=\"file\" name=\"paper\" size=\"35\">");
				out.print("<INPUT TYPE=\"submit\" NAME=\"Checkin\" VALUE=\"Check In\"><p>");
				out.print("</FORM>");				
			}
		}catch(SQLException e){
			out.print("Database error.  Please contact an administrator. <p>"+e.getMessage());
		}finally{
			if(gpidq!=null){
				gpidq.free();
			}
			if(gq!=null){
				gq.free();
			}		
		}
		
		out.print("</TD></TR></TABLE><br>");		
	}  
	
	/** Display the screen that allows a grader to add an assignment to a course*/
	private void addAssignment(PrintWriter out,HttpServletRequest req){		
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Assignment assi=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			if(Long.toString(a.getAssignID()).equals(req.getParameter("assignID"))){
				assi=a;
			}
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("</FORM>");

		//the data entry column
		out.print("</TD><TD valign=\"Center\">");
		out.print("<FORM NAME=\"frmTheNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">"); 
		out.print("<br><b>Please enter the name of the new assignment:</b><p>");
		out.print("<INPUT TYPE=\"TEXT\" NAME=\"NewAssignmentName\"><p>");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addedAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"AssignNum\" VALUE=\""+(assignments.size()+1)+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");

		//Cannot have an assignment without draft structures
		out.print("<p><br><b>Please enter the data for the first draft structure in this assignment:</b><p>");

		out.print("<b>Grading Type:</b><p>");
		out.print("<SELECT NAME=\"GradingType\">");
		out.print("<OPTION SELECTED VALUE=\"Instructor\">Instructor</OPTION>");
		out.print("<OPTION VALUE=\"PeerRandom\">Peer Review Random</OPTION>");
		out.print("<OPTION VALUE=\"PeerAll\">Peer Review All</OPTION>");		
		out.print("</SELECT><p><br>");
		
		//set the number of graders for a peer graded assignment.
		//use a drop down box so errors don't have to be handled
		GetWriterIDQuery gwq=null;
		try{
			Vector v=new Vector();
			v.add(new Long(c.getCourseID()));
			gwq=new GetWriterIDQuery(null,null,null,null,null,null,null,null,v,null);
			ResultSet rs=gwq.execute();
			int studnum=0;
			if(rs.next()){
				out.print("Number of graders per writer for peer review random:<p>");
				out.print("<SELECT NAME=\"k\">");
				out.print("<OPTION SELECTED VALUE=\"1\">1</OPTION>");
				studnum=2;
			}
			while(rs.next()){
				out.print("<OPTION VALUE=\""+studnum+"\">"+studnum+"</OPTION>");
				studnum++;
			}
			if(studnum>0){
				out.print("</SELECT><p><br>");
			}
		}catch(SQLException e){
			out.print("Database error: Error getting number of writers in course.");
		}finally{
			gwq.free();
		}
		
		out.print("<b>Turnin Date:</b><p>");
		out.print("<SELECT NAME=\"Month\">");
		out.print("<OPTION SELECTED VALUE=\"0\">January</OPTION>");
		out.print("<OPTION VALUE=\"1\">February</OPTION>");
		out.print("<OPTION VALUE=\"2\">March</OPTION>");		
		out.print("<OPTION VALUE=\"3\">April</OPTION>");
		out.print("<OPTION VALUE=\"4\">May</OPTION>");		
		out.print("<OPTION VALUE=\"5\">June</OPTION>");
		out.print("<OPTION VALUE=\"6\">July</OPTION>");		
		out.print("<OPTION VALUE=\"7\">August</OPTION>");
		out.print("<OPTION VALUE=\"8\">September</OPTION>");		
		out.print("<OPTION VALUE=\"9\">October</OPTION>");
		out.print("<OPTION VALUE=\"10\">November</OPTION>");		
		out.print("<OPTION VALUE=\"11\">December</OPTION>");
		out.print("</SELECT><p>");
		
		out.print("<SELECT NAME=\"Day\">");
		out.print("<OPTION SELECTED VALUE=\"1\">1</OPTION>");
		for(int i=2;i<=31;i++){
			out.print("<OPTION VALUE=\""+i+"\">"+i+"</OPTION>");			
		}
		out.print("</SELECT><p>");	   
		
		out.print("<SELECT NAME=\"Hour\">");
		out.print("<OPTION SELECTED VALUE=\"0\">12 AM</OPTION>");
		for(int i=1;i<24;i++){
			if(i<12){
				out.print("<OPTION VALUE=\""+i+"\">"+i+" AM</OPTION>");
			}
			else if(i==12){
				out.print("<OPTION VALUE=\""+i+"\">"+i+" PM</OPTION>");
			}
			else{
				out.print("<OPTION VALUE=\""+i+"\">"+(i-12)+" PM</OPTION>");
			}		  
		}
		out.print("</SELECT> : "); 
		out.print("<SELECT NAME=\"Minute\">");
		out.print("<OPTION SELECTED VALUE=\"0\">00</OPTION>");
		for(int i=2;i<=60;i++){
			if(i<10){
				out.print("<OPTION VALUE=\""+i+"\">0"+i+"</OPTION>");			
			}
			else{			
				out.print("<OPTION VALUE=\""+i+"\">"+i+"</OPTION>");			
			}
		}
		out.print("</SELECT><p>");	   
		
		out.print("<SELECT NAME=\"Year\">");
		out.print("<OPTION SELECTED VALUE=\"2004\">2004</OPTION>");
		out.print("<OPTION VALUE=\"2005\">2005</OPTION>");
		out.print("</SELECT><p>");		
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">");
		out.print("</FORM>");		
		out.print("</TD></TR></TABLE><br>");
	}
	
	/**Do the queries to add an assignment to a course*/
	private void addedAssignment(PrintWriter out,HttpServletRequest req){
		String message="Assignment was successfully added to course.";
		NewAssignmentQuery naq=null;
		boolean success=true;
		Long coID=null;
		Long aID=null;
		Integer assignNum=null;
		try{
			coID=new Long(req.getParameter("courseID"));
			assignNum=new Integer(req.getParameter("AssignNum"));
			naq=new NewAssignmentQuery(coID,req.getParameter("NewAssignmentName"),new Integer(1),assignNum);
			int i=naq.execute();
			if(i==0){
				success=false;
				message="Could not add assignment to course.";
			}
			else{
				aID=naq.getLastInsertID();
			}
		}catch(NoConnectionException e){
			success=false;
			message="Connection error: "+e;
		}catch(NumberFormatException e){
			success=false;
			message="Invalid number format.  Please contact an administrator. Error:"+e;
		}catch(SQLException e){
			success=false;
			message="Database error: "+e;
		}
		
		if(success){
			try{
				//get the date and all that in order to add the draft structure
				Integer year=new Integer(req.getParameter("Year"));
				Integer day=new Integer(req.getParameter("Day"));
				Integer month=new Integer(req.getParameter("Month"));
				Integer hour=new Integer(req.getParameter("Hour"));
				Integer minute=new Integer(req.getParameter("Minute"));
				Calendar ca=Calendar.getInstance();
				ca.set(year.intValue(),month.intValue(),day.intValue(),hour.intValue(),minute.intValue(),0);
				java.util.Date da=ca.getTime();
				Timestamp dat=new Timestamp(da.getTime());
				String gt=req.getParameter("GradingType");
				String gradeType=null;
				if(gt.startsWith("Peer")){
					gradeType="Peer";
				}
				else{
					gradeType="Instructor";
				}
				NewDraftStructureQuery ndsq=new NewDraftStructureQuery(new Integer(1),aID,gradeType,dat);
				int i=ndsq.execute();
				if(i==0){
					success=false;
					message="Could not add draft structure to assignment. Please contact an administrator.";
				}  
				//if this draft is peer graded, create all of the writer as grader table entries
				if(success){ 
					WriterAsGraderCreator wagc=null;
					if(req.getParameter("GradingType").equals("PeerAll")){
						wagc=new WriterAsGraderCreator(coID,ndsq.getLastInsertID());
						boolean didwags=wagc.create();
						if(!didwags){
							success=false;
							message="Peer grading structure was not able to be created.";
						}
					}
					else if(req.getParameter("GradingType").equals("PeerRandom")){
						Long knum=new Long(req.getParameter("k"));
						wagc=new WriterAsGraderCreator(coID,ndsq.getLastInsertID(),knum);
						boolean didwags=wagc.create();
						if(!didwags){
							success=false;
							message="Peer grading structure was not able to be created.";
						}
					}
				}
			}catch(NoConnectionException e){
				success=false;
				message="Connection error: "+e;
			}catch(NumberFormatException e){
				success=false;
				message="Invalid number format.  Please contact an administrator. Error:"+e;
			}catch(SQLException e){
				success=false;
				message="Database error: "+e;
			}
		}
		
		if(success){
			//log in again so that the new data will be in the Grader object
			boolean login=this.reLogin(out,req);
			if(!login){
				success=false;
				message="Error in submitting new grader data.";
			}
		}   
		
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Center\">");
		//let the user know what has just happened
		out.print("<b>"+message+"</b><p>");
		if(success){
			out.print("<center><FORM NAME=\"ViewNew\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");			
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+aID+"\">");						
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"view\" VALUE=\"View Assignment\">");			
			out.print("</FORM></center>");
		}
		out.print("</TD></TR></TABLE><br>");		
	}
	
	//print out the screen that lets the grader edit assignment information
	private void editAssignment(PrintWriter out,HttpServletRequest req){
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Assignment assi=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			if(Long.toString(a.getAssignID()).equals(req.getParameter("assignID"))){
				assi=a;
			}
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("</FORM>");

		//and now for the data entry
		out.print("</TD><TD valign=\"Center\">");
		out.print("<FORM NAME=\"frmTheNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">"); 
		out.print("<br><b>Please enter the new name of the assignment:</b><p>");
		out.print("<INPUT TYPE=\"TEXT\" NAME=\"NewAssignmentName\"><p>");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"SUBMIT\" VALUE=\"Submit\" onClick=\"return confirmDelete()\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"editedAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"AssignNum\" VALUE=\""+(assignments.size()+1)+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+assi.getAssignID()+"\">");
		out.print("</TD></TR></TABLE><br>");		
	}
	
	/**Do the queries and whatnot to change the assignment, if it is allowed*/
	private void editedAssignment(PrintWriter out,HttpServletRequest req){
		String message="Assignment was successfully edited.";
		EditAssignmentQuery eaq=null;
		boolean success=true;
		Long coID=null;
		Long aID=null;
		try{
			coID=new Long(req.getParameter("courseID"));
			aID=new Long(req.getParameter("assignID"));
			eaq=new EditAssignmentQuery(aID,null,req.getParameter("NewAssignmentName"),null,null);
			int i=eaq.execute();
			if(i==0){
				success=false;
				message="Could not edit assignment.";
			}
		}catch(NoConnectionException e){
			success=false;
			message="Connection error: "+e;
		}catch(NumberFormatException e){
			success=false;
			message="Invalid number format.  Please contact an administrator. Error:"+e;
		}catch(SQLException e){
			success=false;
			message="Database error: "+e;
		}
				
		if(success){
			//log in again so that the new data will be in the Grader object
			boolean login=this.reLogin(out,req);
			if(!login){
				success=false;
				message="Error in submitting new grader data.";
			}
		}   
		
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Center\">");
		out.print("<b>"+message+"</b><p>");
		if(success){
			out.print("<center><FORM NAME=\"ViewNew\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");			
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+aID+"\">");						
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"view\" VALUE=\"View Assignment\">");			
			out.print("</FORM></center>");
		}
		out.print("</TD></TR></TABLE><br>");				
	}
	
	/**Queries and checks to delete an assignment
	 * An assignment cannot be deleted if a paper has been submitted for it
	 */
	private void deleteAssignment(PrintWriter out,HttpServletRequest req){
		String message="Assignment was successfully deleted.";
		DeleteQuery daq=null;
		DeleteQuery ddsq=null;
		GetPaperIDQuery gpidq=null;
		boolean success=true;
		Long aID=null;
		Vector vec=new Vector();
		try{
			aID=new Long(req.getParameter("assignID"));
			vec.add(aID);
			gpidq=new GetPaperIDQuery(null,null,null,null,null,null,null,null,null,null,null,vec,null,null);
			ResultSet rs=gpidq.execute();
			if(!rs.next()){
				daq=new DeleteQuery(vec,PackagingConstants.TABLE_assignment,PackagingConstants.LIMIT_grader);
				int i=daq.execute();
				if(i==0){
					success=false;
					message="Could not delete assignment.";
				}
			}
			else{
				success=false;
				message="Cannot delete an assignment if papers have been submitted for it already.";
			}
		}catch(NoConnectionException e){
			success=false;
			message="Connection error: "+e;
		}catch(NumberFormatException e){
			success=false;
			message="Invalid number format.  Please contact an administrator. Error:"+e;
		}catch(SQLException e){
			success=false;
			message="Database error: "+e;
		}finally{
			gpidq.free();
			if(daq!=null){
				daq.free();
			}
		}

		Vector dsIDs=new Vector();
		GetWriterAsGraderIDQuery gwagIDq=null;
		GetDraftStructureIDQuery gdsIDq=null;
		//if assignment is deleted, delete all of the draft structures that go with it				
		if(success){
			//aID will already be in a vector, provided that the previous operation succeeded
			try{
				gdsIDq=new GetDraftStructureIDQuery(null,vec,null,null);
				ResultSet rs=gdsIDq.execute();
				while(rs.next()){
					dsIDs.add(new Long(rs.getLong(1)));
				}
				
				gwagIDq=new GetWriterAsGraderIDQuery(dsIDs,null,null,null,null);
				Vector wagIDs=new Vector();
				rs=gwagIDq.execute();
				while(rs.next()){
					wagIDs.add(new Long(rs.getLong(1)));
				}
				if(wagIDs.size()>0){
					ddsq=new DeleteQuery(wagIDs,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_grader);
					int i=ddsq.execute();
					if(i==0){
						success=false;
						message="Could not delete assignment's peer grading entries.";
					}
				}
				
				ddsq=new DeleteQuery(dsIDs,PackagingConstants.TABLE_ds,PackagingConstants.LIMIT_grader);
				int i=ddsq.execute();
				if(i==0){
					success=false;
					message="Could not delete assignment's draft structures: ";
				}
			}catch(NoConnectionException e){
				success=false;
				message="Connection error: "+e;
			}catch(NumberFormatException e){
				success=false;
				message="Invalid number format.  Please contact an administrator. Error:"+e;
			}catch(SQLException e){
				success=false;
				message="Database error: "+e;
			}finally{
				gdsIDq.free();
				gwagIDq.free();
				if(ddsq!=null){
					ddsq.free();
				}
			}
		}
		
		//once again the check must be made to ensure that the changes have been made
		if(success){
			//log in again so that the new data will be in the Grader object
			boolean login=this.reLogin(out,req);
			if(!login){
				success=false;
				message="Error in submitting new grader data.";
			}
		}   
		
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></cnter>");
		Assignment a=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Center\">");
		out.print("<b>"+message+"</b><p>");
		out.print("</TD></TR></TABLE><br>");				
		
	}
	 
	/** Print the screen to allow the grader to edit a draft structure*/   
	private void addDS(PrintWriter out,HttpServletRequest req){
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Assignment assi=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			if(Long.toString(a.getAssignID()).equals(req.getParameter("assignID"))){
				assi=a;
			}
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"top\">");
		out.print("<b>Assignment Number "+assi.assignNum()+": "+assi.name()+"</b><p>");
		out.print("In course: "+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"<p>");
		out.print("<FORM NAME=\"frmEditA\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"editA\" VALUE=\"Edit Assignment\"><p>");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"editAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+req.getParameter("assignID")+"\">");
		out.print("</FORM>");
		
		out.print("<br><b>Draft Structures:</b><p><br>");
		Vector v=assi.getDraftStructure();
		DraftStructure ds=null;
		for(int j=0;j<v.size();j++){
			ds=(DraftStructure)v.elementAt(j);
			out.print("<b>Draft Number "+ds.getDraftNum()+"</b><p> Grading Type: "+ds.getGradingType()+"<p>");
			out.print("Due Date: "+ds.noChangeDate()+"<p>");
			out.print("<FORM NAME=\"frmTheDS"+j+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"ds"+j+"\" VALUE=\"Edit\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"editDS\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"draftStructureID\" VALUE=\""+Long.toString(ds.getDraftStructureID())+"\">");
			out.print("</FORM>");
			out.print("<FORM NAME=\"frmDS"+j+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"DS"+j+"\" VALUE=\"Delete\" onClick=\"return confirmDelete()\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"deleteDS\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"draftStructureID\" VALUE=\""+Long.toString(ds.getDraftStructureID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"numDrafts\" VALUE=\""+Integer.toString(assi.numDrafts())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}
		out.print("<FORM NAME=\"frmNewDS\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewDS\" VALUE=\"Add a Draft Structure\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addDS\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Top\">");
		out.print("<FORM NAME=\"frmTheNewDS\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">"); 
		out.print("<b>Add Draft Structure for Assignment "+assi.assignNum()+": "+assi.name()+"</b><p><br>");
		out.print("<b>Grading Type:</b><p>");
		out.print("<SELECT NAME=\"GradingType\">");
		out.print("<OPTION SELECTED VALUE=\"Instructor\">Instructor</OPTION>");
		out.print("<OPTION VALUE=\"PeerRandom\">Peer Review Random</OPTION>");
		out.print("<OPTION VALUE=\"PeerAll\">Peer Review All</OPTION>");		
		out.print("</SELECT><p><br>");

		//get the number of writers in a course and make that many entries for the list box
		GetWriterIDQuery gwq=null;
		try{
			Vector thisv=new Vector();
			thisv.add(new Long(c.getCourseID()));
			gwq=new GetWriterIDQuery(null,null,null,null,null,null,null,null,thisv,null);
			ResultSet rs=gwq.execute();
			int studnum=0;
			if(rs.next()){
				out.print("Number of graders per writer for peer review random:<p>");
				out.print("<SELECT NAME=\"k\">");
				out.print("<OPTION SELECTED VALUE=\"1\">1</OPTION>");
				studnum=2;
			}
			while(rs.next()){
				out.print("<OPTION VALUE=\""+studnum+"\">"+studnum+"</OPTION>");
				studnum++;
			}
			if(studnum>0){
				out.print("</SELECT><p><br>");
			}
		}catch(SQLException e){
			out.print("Database error: Error getting number of writers in course.");
		}finally{
			gwq.free();
		}
				
		out.print("<b>Turnin Date:</b><p>");
		out.print("<SELECT NAME=\"Month\">");
		out.print("<OPTION SELECTED VALUE=\"0\">January</OPTION>");
		out.print("<OPTION VALUE=\"1\">February</OPTION>");
		out.print("<OPTION VALUE=\"2\">March</OPTION>");		
		out.print("<OPTION VALUE=\"3\">April</OPTION>");
		out.print("<OPTION VALUE=\"4\">May</OPTION>");		
		out.print("<OPTION VALUE=\"5\">June</OPTION>");
		out.print("<OPTION VALUE=\"6\">July</OPTION>");		
		out.print("<OPTION VALUE=\"7\">August</OPTION>");
		out.print("<OPTION VALUE=\"8\">September</OPTION>");		
		out.print("<OPTION VALUE=\"9\">October</OPTION>");
		out.print("<OPTION VALUE=\"10\">November</OPTION>");		
		out.print("<OPTION VALUE=\"11\">December</OPTION>");
		out.print("</SELECT><p>");
		
		out.print("<SELECT NAME=\"Day\">");
		out.print("<OPTION SELECTED VALUE=\"1\">1</OPTION>");
		for(int i=2;i<=31;i++){
			out.print("<OPTION VALUE=\""+i+"\">"+i+"</OPTION>");			
		}
		out.print("</SELECT><p>");		

		out.print("<SELECT NAME=\"Hour\">");
		out.print("<OPTION SELECTED VALUE=\"0\">12 AM</OPTION>");
		for(int i=1;i<24;i++){
			if(i<12){
				out.print("<OPTION VALUE=\""+i+"\">"+i+" AM</OPTION>");
			}
			else if(i==12){
				out.print("<OPTION VALUE=\""+i+"\">"+i+" PM</OPTION>");
			}
			else{
				out.print("<OPTION VALUE=\""+i+"\">"+(i-12)+" PM</OPTION>");
			}		  
		}
		out.print("</SELECT> : "); 
		out.print("<SELECT NAME=\"Minute\">");
		out.print("<OPTION SELECTED VALUE=\"0\">00</OPTION>");
		for(int i=2;i<=60;i++){
			if(i<10){
				out.print("<OPTION VALUE=\""+i+"\">0"+i+"</OPTION>");			
			}
			else{			
				out.print("<OPTION VALUE=\""+i+"\">"+i+"</OPTION>");			
			}
		}
		out.print("</SELECT><p>");	   
		
		out.print("<SELECT NAME=\"Year\">");
		out.print("<OPTION SELECTED VALUE=\"2004\">2004</OPTION>");
		out.print("<OPTION VALUE=\"2005\">2005</OPTION>");
		out.print("</SELECT><p>");		
		
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addedDS\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+req.getParameter("assignID")+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"numDrafts\" VALUE=\""+Integer.toString(assi.numDrafts())+"\">");
		out.print("</FORM>");		
		out.print("</TD></TR></TABLE><br>");				
	}

	/**Queries and whatnot to add a draft structure*/
	private void addedDS(PrintWriter out,HttpServletRequest req){
		String message="Draft Structure was successfully added to assignment.";
		boolean success=true;
		Integer numDrafts=null;
		Long coID=null;
		Long aID=null;
		Long dsID=null;
		try{
			coID=new Long(req.getParameter("courseID"));
			aID=new Long(req.getParameter("assignID"));
		}catch(NumberFormatException e){
			success=false;
			message="Invalid number format.  Please contact an administrator. Error:"+e;
		}
		
		NewDraftStructureQuery ndsq=null;

		//do all the date calculations
		try{
			numDrafts=new Integer(req.getParameter("numDrafts"));
			int nd=numDrafts.intValue();
			nd++;
			numDrafts=new Integer(nd);
			Integer year=new Integer(req.getParameter("Year"));
			Integer day=new Integer(req.getParameter("Day"));
			Integer month=new Integer(req.getParameter("Month"));
			Integer hour=new Integer(req.getParameter("Hour"));
			Integer minute=new Integer(req.getParameter("Minute"));
			Calendar ca=Calendar.getInstance();
			ca.set(year.intValue(),month.intValue(),day.intValue(),hour.intValue(),minute.intValue(),0);
			java.util.Date da=ca.getTime();
			Timestamp dat=new Timestamp(da.getTime());
			String gt=req.getParameter("GradingType");
			String gradeType=null;
			if(gt.startsWith("Peer")){
				gradeType="Peer";
			}
			else{
				gradeType="Instructor";
			}
			ndsq=new NewDraftStructureQuery(numDrafts,aID,gradeType,dat);
			int i=ndsq.execute();
			if(i==0){
				success=false;
				message="Could not add draft structure to assignment.";
			}
			//create writer as grader entries if this is a peer graded draft
			if(success){
				//get the dsid for later
				dsID=ndsq.getLastInsertID();
				WriterAsGraderCreator wagc=null;
				boolean didwags=true;
				if(req.getParameter("GradingType").equals("PeerAll")){
					wagc=new WriterAsGraderCreator(coID,ndsq.getLastInsertID());
					didwags=wagc.create();
				}
				else if(req.getParameter("GradingType").equals("PeerRandom")){
					Long knum=new Long(req.getParameter("k"));
					wagc=new WriterAsGraderCreator(coID,ndsq.getLastInsertID(),knum);
					didwags=wagc.create();
				}
				if(!didwags){
					success=false;
					message="Peer grading structure was not able to be created.";
				}
			}
		}catch(NoConnectionException e){
			success=false;
			message="Connection error: "+e;
		}catch(NumberFormatException e){
			success=false;
			message="Invalid number format.  Please contact an administrator. Error:"+e;
		}catch(SQLException e){
			success=false;
			message="Database error: "+e;
		}

		//check if any drafts have been submitted for this draft structure before it was created
		//if so, give them the proper dsID
		//first, get the paperIDs of the papers in this assignment
		Vector vec=new Vector();
		GetPaperIDQuery gpidq=null;
		Vector pIDs=new Vector();
		try{
			vec.add(aID);
			gpidq=new GetPaperIDQuery(null,null,null,null,null,null,null,null,null,null,null,vec,null,null);
			ResultSet rs=gpidq.execute();
			while(rs.next()){
				pIDs.add(new Long(rs.getLong(1)));
			}
		}catch(SQLException e){			
			success=false;
			message="A database error has occurred when trying to determine if drafts already exist.";
		}finally{
			gpidq.free();
		}
		
		//next, see if any from among those papers have the same draftNum as this draftStructure
		GetDraftIDQuery gdidq=new GetDraftIDQuery(pIDs,numDrafts,null,null,null,null,null);
		try{
			ResultSet rs=gdidq.execute();
			EditDraftQuery edq=null;
			while(rs.next()){
				//if so, edit them
				try{
					edq=new EditDraftQuery(new Long(rs.getLong(1)),null,null,null,null,dsID,null);
					int p=edq.execute();
					if(p==0){
						success=false;
						message="Draft structure has been created, but existing drafts for this draft structure have not been modified.";
					}
				}catch(SQLException e){			
					success=false;
					message="A database error has occurred when trying to edit existing drafts.";
				}catch(NumberFormatException e){
					success=false;
					message="A number format error has occurred when trying to edit existing drafts.  Please notify an administrator.";
				}
			}
		}catch(SQLException e){			
			success=false;
			message="A database error has occurred when trying to determine if drafts already exist.";
		}catch(NumberFormatException e){
			success=false;
			message="A number format error has occurred when trying to determine if drafts already exist.  Please notify an administrator.";
		}finally{
			gdidq.free();
		}
				
		//edit the assignment to reflect the changes to the number of drafts
		EditAssignmentQuery eaq=null;
		try{
			eaq=new EditAssignmentQuery(aID,null,null,numDrafts,null);
			int i=eaq.execute();
			if(i==0){
				success=false;
				message="Could not add draft structure to assignment.";
			}
		}catch(NoConnectionException e){
			success=false;
			message="Connection error: "+e;
		}catch(NumberFormatException e){
			success=false;
			message="Invalid number format.  Please contact an administrator. Error:"+e;
		}catch(SQLException e){
			success=false;
			message="Database error: "+e;
		}
		
		if(success){
			//log in again so that the new data will be in the Grader object
			boolean login=this.reLogin(out,req);
			if(!login){
				success=false;
				message="Error in submitting new grader data.";
			}
		}   
		
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Center\">");
		out.print("<b>"+message+"</b><p>");
		if(success){
			out.print("<center><FORM NAME=\"ViewNew\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");			
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+aID+"\">");						
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"view\" VALUE=\"View Assignment\">");			
			out.print("</FORM></center>");
		}
		out.print("</TD></TR></TABLE><br>");		
		
	}
				
	/**print the screen to edit a draft structure*/
	private void editDS(PrintWriter out,HttpServletRequest req){
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Assignment assi=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			if(Long.toString(a.getAssignID()).equals(req.getParameter("assignID"))){
				assi=a;
			}
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"top\">");
		out.print("<b>Assignment Number "+assi.assignNum()+": "+assi.name()+"</b><p>");
		out.print("In course: "+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"<p>");
		out.print("<FORM NAME=\"frmEditA\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"editA\" VALUE=\"Edit Assignment\"><p>");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"editAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+req.getParameter("assignID")+"\">");
		out.print("</FORM>");
		
		out.print("<br><b>Draft Structures:</b><p><br>");
		Vector v=assi.getDraftStructure();
		DraftStructure ds=null;
		DraftStructure dst=null;
		for(int j=0;j<v.size();j++){
			ds=(DraftStructure)v.elementAt(j);
			if(Long.toString(ds.getDraftStructureID()).equals(req.getParameter("draftStructureID"))){
				dst=ds;
			}
			out.print("<b>Draft Number "+ds.getDraftNum()+"</b><p> Grading Type: "+ds.getGradingType()+"<p>");
			out.print("Due Date: "+ds.noChangeDate()+"<p>");
			out.print("<FORM NAME=\"frmTheDS"+j+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"ds"+j+"\" VALUE=\"Edit\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"editDS\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"draftStructureID\" VALUE=\""+Long.toString(ds.getDraftStructureID())+"\">");
			out.print("</FORM>");
			out.print("<FORM NAME=\"frmDS"+j+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"DS"+j+"\" VALUE=\"Delete\" onClick=\"return confirmDelete()\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"deleteDS\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"draftStructureID\" VALUE=\""+Long.toString(ds.getDraftStructureID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"numDrafts\" VALUE=\""+Integer.toString(assi.numDrafts())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}
		out.print("<FORM NAME=\"frmNewDS\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewDS\" VALUE=\"Add a Draft Structure\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addDS\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(assi.getAssignID())+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Top\">");
		out.print("<FORM NAME=\"frmTheNewDS\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">"); 
		out.print("<b>Edit Draft "+dst.getDraftNum()+" for Assignment "+assi.assignNum()+": "+assi.name()+"</b><p><br>");
		out.print("<b>Grading Type:</b><p>");
		out.print("<SELECT NAME=\"GradingType\">");
		out.print("<OPTION SELECTED VALUE=\"Instructor\">Instructor</OPTION>");
		out.print("<OPTION VALUE=\"PeerRandom\">Peer Review Random</OPTION>");
		out.print("<OPTION VALUE=\"PeerAll\">Peer Review All</OPTION>");		
		out.print("</SELECT><p><br>");
		
		//make enough entries in the "k" list to allow the same effect as peer review all
		GetWriterIDQuery gwq=null;
		try{
			Vector thisv=new Vector();
			thisv.add(new Long(c.getCourseID()));
			gwq=new GetWriterIDQuery(null,null,null,null,null,null,null,null,thisv,null);
			ResultSet rs=gwq.execute();
			int studnum=0;
			if(rs.next()){
				out.print("Number of graders per writer for peer review random:<p>");
				out.print("<SELECT NAME=\"k\">");
				out.print("<OPTION SELECTED VALUE=\"1\">1</OPTION>");
				studnum=2;
			}
			while(rs.next()){
				out.print("<OPTION VALUE=\""+studnum+"\">"+studnum+"</OPTION>");
				studnum++;
			}
			if(studnum>0){
				out.print("</SELECT><p><br>");
			}
		}catch(SQLException e){
			out.print("Database error: Error getting number of writers in course.");
		}finally{
			gwq.free();
		}

		out.print("<b>Turnin Date:</b><p>");
		out.print("<SELECT NAME=\"Month\">");
		out.print("<OPTION SELECTED VALUE=\"0\">January</OPTION>");
		out.print("<OPTION VALUE=\"1\">February</OPTION>");
		out.print("<OPTION VALUE=\"2\">March</OPTION>");		
		out.print("<OPTION VALUE=\"3\">April</OPTION>");
		out.print("<OPTION VALUE=\"4\">May</OPTION>");		
		out.print("<OPTION VALUE=\"5\">June</OPTION>");
		out.print("<OPTION VALUE=\"6\">July</OPTION>");		
		out.print("<OPTION VALUE=\"7\">August</OPTION>");
		out.print("<OPTION VALUE=\"8\">September</OPTION>");		
		out.print("<OPTION VALUE=\"9\">October</OPTION>");
		out.print("<OPTION VALUE=\"10\">November</OPTION>");		
		out.print("<OPTION VALUE=\"11\">December</OPTION>");
		out.print("</SELECT><p>");
		
		out.print("<SELECT NAME=\"Day\">");
		out.print("<OPTION SELECTED VALUE=\"1\">1</OPTION>");
		for(int i=2;i<=31;i++){
			out.print("<OPTION VALUE=\""+i+"\">"+i+"</OPTION>");			
		}
		out.print("</SELECT><p>");		

		out.print("<SELECT NAME=\"Hour\">");
		out.print("<OPTION SELECTED VALUE=\"0\">12 AM</OPTION>");
		for(int i=1;i<24;i++){
			if(i<12){
				out.print("<OPTION VALUE=\""+i+"\">"+i+" AM</OPTION>");
			}
			else if(i==12){
				out.print("<OPTION VALUE=\""+i+"\">"+i+" PM</OPTION>");
			}
			else{
				out.print("<OPTION VALUE=\""+i+"\">"+(i-12)+" PM</OPTION>");
			}		  
		}
		out.print("</SELECT> : "); 
		out.print("<SELECT NAME=\"Minute\">");
		out.print("<OPTION SELECTED VALUE=\"0\">00</OPTION>");
		for(int i=2;i<=60;i++){
			if(i<10){
				out.print("<OPTION VALUE=\""+i+"\">0"+i+"</OPTION>");			
			}
			else{			
				out.print("<OPTION VALUE=\""+i+"\">"+i+"</OPTION>");			
			}
		}
		out.print("</SELECT><p>");	   
		
		out.print("<SELECT NAME=\"Year\">");
		out.print("<OPTION SELECTED VALUE=\"2004\">2004</OPTION>");
		out.print("<OPTION VALUE=\"2005\">2005</OPTION>");
		out.print("</SELECT><p>");		
		
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\" onClick=\"return confirmDelete()\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"editedDS\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+req.getParameter("assignID")+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"numDrafts\" VALUE=\""+Integer.toString(assi.numDrafts())+"\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"draftStructureID\" VALUE=\""+req.getParameter("draftStructureID")+"\">");
		out.print("</FORM>");		
		out.print("</TD></TR></TABLE><br>");						
	}

	/**
	 * queries for editing a draft structure
	 * draft structures cannot be changed if drafts have been submitted for them
	 */
	private void editedDS(PrintWriter out,HttpServletRequest req){
		String message="Draft Structure was successfully edited.";
		boolean success=true;
		Integer numDrafts=null;
		Long aID=null;
		Long dsID=null;
		GetDraftIDQuery gdidq=null;
		//check and make sure no drafts exist with this dsid
		try{
			aID=new Long(req.getParameter("assignID"));
			Vector dvec=new Vector();
			dsID=new Long(req.getParameter("draftStructureID"));
			dvec.add(dsID);
			gdidq=new GetDraftIDQuery(null,null,null,null,null,dvec,null);
			ResultSet rs=gdidq.execute();
			if(rs.next()){
				success=false;
				message="Cannot change a draft structure if papers have been submitted for it already.";
			}
		}catch(NumberFormatException e){
			success=false;
			message="Invalid number format.  Please contact an administrator. Error:"+e;
		}catch(SQLException e){
			success=false;
			message="Database error.  Could not determine if draft structure could be edited.";
		}finally{
			gdidq.free();
		}
		
		if(success){
			EditDraftStructureQuery edsq=null;
			GetWriterAsGraderIDQuery gwagIDq=null;
			DeleteQuery ddsq=null;
			try{
				numDrafts=new Integer(req.getParameter("numDrafts"));
				int nd=numDrafts.intValue();
				nd++;
				numDrafts=new Integer(nd);
				Integer year=new Integer(req.getParameter("Year"));
				Integer day=new Integer(req.getParameter("Day"));
				Integer month=new Integer(req.getParameter("Month"));
				Integer hour=new Integer(req.getParameter("Hour"));
				Integer minute=new Integer(req.getParameter("Minute"));
				Calendar ca=Calendar.getInstance();
				ca.set(year.intValue(),month.intValue(),day.intValue(),hour.intValue(),minute.intValue(),0);
				java.util.Date da=ca.getTime();
				Timestamp dat=new Timestamp(da.getTime());
				String gt=req.getParameter("GradingType");
				String gradeType=null;
				if(gt.startsWith("Peer")){
					gradeType="Peer";
				}
				else{
					gradeType="Instructor";
				}
				edsq=new EditDraftStructureQuery(dsID,null,null,gradeType,dat);
				int i=edsq.execute();
				if(i==0){
					success=false;
					message="Could not add draft structure to assignment.";
				}
				
				//delete old peer grading entries when editing an assignment
				Vector dsIDs=new Vector();
				dsIDs.add(dsID);
				gwagIDq=new GetWriterAsGraderIDQuery(dsIDs,null,null,null,null); 
				Vector wagIDs=new Vector();
				ResultSet rs=gwagIDq.execute();
				while(rs.next()){
					wagIDs.add(new Long(rs.getLong(1)));
				}
				if(wagIDs.size()>0){
					ddsq=new DeleteQuery(wagIDs,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_grader);
					int m=ddsq.execute();
					if(m==0){
						success=false;
						message="Could not delete assignment's peer grading entries.";
					}
				}

				
				//assign peer graders
				if(success){
					WriterAsGraderCreator wagc=null;
					if(req.getParameter("GradingType").equals("PeerAll")){
						wagc=new WriterAsGraderCreator(new Long(req.getParameter("courseID")),dsID);
						boolean didwags=wagc.create();
						if(!didwags){
							success=false;
							message="Peer grading structure was not able to be created.";
						}
					}
					else if(req.getParameter("GradingType").equals("PeerRandom")){
						Long knum=new Long(req.getParameter("k"));
						wagc=new WriterAsGraderCreator(new Long(req.getParameter("courseID")),dsID,knum);
						boolean didwags=wagc.create();
						if(!didwags){
							success=false;
							message="Peer grading structure was not able to be created.";
						}
					}
				}
			}catch(NoConnectionException e){
				success=false;
				message="Connection error: "+e;
			}catch(NumberFormatException e){
				success=false;
				message="Invalid number format.  Please contact an administrator. Error:"+e;
			}catch(SQLException e){
				success=false;
				message="Database error: "+e;
			}finally{
				gwagIDq.free();
				if(ddsq!=null){
					ddsq.free();
				}
			}
		}
		
		if(success){
			//log in again so that the new data will be in the Grader object
			boolean login=this.reLogin(out,req);
			if(!login){
				success=false;
				message="Error in submitting new grader data.";
			}
		}   
		
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Center\">");
		out.print("<b>"+message+"</b><p>");
		if(success){
			out.print("<center><FORM NAME=\"ViewNew\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");			
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+aID+"\">");						
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"view\" VALUE=\"View Assignment\">");			
			out.print("</FORM></center>");
		}
		out.print("</TD></TR></TABLE><br>");				
	}

	private void deleteDS(PrintWriter out,HttpServletRequest req){
		String message="Draft Structure was successfully deleted.";
		boolean success=true;
		Integer numDrafts=null;
		Long coID=null;
		Long aID=null;
		Long dsID=null;
		try{
			coID=new Long(req.getParameter("courseID"));
			aID=new Long(req.getParameter("assignID"));
			dsID=new Long(req.getParameter("draftStructureID"));
		}catch(NumberFormatException e){
			success=false;
			message="Invalid number format.  Please contact an administrator. Error:"+e;
		}
		
		//an assignment has to have a draft structure, so don't delete this ds if it is the last one
		if(success){
			GetDraftStructureIDQuery gdsidq=null;
			try{
				Vector av=new Vector();
				av.add(aID);
				gdsidq=new GetDraftStructureIDQuery(null,av,null,null);
				ResultSet rs=gdsidq.execute();
				int count=0;
				while(rs.next()){
					count++;
				}
				if(count==1){
					success=false;
					message="Cannot delete last draft structure in an assignment.  <p>To remove this draft structure, please delete the assignment.";
				}
			}catch(SQLException e){
				success=false;
				message="Database error has occurred when determining eligibility for deletion.";
			}finally{
				if(gdsidq!=null){
					gdsidq.free();
				}
			}
		}
		
		//if this isnt the last draft structure and nothing else has gotten screwed up so far, delete the ds
		if(success){
			Vector vec=new Vector();
			vec.add(dsID);
			DeleteQuery ddsq=null;
			GetWriterAsGraderIDQuery gwagIDq=null;
	
			try{
				ddsq=new DeleteQuery(vec,PackagingConstants.TABLE_ds,PackagingConstants.LIMIT_grader);
				int i=ddsq.execute();
				if(i==0){
					success=false;
					message="Could not delete draft structure.";
				}
				
				//delete old peer grading entries when deleting a draft structure
				Vector dsIDs=new Vector();
				dsIDs.add(dsID);
				gwagIDq=new GetWriterAsGraderIDQuery(dsIDs,null,null,null,null); 
				Vector wagIDs=new Vector();
				ResultSet rs=gwagIDq.execute();
				while(rs.next()){
					wagIDs.add(new Long(rs.getLong(1)));
				}
				if(wagIDs.size()>0){
					ddsq=new DeleteQuery(wagIDs,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_grader);
					int m=ddsq.execute();
					if(m==0){
						success=false;
						message="Could not delete assignment's peer grading entries.";
					}
				}
			}catch(NoConnectionException e){
				success=false;
				message="Connection error: "+e;
			}catch(NumberFormatException e){
				success=false;
				message="Invalid number format.  Please contact an administrator. Error:"+e;
			}catch(SQLException e){
				success=false;
				message="Database error: "+e;
			}finally{
				ddsq.free();
				gwagIDq.free();
			}
		}

		int nds=-2;
		int dn=-1;
		if(success){
			//try to find out if this is the last draft structure
			try{
				numDrafts=new Integer(req.getParameter("numDrafts"));
				Integer draftNum=new Integer(req.getParameter("draftNum"));
				nds=numDrafts.intValue();
				dn=draftNum.intValue();
			}catch(NumberFormatException e){
				success=false;
				message="Could not determine number of drafts in assignment or draft number.";
			}
		}
						
		if(success && nds==dn){
			//if this is the last draft structure, decrement the number of drafts in the assignment
			EditAssignmentQuery eaq=null;
			try{
				int nd=numDrafts.intValue();
				nd--;
				numDrafts=new Integer(nd);
				eaq=new EditAssignmentQuery(aID,null,null,numDrafts,null);
				int i=eaq.execute();
				if(i==0){
					success=false;
					message="Could not edit number of drafts in assignment.";
				}
			}catch(NoConnectionException e){
				success=false;
				message="Connection error: "+e;
			}catch(NumberFormatException e){
				success=false;
				message="Invalid number format.  Please contact an administrator. Error:"+e;
			}catch(SQLException e){
				success=false;
				message="Database error: "+e;
			}
		}

		if(success){
			//log in again so that the new data will be in the Grader object
			boolean login=this.reLogin(out,req);
			if(!login){
				success=false;
				message="Error in submitting new grader data.";
			}
		}   
		
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			out.print("<FORM NAME=\"frmTheAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Center\">");
		out.print("<b>"+message+"</b><p>");
		if(success){
			out.print("<center><FORM NAME=\"ViewNew\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+cID+"\">");			
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+aID+"\">");						
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"view\" VALUE=\"View Assignment\">");			
			out.print("</FORM></center>");
		}
		out.print("</TD></TR></TABLE><br>");				
	}

	/*Check out and download from the web previously not supported*/
	private byte[] doCheckout(HttpServletRequest req){
		Properties p=new Properties();
		p.put("paperID",req.getParameter("paperID"));
		p.put("graderID",Long.toString(gID.getGraderID()));
		PackagePaper pp=new PackagePaper(TransmissionConstants.checkOutPaper,req,PackagingConstants.LIMIT_grader,null,p,null);
		return pp.execute(false);
	}

	/*Set up the screen as a table*/
	private void doTables(PrintWriter out, HttpServletRequest req){
		out.print("<TABLE border=\"2\" cellspacing=\"5\" cellpadding=\"10\"><TR><TD><IMG SRC=\""+TransmissionConstants.logoFileLocation+"\">");
		out.print("</TD><TD>");
		out.print("<h3>Blaise Account<p>");
		out.print("User: "+gID.getUserName()+"<p>Date: "+new java.util.Date());
		out.print("<p>Blaise User since: "+gID.getCreationDate()+"</h3>");
		out.print("</TD></TR><TR><TD valign=\"TOP\" halign=\"CENTER\">");
	}
	
	/*Log in the user*/
	private boolean doLogin(PrintWriter out,HttpServletRequest req){
		userName=req.getParameter("userName");
		password=req.getParameter("password");
		uID=req.getParameter("universityID");
				
		//try to log in.  if it fails, send out the message to the user.
		glq=TransmissionHandler.getGraderLogin(userName,password,uID);
		boolean b=glq.transmit();
		if(!b){
			return false;
		}
		
		gID=glq.getGrader();
		if(gID==null){
			return false;
		}
		
		return true;
	}

	/*refreshes the user after changes have been made*/
	private boolean reLogin(PrintWriter out,HttpServletRequest req){
		//try to log in.  if it fails, send out the message to the user.
		glq=TransmissionHandler.getGraderLogin(userName,password,uID);
		boolean b=glq.transmit();
		if(!b){
			return false;
		}
		
		gID=glq.getGrader();
		if(gID==null){
			return false;
		}
		
		return true;
	}
	
	/*print the welcome screen*/
	private void welcomeScreen(PrintWriter out, HttpServletRequest req){
		//print out the welcome screen stuff, there may be more to come		
		out.print("<center><h3>Hello, "+gID.getFirstName()+" "+gID.getLastName()+"!</h3><p>");
		out.print("Welcome to your blaise account.<p>");
		out.print("Please click on a course.<br>");
		
	}
		
	/*Get this grader's courses*/
	private void getCourses(PrintWriter out,HttpServletRequest req){
		Vector courses=glq.getCourses();
		Course c=null;
		out.print("<h4>Your Current Courses:</h4>");
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			out.print("<FORM NAME=\"frm"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doCourse\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
			out.print("<INPUT TYPE=\"submit\" NAME=\"courseName\" VALUE=\""+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"\">");
			out.print("</FORM>");
			out.print("<p>");
		}
		
		Vector pastCourses=glq.getPastCourses();
		out.print("<h4>Your Past Courses:</h4>");
		for(int i=0;i<pastCourses.size();i++){
			c=(Course)pastCourses.elementAt(i);
			out.print("<FORM NAME=\"frm"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doCourse\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
			out.print("<INPUT TYPE=\"submit\" NAME=\"courseName\" VALUE=\""+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"\">");
			out.print("</FORM>");
			out.print("<p>");
		}
	}
	
	/*Print out the info for this course: assignments, announcements, etc.*/
	private void doCourse(PrintWriter out,HttpServletRequest req){		
		String cID=req.getParameter("courseID");
		Vector courses=glq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE border=\"1\"><TR><TD valign=\"top\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		Assignment a=null;
		Vector assignments=c.getAssignments();
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			out.print("<FORM NAME=\"frmNewAssign"+i+"\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
			out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"assign"+i+"\" VALUE=\""+a.assignNum()+": "+a.name()+"\"><p>");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doAssignment\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"assignID\" VALUE=\""+Long.toString(a.getAssignID())+"\">");
			out.print("</FORM>");
			out.print("<br>");
		}		

		out.print("<FORM NAME=\"frmNewAssign\" METHOD=\"POST\" ACTION=\"GraderWebAccess\">");
		out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"NewAssignment\" VALUE=\"Add an Assignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"addAssignment\">");
		out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
		out.print("</FORM>");

		out.print("</TD><TD valign=\"Center\">");
		out.print("<h3>Please select an assignment.</h3>");
		out.print("</TD></TR></TABLE><br>");
		
		//display general announcements, somehow
		out.print("<center><h4>Announcements:</h4></center>");
	}	
	
	/*the html header information*/
	private void printHeaderInfo(PrintWriter out,HttpServletRequest req){
		//may want this to have more information, such as have the section of the site listed in the title bar
		out.print("<HTML><HEAD><TITLE>Blaise Grader Web Access</TITLE>");
		out.print("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"cssSheet.css\" TITLE=\"Default\"></HEAD><BODY>");
	}

	/*the html footer information*/	
	private void printFooterInfo(PrintWriter out,HttpServletRequest req){
		out.print("</BODY></HTML>");
	}
	
	/////////////////////////////////////////////////////////////
	//
	// edu.gwu.servlets required methods
	//
	/////////////////////////////////////////////////////////////
  
	public void shutdown ()
	{
		// Nothing to be done.
		return;
	}
	
	public void reset ()
	{
		// Nothing to be done.
		return;
	}
	
	public void save ()
	{
		// Nothing to be done.
		return;
	}
	
	public void test (PrintWriter out)
	{
		out.print ("<p> GraderWebAccess.test: successful </p>");
	}
}
