package edu.gwu.blaise.version2.backend.webaccess;
import edu.gwu.servlets.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import edu.gwu.blaise.version2.transmission.*;
import edu.gwu.blaise.version2.documents.*;
import edu.gwu.blaise.version2.backend.packagers.*;
import edu.gwu.blaise.version2.backend.queries.*;
import java.sql.*;

public class StudentBean implements Serializable{
	private WriterLoginQuery wlq;
	private edu.gwu.blaise.version2.transmission.Writer wID;
	private Vector courses, oldCourses;
	private StringBuffer strbuf=new StringBuffer();
	
	boolean didLogin=true;
	String userName;
	String password;
	String uID;
	String cID;
	String univID;
	CourseBean[] currentCourses;
	CourseBean[] pastCourses;

	public void setUserName(String userName){
		this.userName=userName;
	}
	
	public void setUID(String uID){
		this.uID=uID;
	}

	public void setUnivID(String univID){
		this.univID=univID;
	}

	public String getUnivID(){
		return univID;
	}
	
	public void setPassword(String password){
		didLogin=true;
		this.password=password;
		
		//need to get the userID
		Integer in;
		try{
			in=new Integer(univID);
			Vector v=new Vector();
			v.add(in);
			GetWriterIDQuery gwidq=new GetWriterIDQuery(v, null, null, null, userName, null, null, null, null, null);
			ResultSet rs=gwidq.execute();
			if(rs.next()){
				this.uID=new String(""+rs.getInt(1));
			}else{
				didLogin=false;
				return;
			}
		}catch(Exception e){
			strbuf.append("Database Error: "+e);
			didLogin=false;
			return;
		}
				
		//now that we have the user name, university ID and password, get the writer object
		//try to log in.  if it fails, set success variable to false
		wlq=TransmissionHandler.getWriterLogin(userName,password,uID);
		boolean b=wlq.transmit();
		if(!b){
			didLogin=false;
			return;
		}
		
		wID=wlq.getWriter();
		if(wID==null){
			didLogin=false;
			return;
		}		
		
		courses=wlq.getCourses();
		oldCourses=wlq.getPastCourses();
		
		currentCourses=new CourseBean[courses.size()];
		pastCourses=new CourseBean[oldCourses.size()];
		
		CourseBean cb;
		for(int i=0;i<courses.size();i++){
			cb=this.populateCourseBean((Course)courses.elementAt(i));
			currentCourses[i]=cb;
		}
		for(int i=0;i<oldCourses.size();i++){
			cb=this.populateCourseBean((Course)oldCourses.elementAt(i));
			pastCourses[i]=cb;
		}
	}
	
	//getter methods for student info, including currentCourses and pastCourses
	public java.util.Date getCreationDate(){
		return wID.getCreationDate();
	}
	
	public String getUserName(){
		return userName;
	}
	
	public CourseBean[] getCurrentCourses(){
		return currentCourses;
	}
	
	public CourseBean[] getPastCourses(){
		return pastCourses;
	}
	
	public String getErrors(){
		return strbuf.toString();
	}

	public String getUID(){
		return uID;
	}
	
	public boolean getIsError(){
		if(strbuf.length()==0){
			return false;
		}
		return true;
	}
	
	public boolean getDidLogin(){
		return didLogin;
	}
		
	//code for this more or less lifted straight from the old servlet code
	private CourseBean populateCourseBean(Course c){
		//get the assignment info, and display it
		
		Assignment a=null;
		Vector assignments=c.getAssignments();
		Vector asi=null;
		Vector pap=null;
		Blaise_Draft bd=null;
		Blaise_Comment bc=null;
		Blaise_Paper blp=null;
		Vector comments=null;
		PaperSearchQuery ps;
		boolean ex;
		AssignmentBean ab=null;
		CourseBean cb=new CourseBean();
		AssignmentBean[] AssignmentBeans =new AssignmentBean[assignments.size()];
		DraftStructureBean[] DraftStructureBeans=null;
		DraftStructureBean dsb=null;
		String[] gradedFNames=null;
		String[] gradedLNames=null;
		String[] ungradedFNames=null;		
		String[] ungradedLNames=null;
		int n;
		
		//set basic attributes of this CourseBean
		cb.setDeptName(c.getDept());
		cb.setCourseNum(c.getNumber());
		cb.setSectNum(c.getSection());
		
		for(int i=0;i<assignments.size();i++){
			ab=new AssignmentBean();
			a=(Assignment)assignments.elementAt(i);
			asi=new Vector();
			asi.add(new Long(a.getAssignID()));
			ps=TransmissionHandler.getPaperSearch(false,wID.getLastName(),wID.getStudentIdent(),wID.getEmail(),c,TransmissionHandler.WRITER_TYPE,null,asi,null);
			ex=ps.transmit();
			if(ex){
				pap=ps.getPapers();
				//pap can only have one paper
				if(pap.size()==1){
					//print out the peer grading status
					blp=(Blaise_Paper)pap.firstElement();
					Vector idvec=new Vector();
					idvec.add(new Long(blp.getPaperID()));
					GetQuery gq=new GetQuery(idvec,PackagingConstants.TABLE_paper,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
					String hbd=null;
					try{
						ResultSet result=gq.execute();
						if(result.next()){
							hbd=result.getString("hasBeenDownloaded");
						}
					}catch(SQLException e){
						strbuf.append("An error has occurred in getting the status of this paper.");
					}finally{
						gq.free();
					}
					if(hbd.equals("Y")){
						ab.setHasBeenDownloaded(true);
					}else{
						ab.setHasBeenDownloaded(false);
					}
						
					//put in some stats about each draft
					Vector dss=a.getDraftStructure();
					DraftStructureBeans=new DraftStructureBean[dss.size()];
					java.util.Date utilDate=null;
					DraftStructure d=null;
					for(int j=0;j<dss.size();j++){
						d=(DraftStructure)dss.elementAt(j);
						dsb=new DraftStructureBean();
						dsb.setNoChangeDate(d.noChangeDate());
						dsb.setDraftNum(d.getDraftNum());
						DraftStructureBeans[j]=dsb;
//grading type?
					} 
/*					out.print("<FORM NAME=\"frmDL\" METHOD=\"POST\" ACTION=\"StudentWebAccess\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"command\" value=\"doDownload\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"paperID\" value=\""+blp.getPaperID()+"\">");
					out.print("<INPUT TYPE=\"submit\" name=\"Download\" value=\"Download this paper\"><p>");
					out.print("</FORM>");					
*/
				}
				else if(pap.size()==0){
						
					//put in some stats about each draft
					Vector dss=a.getDraftStructure();
					DraftStructureBeans=new DraftStructureBean[dss.size()];
					java.util.Date utilDate=null;
					DraftStructure d=null;
					for(int j=0;j<dss.size();j++){
						d=(DraftStructure)dss.elementAt(j);
						dsb=new DraftStructureBean();
						dsb.setNoChangeDate(d.noChangeDate());
						dsb.setDraftNum(d.getDraftNum());
						DraftStructureBeans[j]=dsb;
					} 
					strbuf.append("No paper has been submitted for this assignment yet.");
				}
				else{
					strbuf.append("A formatting error has occurred when getting the paper for "+a.assignNum()+": "+a.name());
					strbuf.append(".  Please contact an administrator.");
				}
				
				//equivalent to a call to printStatus - may want to use this instead of the above
				//code included in the first else clause
				if(pap.size()==0 || pap.size()==1){
					ab.setDraftStructures(DraftStructureBeans);					
					
					Vector vect=new Vector();
					Vector vecto=new Vector();
					GetWriterAsGraderIDQuery gwagIDQ=null;		
					GetQuery gwagq=null;
					long wagID;
					long writerID;
					Vector vw=new Vector();
					Vector w=new Vector();
					Vector v=new Vector();
					ResultSet rs=null;
					long dsID;
					Vector vec=new Vector();
					GetDraftStructureIDQuery gdsIDQ=null;
					boolean printStatus=true;
			
					//get the dsids for peer grading in this assignment		
					try{
						v.add(new Long(a.getAssignID()));
						gdsIDQ=new GetDraftStructureIDQuery(null,v,"Peer",null);
						rs=gdsIDQ.execute();	
						while(rs.next()){
							dsID=rs.getLong(1);
							vec.add(new Long(dsID));
						}
					}catch(SQLException e){
						strbuf.append("A database error has occurred when getting the drafts: "+e);
						return null;
					}finally{
						gdsIDQ.free();
					}

					//only do this if there are peer graded draft structures
					if(vec!=null && !vec.isEmpty()){
						try{
							//find out which peer graders have graded the paper, and print them
							vect.add(new Long(wID.getWriterID()));
							vecto.add(new Long(c.getCourseID()));
							//first get the rowIDs from the writer as grader table
							gwagIDQ=new GetWriterAsGraderIDQuery(vec,null,vect,vecto,"Y");
							rs=gwagIDQ.execute();
							while(rs.next()){
								wagID=rs.getLong(1);
								vw.add(new Long(wagID));
							}
						}catch(SQLException e){
							strbuf.append("A database error has occurred when getting the peer grading IDs: "+e);
							return null;
						}finally{
							gwagIDQ.free();
						}
					}
					
					if(vw!=null && !vw.isEmpty()){
						printStatus=false;
						try{
							//then get the entire entry from said table, from which we extract the writerID of the peer grader
							gwagq=new GetQuery(vw,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
							rs=gwagq.execute();
							while(rs.next()){
								writerID=rs.getLong("writerAsGraderID");
								w.add(new Long(writerID));
							}
						}catch(SQLException e){
							strbuf.append("A database error has occurred when getting the completed peer grader information: "+e);
							return null;
						}finally{
							gwagq.free();
						}
						try{
							//then use those IDs to get the entries from the writer table, and thus the writers' names
							gwagq=new GetQuery(w,PackagingConstants.TABLE_writer,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
							rs=gwagq.execute();
							n=0;
							gradedFNames=new String[rs.getFetchSize()];
							gradedLNames=new String[rs.getFetchSize()];
							while(rs.next()){
								gradedFNames[n]=rs.getString("firstName");
								gradedLNames[n]=rs.getString("lastName");
								n++;
							}
			
						}catch(SQLException e){
							strbuf.append("A database error has occurred when getting the completed peer graders' information: "+e);
							return null;
						}finally{
							gwagq.free();
						}
					}
					
					//Don't search for writer as grader entries if there are no peer graded draft structures
					if(vec!=null && !vec.isEmpty()){
						try{			
							//find out which peer graders have not graded the paper, and print them
							//first get the rowIDs from the writer as grader table
							gwagIDQ=new GetWriterAsGraderIDQuery(vec,null,vect,vecto,"N");
							rs=gwagIDQ.execute();
							vw=new Vector();
							w=new Vector();
							while(rs.next()){
								wagID=rs.getLong(1);
								vw.add(new Long(wagID));
							}
						}catch(SQLException e){
							strbuf.append("A database error has occurred when getting the pending peer grader IDs: "+e);	
							return null;
						}finally{
							gwagIDQ.free();
						}
					}
		
					if(vw!=null && !vw.isEmpty()){
						if(printStatus){
//							out.print("Status:<p>");
						}
						try{
							//then get the entire entry from said table, from which we extract the writerID of the peer grader
							gwagq=new GetQuery(vw,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
							rs=gwagq.execute();
							while(rs.next()){
								writerID=rs.getLong("writerAsGraderID");
								w.add(new Long(writerID));
							}
						}catch(SQLException e){
							strbuf.append("A database error has occurred when getting the pending peer grader information: "+e);
							return null;
						}finally{
							gwagq.free();
						}
						try{
							//then use those IDs to get the entries from the writer table, and thus the writers' names
							gwagq=new GetQuery(w,PackagingConstants.TABLE_writer,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
							n=0;
							rs=gwagq.execute();
							while(rs.next()){
								n++;
							}
							ungradedFNames=new String[n];
							ungradedLNames=new String[n];
							rs.beforeFirst();
							n=0;
							while(rs.next()){
								ungradedFNames[n]=rs.getString("firstName");
								ungradedLNames[n]=rs.getString("lastName");
							}
						}catch(SQLException e){
							strbuf.append("An error has occurred when getting the pending peer graders' information: "+e);
							return null;
						}finally{
							gwagq.free();
						}
					}
					ab.setGradedByFNames(gradedFNames);
					ab.setGradedByLNames(gradedLNames);
					ab.setUngradedByFNames(gradedFNames);
					ab.setUngradedByLNames(gradedLNames);
				}
			}
			else{
				strbuf.append("Could not get paper: "+ps.getMessage());
			}
			AssignmentBeans[i]=ab;
		}
		cb.setAssignments(AssignmentBeans);		
		
		//get the writer as grader info, and display that
		Vector wagIDs=wID.getWriterAsGraderIDs();
		
		//pending
		GetWriterAsGraderIDQuery gwagidq=null;
		GetDraftStructureIDQuery gdsidq=null;
		GetAssignIDQuery gaidq=null;
		GetQuery gq=null;
		Vector courseID=new Vector();
		courseID.add(new Long(c.getCourseID()));
		Vector writerID=new Vector();
		writerID.add(new Long(wID.getWriterID()));
		Vector assignID=new Vector();
		Long aID=null;
		Long dsID=null;
		Vector draftStructureID=new Vector();
		ResultSet ras=null;
		ResultSet rds=null;
		ResultSet rws=null;
		ResultSet rw=null;
		ResultSet rf=null;
		Vector rowID=new Vector();
		Long limitID=new Long(wID.getWriterID());
		Long wawID=null;
		String assignNum=null;
		String assignName=null;
		String draftNum=null;
		String firstName=null;
		String lastName=null;
		Vector writerAsWriterID=new Vector();
		WriterAsGraderBean[] completedWriterAsGraders=null;
		WriterAsGraderBean[] pendingWriterAsGraders=null;
		WriterAsGraderBean wagb;
		try{
			//get all of the assignment ids for this course
			gaidq=new GetAssignIDQuery(courseID,null,null,null);
			ras=gaidq.execute();
			gaidq.free();
			Vector pwagb=new Vector();
			while(ras.next()){
				//get all of the peer graded draft structure ids for this assignment
				assignID.clear();
				assignID.add(new Long(ras.getLong(1)));
				gdsidq=new GetDraftStructureIDQuery(null,assignID,"Peer",null);
				rds=gdsidq.execute();
				gdsidq.free();
				while(rds.next()){
					//get all of the writer as grader entries for this draft structure/writer as grader combo
					draftStructureID.clear();
					draftStructureID.add(new Long(rds.getLong(1)));
					gwagidq=new GetWriterAsGraderIDQuery(draftStructureID,writerID,null,courseID,"N");
					rws=gwagidq.execute();
					gwagidq.free();
					while(rws.next()){
						//for each of those, print out the stats of the paper
						rowID.clear();
						rowID.add(new Long(rws.getLong(1)));
						gq=new GetQuery(rowID,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_writer,limitID);
						rw=gq.execute();
						gq.free();
						//print nothing if, for whatever reason, the writer as grader table doesn't have what we want
						if(rw.next()){
							wagb=new WriterAsGraderBean();
							
							writerAsWriterID.clear();
							writerAsWriterID.add(new Long(rw.getLong("writerAsWriterID")));
							gq=new GetQuery(draftStructureID,PackagingConstants.TABLE_ds,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								wagb.setDraftNum(rf.getInt("draftNum"));
							}
							gq=new GetQuery(assignID,PackagingConstants.TABLE_assignment,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								wagb.setAssignNum(rf.getInt("assignNum"));
								wagb.setAssignName(rf.getString("name"));
							}
							gq=new GetQuery(writerAsWriterID,PackagingConstants.TABLE_writer,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								wagb.setFname(rf.getString("firstName"));
								wagb.setLname(rf.getString("lastName"));
							}
							pwagb.add(wagb);
						}
					}
				}
			}
			
			pendingWriterAsGraders=new WriterAsGraderBean[pwagb.size()];				
			for(int m=0;m<pwagb.size();m++){
				pendingWriterAsGraders[m]=(WriterAsGraderBean)pwagb.elementAt(m);
			}	
		}catch(SQLException e){
			strbuf.append("Database error getting pending papers.");
		}finally{
			if(gwagidq!=null){
				gwagidq.free();
			}
			if(gaidq!=null){
				gaidq.free();
			}
			if(gdsidq!=null){
				gdsidq.free();
			}
			if(gq!=null){
				gq.free();
			}
		}
		cb.setPendingWriterAsGraders(pendingWriterAsGraders);

		//completed peer grading
		try{
			//get all of the assignment ids for this course
			gaidq=new GetAssignIDQuery(courseID,null,null,null);
			ras=gaidq.execute();
			gaidq.free();
			Vector cwagb=new Vector();
			while(ras.next()){
				//get all of the peer graded draft structure ids for this assignment
				assignID.clear();
				assignID.add(new Long(ras.getLong(1)));
				gdsidq=new GetDraftStructureIDQuery(null,assignID,"Peer",null);
				rds=gdsidq.execute();
				gdsidq.free();
				while(rds.next()){
					//get all of the writer as grader entries for this draft structure/writer as grader combo
					draftStructureID.clear();
					draftStructureID.add(new Long(rds.getLong(1)));
					gwagidq=new GetWriterAsGraderIDQuery(draftStructureID,writerID,null,courseID,"Y");
					rws=gwagidq.execute();
					gwagidq.free();
					while(rws.next()){
						//for each of those, print out the stats of the paper
						rowID.clear();
						rowID.add(new Long(rws.getLong(1)));
						gq=new GetQuery(rowID,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_writer,limitID);
						rw=gq.execute();
						gq.free();
						//print nothing if, for whatever reason, the writer as grader table doesn't have what we want
						if(rw.next()){
							wagb=new WriterAsGraderBean();
							
							writerAsWriterID.clear();
							writerAsWriterID.add(new Long(rw.getLong("writerAsWriterID")));
							gq=new GetQuery(draftStructureID,PackagingConstants.TABLE_ds,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								wagb.setDraftNum(rf.getInt("draftNum"));
							}
							gq=new GetQuery(assignID,PackagingConstants.TABLE_assignment,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								wagb.setAssignNum(rf.getInt("assignNum"));
								wagb.setAssignName(rf.getString("name"));
							}
							gq=new GetQuery(writerAsWriterID,PackagingConstants.TABLE_writer,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								wagb.setFname(rf.getString("firstName"));
								wagb.setLname(rf.getString("lastName"));
							}
							cwagb.add(wagb);
						}
					}
				}
			}
			completedWriterAsGraders=new WriterAsGraderBean[cwagb.size()];
			for(int m=0;m<cwagb.size();m++){
				completedWriterAsGraders[m]=(WriterAsGraderBean)cwagb.elementAt(m);
			}					
		}catch(SQLException e){
			strbuf.append("Database error getting completed papers.");
		}finally{
			if(gwagidq!=null){
				gwagidq.free();
			}
			if(gaidq!=null){
				gaidq.free();
			}
			if(gdsidq!=null){
				gdsidq.free();
			}
			if(gq!=null){
				gq.free();
			}
		}
		cb.setCompletedWriterAsGraders(completedWriterAsGraders);
		return cb;	
	}
}