package edu.gwu.blaise.version2.backend.webaccess;
import edu.gwu.servlets.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import edu.gwu.blaise.version2.transmission.*;
import edu.gwu.blaise.version2.documents.*;
import edu.gwu.blaise.version2.backend.packagers.*;
import edu.gwu.blaise.version2.backend.queries.*;
import java.sql.*;
import org.apache.commons.fileupload.*;

/**
 * This is the servlet module that handles the student
 * web access to the data on blaiseserver. 
 *
 * @author Jared Kiraly
 * @version 2 6/7/2004
 */
public class StudentWebAccess extends BaseServlet{
	private WriterLoginQuery wlq;
	private edu.gwu.blaise.version2.transmission.Writer wID;
	
	public StudentWebAccess(){
	}
	
	public void doGet (HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
		doPost(req,res);
	}

	public void doPost (HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
		String command=req.getParameter("command");
		
		//paper submission
		if(command==null){
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out, req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD>");
			//will need more error checking
			if(!FileUpload.isMultipartContent(req)){//if there was some sort of a problem
				//print out the error message
				out.print("<center><h3>Invalid filename</h3></center><p>");
				out.print("</TD></TR></TABLE>");			
			}else{
				byte[] b=this.doSubmit(req);
				byte[] first=DualByteArray.extractFirst(b);
				Properties p=DualByteArray.toProperties(first);
				String stat=p.getProperty("status");
				if(stat.equals(TransmissionConstants.SUCCESS)){
					out.print("<center><h3>Paper Submitted Successfully</h3></center><p>");
					out.print("</TD></TR></TABLE>");								
				}else{
					out.print("<center><h3>Error</h3><p></center>");
					out.print(p.getProperty("message"));
					out.print("</TD></TR></TABLE>");									
				}				
			}
			printFooterInfo(out, req);
			out.flush();
			out.close();
		}
		else if(command.equals("login")){
		//log in the user and display the welcome screen
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			boolean b=this.doLogin(out,req);
			if(b){
				this.doTables(out,req);
				this.getCourses(out,req);
				out.print("</TD><TD CLASS=\"outer_td\">");
				this.welcomeScreen(out,req);
				out.print("</TD></TR></TABLE>");
				printFooterInfo(out,req);
				out.flush();
				out.close();
			}
			else{//failed log in, reprint the login screen with an error message
			   out.print("<CENTER><h3>Invalid User Name or Password.  Please try again.</h3>");
			   out.print("<IMG SRC=\""+TransmissionConstants.logoFileLocation+"\"><br>");
			   out.print("<FORM ACTION=\"StudentWebAccess\" NAME=\"FRM1\" METHOD=\"POST\">");
			   out.print("Username:<INPUT TYPE=\"TEXT\" NAME=\"userName\" VALUE=\""+req.getParameter("userName")+"\"><br><br>");
			   out.print("Password:<INPUT TYPE=\"PASSWORD\" NAME=\"password\"><p>");
			   out.print("University: <SELECT NAME=\"universityID\">");
			   out.print("<OPTION VALUE=\"1\">Hogwarts</OPTION> <OPTION VALUE=\"2\">Springfield</OPTION>");
			   out.print("</SELECT><p>");
			   out.print("<INPUT TYPE=\"SUBMIT\" NAME=\"Log In\" VALUE=\"Log In\">");
			   out.print("<INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"login\">");
			   out.print("</FORM></CENTER>");
			}
		}
		else if(command.equals("doCourse")){
		//display the data for the selected course
			res.setContentType("text/html");
			PrintWriter out=res.getWriter();
			printHeaderInfo(out,req);
			this.doTables(out,req);
			this.getCourses(out,req);
			out.print("</TD><TD CLASS=\"outer_td\">");
			this.doCourse(out,req);
			out.print("</TD></TR></TABLE>");
			printFooterInfo(out,req);
			out.flush();
			out.close();
		}
		//this feature was previously unallowed.  it may not yet work.
		else if(command.equals("doCheckout")){
		//download the selected paper for grading
			byte[] b=this.doCheckout(req);
			byte[] first=DualByteArray.extractFirst(b);
			Properties p=DualByteArray.toProperties(first);
			String stat=p.getProperty("status");
			if(stat.equals(TransmissionConstants.SUCCESS)){
				Blaise_Paper bp=null;
				try{
					bp=BlaiseFile.byteArrayToPaper(DualByteArray.extractSecond(b));
				}catch(IOException e){
					res.setContentType("text/html");
					PrintWriter out=res.getWriter();
					printHeaderInfo(out,req);
					out.print("<h2>An error has occurred that prevented the paper from being checked out:</h2><p>");
					out.print("Download paper query returned in an unknown format.  Please notify an administrator.");
					this.doTables(out,req);
					this.getCourses(out,req);
					out.print("</TD><TD CLASS=\"outer_td\">");
					this.doCourse(out,req);
					out.print("</TD></TR></TABLE>");
					printFooterInfo(out,req);
					out.flush();
					out.close();
					return;
				}
				Vector v=bp.getDrafts();
				if(v.size()==1){//if this paper has only one external draft, return the paper in the format of the draft
					Blaise_Draft bd=(Blaise_Draft)v.firstElement();
					if(bd.hasExternalBody()){
						res.setContentType("application/octet-stream");
						ServletOutputStream out=res.getOutputStream();
						out.write(bd.getExternalBody());
						out.flush();
						out.close();
					}else{//the paper is in blaise format, continue as usual
						res.setContentType("application/octet-stream");
						ServletOutputStream out=res.getOutputStream();
						out.write(DualByteArray.extractSecond(b));
						out.flush();
						out.close();
					}
				}else{
					res.setContentType("application/octet-stream");
					ServletOutputStream out=res.getOutputStream();
					out.write(DualByteArray.extractSecond(b));				
					out.flush();
					out.close();
				}
			}else{
			//download wasn't successful, print an error message above the course data screen
				res.setContentType("text/html");
				PrintWriter out=res.getWriter();
				printHeaderInfo(out,req);
				out.print("<h2>An error has occurred that prevented the paper from being downloaded:</h2><p>");
				String s=p.getProperty("message");
				String message=null;
				ResultReader rr=new ResultReader(s);
				boolean caught=false;
				try{
					rr.parse();
				}catch(ParseResultException e){
					caught=true;
					message=
					"Check out paper query returned in an unknown format.  Please notify an administrator.";
				}
				if(!caught){
					message=rr.getBody();
				}
				out.print("<h2>"+message+"</h2>");
				this.doTables(out,req);
				this.getCourses(out,req);
				out.print("</TD><TD CLASS=\"outer_td\">");
				this.doCourse(out,req);
				out.print("</TD></TR></TABLE>");
				printFooterInfo(out,req);
				out.flush();
				out.close();				
			}
		}
		else if(command.equals("doDownload")){
		//download the selected paper
			byte[] b=this.doDownload(req);
			byte[] first=DualByteArray.extractFirst(b);
			Properties p=DualByteArray.toProperties(first);
			String stat=p.getProperty("status");
			if(stat.equals(TransmissionConstants.SUCCESS)){
				Blaise_Paper bp=null;
				try{
					bp=BlaiseFile.byteArrayToPaper(DualByteArray.extractSecond(b));
				}catch(IOException e){
					res.setContentType("text/html");
					PrintWriter out=res.getWriter();
					printHeaderInfo(out,req);
					out.print("<h2>An error has occurred that prevented the paper from being downloaded:</h2><p>");
					out.print("Download paper query returned in an unknown format.  Please notify an administrator.");
					this.doTables(out,req);
					this.getCourses(out,req);
					out.print("</TD><TD CLASS=\"outer_td\">");
					this.doCourse(out,req);
					out.print("</TD></TR></TABLE>");
					printFooterInfo(out,req);
					out.flush();
					out.close();
					return;
				}
				Vector v=bp.getDrafts();
				if(v.size()==1){//if this paper has only one external draft, return the paper in the format of the draft
					Blaise_Draft bd=(Blaise_Draft)v.firstElement();
						//if this is an external draft with one external comment, return the external comment
						//if not both of these, return the paper in blaise format
					Vector vc=bd.getComments();
					if(vc.size()==1 && bd.hasExternalBody()){
						Blaise_Comment bc=(Blaise_Comment)vc.firstElement();
						if(bc.hasExternalBody()){
							res.setContentType("application/octet-stream");
							ServletOutputStream out=res.getOutputStream();
							out.write(bc.getExternalBody());
							out.flush();
							out.close();								
						}else{
							res.setContentType("application/octet-stream");
							ServletOutputStream out=res.getOutputStream();
							out.write(DualByteArray.extractSecond(b));
							out.flush();
							out.close();				
						}
					}else if(bd.hasExternalBody()){
						res.setContentType("application/octet-stream");
						ServletOutputStream out=res.getOutputStream();
						out.write(bd.getExternalBody());
						out.flush();
						out.close();														
					}else{//the paper is to be returned in blaise format, continue as usual
						res.setContentType("application/octet-stream");
						ServletOutputStream out=res.getOutputStream();
						out.write(DualByteArray.extractSecond(b));
						out.flush();
						out.close();
					}
				}else{
					res.setContentType("application/octet-stream");
					ServletOutputStream out=res.getOutputStream();
					out.write(DualByteArray.extractSecond(b));				
					out.flush();
					out.close();
				}
			}else{
			//download wasn't successful, print an error message above the course data screen
				res.setContentType("text/html");
				PrintWriter out=res.getWriter();
				printHeaderInfo(out,req);
				out.print("<h2>An error has occurred that prevented the paper from being downloaded:</h2><p>");
				String s=p.getProperty("message");
				String message=null;
				ResultReader rr=new ResultReader(s);
				boolean caught=false;
				try{
					rr.parse();
				}catch(ParseResultException e){
					caught=true;
					message=
					"Download paper query returned in an unknown format.  Please notify an administrator.";
				}
				if(!caught){
					message=rr.getBody();
				}
				out.print("<h2>"+message+"</h2>");
				this.doTables(out,req);
				this.getCourses(out,req);
				out.print("</TD><TD CLASS=\"outer_td\">");
				this.doCourse(out,req);
				out.print("</TD></TR></TABLE>");
				printFooterInfo(out,req);
				out.flush();
				out.close();				
			}
		}
	}
	
	/*handles submission and checkin of papers*/
	private byte[] doSubmit(HttpServletRequest req){
		// Create a new file upload handler and parse the request
		DiskFileUpload upload = new DiskFileUpload();
		FileItem item;
		Iterator iter;
		List fileItems;
		boolean isFile=false;
		//this method does submit and checkin.  if the parameter isn't gotten, do submit by default and the error should be caught
		boolean isSubmit=true;
		
		try{
			fileItems = upload.parseRequest(req);
			iter = fileItems.iterator();
		}catch(FileUploadException e){
			//may have to change this error message
			return PackagePaper.sendMessage(false, "An error has occurred, please contact the administrator (error code #1).<p>"+e.toString());
		}
		Blaise_Paper bp=new Blaise_Paper();
		Properties p=new Properties();
		boolean finishLater=false;
		String name=null;
		byte[] extFile=new byte[0];
		String draftNum=null;
		String paperID=null;
		String assignID=null;
		String courseID=null;
		
		//all uploaded items handled here
		while (iter.hasNext()) {
			item = (FileItem) iter.next();
			if (item.isFormField()) {
				String str=item.getString();
				if(str.equals("Checkin")){
					isSubmit=false;
				}else if(str.equals("Submit")){
					isSubmit=true;
				}else if(str.startsWith("pID")){
					paperID=str.substring(3);
				}else if(str.startsWith("aID")){
					assignID=str.substring(3);
				}else if(str.startsWith("cID")){
					courseID=str.substring(3);
				}else if(str.startsWith("wID")){
					//I think this is just a placeholder, but it may be needed later
				}else{
					draftNum=str;
				}				
			}else{
				//this will only work for one paper - shouldnt be a problem
				isFile=true;
				//get filename
				name=item.getName();
				
				//this is simpler if it is a BlaiseFile
				if(name.endsWith(".bls")){
					//include the writerID in the tempfile name to prevent conflicts
					//File f=new File("temp"+wID.getWriterID()+".tmp");

					File f=null;
					try{
						f=File.createTempFile("temp"+wID.getWriterID(),".tmp");
					}catch(IOException e){
							return PackagePaper.sendMessage(false, "An error has occurred, please contact the administrator (error code #2c).<p>"+e.toString());
					}
					BlaiseFile bf=null;
					try{
						item.write(f);
						bf=new BlaiseFile(bp, f, new BackendFileHandler());
						bf.openPaper();
					}catch(IOException e){
						//may have to change this error message 
						return PackagePaper.sendMessage(false, "An error has occurred, please contact the administrator (error code #2a).<p>"+e.toString());
					}catch(Exception e){
						//may have to change this error message 
						return PackagePaper.sendMessage(false, "An error has occurred, please contact the administrator (error code #2b).<p>"+e.toString());
					}
					bp=bf.getPaper();	
				}else{
					//just set the flag here and get the file later because it needs a draftNum, which may not have been gotten yet
					finishLater=true;
					extFile=item.get();
				}
		    }
		}
		
		//only done if this is a non-blaise document
		if(finishLater){
			/*checkin no longer has to be a .bls file
			if(!isSubmit){
				return PackagePaper.sendMessage(false, "Checked in paper must be a .bls file");
			}*/
			
//I'm not sure this check is necessary
			if(draftNum==null || draftNum.equals("")){
				//this means that the draft number wasn't entered and this is not a .bls file
				return PackagePaper.sendMessage(false, "Please enter a draft number.<p>");
			}
			
			if(paperID==null && !isSubmit){//it would be strange if this happened.  this is the only reason I can think of.
					return PackagePaper.sendMessage(false, "An error has occurred.  You are checking in a paper that hasn't been checked out. (error code #3a)");							
			}else if(paperID==null){//if the paperID is null, that means that this is a new paper, so create a paper in the database
				try{
					NewPaperQuery npq=new NewPaperQuery(new Integer(2), new Long(wID.getWriterID()), new Integer(wID.getUniversityID()), new Long(courseID), "standard", new Long(assignID), "N");
					int i=npq.execute();
					paperID=npq.getLastInsertID().toString();
				}catch(SQLException e){
					return PackagePaper.sendMessage(false, "A database error has occurred.  Please contact an administrator (error code #3b).<p>"+e);				
				}catch(NumberFormatException e){
					return PackagePaper.sendMessage(false, "An error has occurred (number format).  Please contact an administrator (error code #3c).<p>"+e);				
				}
			}
			
			//one way or another, get the paper from the database
//should probably change this so only get it from db if it is a preexisting paper
			Properties p2=new Properties();
			p2.put("writerID",Long.toString(wID.getWriterID()));
			p2.put("paperID",paperID);
			PackagePaper pp2=new PackagePaper(TransmissionConstants.getPaperFull, req, PackagingConstants.LIMIT_writer, null, p2, null);
			byte[] paper=pp2.execute(true);
			
			//check for success
			byte[] first=DualByteArray.extractFirst(paper);
			p2=DualByteArray.toProperties(first);
			String stat=p2.getProperty("status");
			if(stat==null){
				return PackagePaper.sendMessage(false, "Error transmitting paper.");
			}else if(stat.equals(TransmissionConstants.FAILURE)){
				//is this message correct?
				return PackagePaper.sendMessage(false, "No paper specified.");
			}
			
			try{
				bp=BlaiseFile.byteArrayToPaper(paper);
			}catch(IOException e){
				return PackagePaper.sendMessage(false, "An error has occurred while getting the paper (error code #4): "+e.toString());
			}
			
			//get the drafts of this paper and add the checked in external draft as a comment			
			if(!isSubmit){
				Vector v=bp.getDrafts();
				int draftNumber=-1;
				try{
					draftNumber=Integer.parseInt(draftNum);
				}catch(NumberFormatException e){
					draftNumber=1;
BaseServlet.writeLog("Draft number incorrectly specified as: "+draftNum+".");
//				return PackagePaper.sendMessage(false, "Invalid draft number specified.");
				}
			
				Blaise_Draft bd=(Blaise_Draft)v.elementAt(draftNumber-1);
			
				Blaise_Comment bc=new Blaise_Comment();
				bc.setExternalBody(extFile);
				bc.setExternalBodyFilename(name);
				bc.setGraderID(wID.getWriterID()+"");
				if(paperID!=null){
					bc.setPaperID(paperID);
				}
				bc.setDraftID(bd.getDraftID());
				bc.setGraderName(wID.getFirstName()+" "+wID.getLastName());
				bc.setIsPublic("YES");
				bd.addComment(bc);
				
				bd.setIsModified("YES");
				v.setElementAt(bd, draftNumber-1);
			
				bp.setDrafts(v);
			}else{//or add external draft
				Blaise_Draft bd=new Blaise_Draft();
				bd.setPaperID(paperID);
				bd.setDraftNumber(draftNum);
				bd.setExternalBody(extFile);
				bd.setExternalBodyFilename(name);
				bp.addDraft(bd);
			}
		}
		
		if(isFile){	
			bp.setVersion("2");
			bp.setFirst(wID.getFirstName());
			bp.setLast(wID.getLastName());
			bp.setStudentIdentifier(wID.getStudentIdent());
			bp.setEmail(wID.getEmail());
			
			PackagePaper pp;
			p.put("writerID",Long.toString(wID.getWriterID()));			
			bp.setWriterID(Long.toString(wID.getWriterID()));
			bp.setUniversityID(Integer.toString(wID.getUniversityID()));
			bp.setCourseID(courseID);
			if(paperID!=null){
				bp.setPaperID(paperID);
			}
			if(assignID!=null){
				bp.setAssignmentID(assignID);
			}
			if(isSubmit){
				pp=new PackagePaper(TransmissionConstants.submitPaper, req, PackagingConstants.LIMIT_writer, null, p, bp);
			}else{
				pp=new PackagePaper(TransmissionConstants.checkInPaper, req, PackagingConstants.LIMIT_writer, null, p, bp);				
			}
			return pp.execute(true);
		}else{
			return PackagePaper.sendMessage(false, "No file specified.");
		}
	}
			
	/*Check out the selected paper*/
	private byte[] doCheckout(HttpServletRequest req){
		Properties p=new Properties();
		p.put("paperID",req.getParameter("paperID"));
		p.put("writerID",Long.toString(wID.getWriterID()));
		PackagePaper pp=new PackagePaper(TransmissionConstants.checkOutPaper,req,PackagingConstants.LIMIT_writer,null,p,null);
		return pp.execute(false);
	}

	/*Download the selected paper*/
	private byte[] doDownload(HttpServletRequest req){
		Properties p=new Properties();
		p.put("paperID",req.getParameter("paperID"));
		p.put("writerID",Long.toString(wID.getWriterID()));
		PackagePaper pp=new PackagePaper(TransmissionConstants.getPaperFull,req,PackagingConstants.LIMIT_writer,null,p,null);
		return pp.execute(false);
	}
	
	/*Set up the screen as a table*/
	private void doTables(PrintWriter out, HttpServletRequest req){
		out.print("<TABLE cellspacing=\"5\" cellpadding=\"10\"><TR><TD><IMG SRC=\""+TransmissionConstants.logoFileLocation+"\"></TD>");
		out.print("<TD>");
		out.print("<h3>Blaise Account<p>");
		out.print("User: "+wID.getUserName()+"<p>Date: "+new java.util.Date());
		out.print("<p>Blaise User since: "+wID.getCreationDate()+"</h3>");
		out.print("</TD></TR><TR><TD valign=\"TOP\" halign=\"CENTER\">");
	}
	
	/*Log in the user*/
	private boolean doLogin(PrintWriter out,HttpServletRequest req){
		String userName=req.getParameter("userName");
		String password=req.getParameter("password");
		String uID=req.getParameter("universityID");
		
		//try to log in.  if it fails, send out the message to the user.
		wlq=TransmissionHandler.getWriterLogin(userName,password,uID);
		boolean b=wlq.transmit();
		if(!b){
			return false;
		}
		
		wID=wlq.getWriter();
		if(wID==null){
			return false;
		}
		
		return true;
	}
	
	/*print the welcome screen*/
	private void welcomeScreen(PrintWriter out, HttpServletRequest req){
		//print out the welcome screen stuff, there may be more to come		
		out.print("<center><h3>Hello, "+wID.getFirstName()+" "+wID.getLastName()+"!</h3><p>");
		out.print("Welcome to your blaise account.<p>");
		out.print("Please click on a course.<br>");
		
	}
		
	/*Get this writer's courses*/
	private void getCourses(PrintWriter out,HttpServletRequest req){
		//distinguish between past and present courses
		Vector courses=wlq.getCourses();
		Course c=null;
		out.print("<h4>Your Current Courses:</h4>");
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			out.print("<FORM NAME=\"frm"+i+"\" METHOD=\"POST\" ACTION=\"StudentWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doCourse\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
			out.print("<INPUT TYPE=\"submit\" NAME=\"courseName\" VALUE=\""+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"\">");
			out.print("</FORM>");
			out.print("<p>");
		}

		Vector pastCourses=wlq.getPastCourses();
		out.print("<h4>Your Past Courses:</h4>");
		for(int i=0;i<pastCourses.size();i++){
			c=(Course)pastCourses.elementAt(i);
			out.print("<FORM NAME=\"frm"+i+"\" METHOD=\"POST\" ACTION=\"StudentWebAccess\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doCourse\">");
			out.print("<INPUT TYPE=\"hidden\" NAME=\"courseID\" VALUE=\""+Long.toString(c.getCourseID())+"\">");
			out.print("<INPUT TYPE=\"submit\" NAME=\"courseName\" VALUE=\""+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"\">");
			out.print("</FORM>");
			out.print("<p>");
		}
	}
	
	/*Print out the info for this course: assignments, peer grading, announcements, etc.*/
	private void doCourse(PrintWriter out,HttpServletRequest req){		
		String cID=req.getParameter("courseID");
		Vector courses=wlq.getCourses();
		Course c=null;
		for(int i=0;i<courses.size();i++){
			c=(Course)courses.elementAt(i);
			if(Long.toString(c.getCourseID()).equals(cID)){
				break;
			}
		}
		
		out.print("<h3><center>"+c.getDept()+" "+c.getNumber()+"-"+c.getSection()+"</center></h3>");
		out.print("<TABLE cellpadding=\"7\"><TR><TD valign=\"top\" CLASS=\"inner_td_header\">");

		//get the assignment info, and display it
		out.print("<center><h4>Your Assignments:</h4></center>");
		
		out.print("</TD><TD valign=\"top\" CLASS=\"inner_td_header\">");
		//get the writer as grader info, and display that
		out.print("<center><h4>Peer Grading:</h4></center>");
		out.print("</TR><TR> <td valign=\"top\" CLASS=\"inner_td_contents\">");
		
		Assignment a=null;
		Vector assignments=c.getAssignments();
		Vector asi=null;
		Vector pap=null;
		Blaise_Draft bd=null;
		Blaise_Comment bc=null;
		Blaise_Paper blp=null;
		Vector comments=null;
		PaperSearchQuery ps;
		boolean ex;
		for(int i=0;i<assignments.size();i++){
			a=(Assignment)assignments.elementAt(i);
			asi=new Vector();
			asi.add(new Long(a.getAssignID()));
			ps=TransmissionHandler.getPaperSearch(false,wID.getLastName(),wID.getStudentIdent(),wID.getEmail(),c,TransmissionHandler.WRITER_TYPE,null,asi,null);
			ex=ps.transmit();
			if(ex){
				pap=ps.getPapers();
				//pap can only have one paper
				if(pap.size()==1){
					//print out the peer grading status
					blp=(Blaise_Paper)pap.firstElement();
					Vector idvec=new Vector();
					idvec.add(new Long(blp.getPaperID()));
					GetQuery gq=new GetQuery(idvec,PackagingConstants.TABLE_paper,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
					String hbd=null;
					try{
						ResultSet result=gq.execute();
						if(result.next()){
							hbd=result.getString("hasBeenDownloaded");
						}
					}catch(SQLException e){
						out.print("An error has occurred in getting the status of this paper.<p>");
					}finally{
						gq.free();
					}
					if(hbd.equals("Y")){
						out.print(a.assignNum()+": "+a.name()+"<p>");
					}else{
						out.print("<b>"+a.assignNum()+": "+a.name()+"</b><p>");
					}
						
					//put in some stats about each draft
					Vector dss=a.getDraftStructure();
					java.util.Date utilDate=null;
					DraftStructure d=null;
					out.print("<ul>");
					for(int j=0;j<dss.size();j++){
						d=(DraftStructure)dss.elementAt(j);
						utilDate=d.noChangeDate();
						out.print("<li>Draft number "+d.getDraftNum()+" is due "+utilDate.toString()+"<p>");
					} 
					out.print("</ul>");
										
					this.printStatus(out,a.getAssignID(),c.getCourseID());
					out.print("<FORM NAME=\"frmDL\" METHOD=\"POST\" ACTION=\"StudentWebAccess\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"command\" value=\"doDownload\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"paperID\" value=\""+blp.getPaperID()+"\">");
					out.print("<INPUT TYPE=\"submit\" name=\"Download\" value=\"Download\"><p>");
					out.print("</FORM>");
					
					out.print("Submit this paper:<P>");					
					out.print("<FORM NAME=\"frmSubmit\" METHOD=\"POST\" ACTION=\"StudentWebAccess\" ENCTYPE=\"multipart/form-data\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"paperID\" value=\"pID"+blp.getPaperID()+"\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"paperID\" value=\"aID"+a.getAssignID()+"\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"paperID\" value=\"cID"+a.getcourseID()+"\">");
					out.print("<INPUT TYPE=\"file\" name=\"paper\" size=\"35\"><p>");
					out.print("Draft Number (if written with non-Blaise editor):");
					out.print("<INPUT TYPE=\"text\" name=\"draftNum\" size=2><p>");
					out.print("<INPUT TYPE=\"submit\" name=\"Submit\" value=\"Submit\"><p>");
					out.print("</FORM>");					
				}
				else if(pap.size()==0){
					out.print("<b>"+a.assignNum()+": "+a.name()+"</b><p>");
						
					//put in some stats about each draft
					Vector dss=a.getDraftStructure();
					java.util.Date utilDate=null;
					DraftStructure d=null;
					out.print("<ul>");
					for(int j=0;j<dss.size();j++){
						d=(DraftStructure)dss.elementAt(j);
						utilDate=d.noChangeDate();
						out.print("<li>Draft number "+d.getDraftNum()+" is due "+utilDate.toString()+"<p>");
					} 
					out.print("</ul>");
										
					this.printStatus(out,a.getAssignID(),c.getCourseID());
					out.print("<i>No paper has been submitted for this assignment yet.</i><p>");
					out.print("Submit this paper:<P>");					
					out.print("<FORM NAME=\"frmSubmit\" METHOD=\"POST\" ACTION=\"StudentWebAccess\" ENCTYPE=\"multipart/form-data\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"paperID\" value=\"aID"+a.getAssignID()+"\">");
					out.print("<INPUT TYPE=\"hidden\" name=\"paperID\" value=\"cID"+a.getcourseID()+"\">");
					out.print("<INPUT TYPE=\"file\" name=\"paper\" size=\"35\"><p>");
					out.print("Draft Number (if written with non-Blaise editor):");
					out.print("<INPUT TYPE=\"text\" name=\"draftNum\" size=2><p>");
					out.print("<INPUT TYPE=\"submit\" name=\"Submit\" value=\"Submit\"><p>");
					out.print("</FORM>");					
				}
				else{
					out.print("A formatting error has occurred when getting the paper for "+a.assignNum()+": "+a.name());
					out.print(".  Please contact an administrator.");
				}
			}
			else{
				out.print("Could not get paper: "+ps.getMessage());
			}
			out.print("<br>");
		}		

//****************
//****************
//****************
		out.print("</TD><td valign=\"top\" CLASS=\"inner_td_contents\">");		
		
		Vector wagIDs=wID.getWriterAsGraderIDs();
		
		out.print("<b>Pending:</b><p>");
		GetWriterAsGraderIDQuery gwagidq=null;
		GetDraftStructureIDQuery gdsidq=null;
		GetAssignIDQuery gaidq=null;
		GetPaperIDQuery gpidq=null;
		GetQuery gq=null;
		Vector courseID=new Vector();
		courseID.add(new Long(c.getCourseID()));
		Vector writerID=new Vector();
		writerID.add(new Long(wID.getWriterID()));
		Vector assignID=new Vector();
		Long aID=null;
		Long dsID=null;
		long paperID=-1;
		Vector draftStructureID=new Vector();
		ResultSet ras=null;
		ResultSet rds=null;
		ResultSet rws=null;
		ResultSet rw=null;
		ResultSet rf=null;
		Vector rowID=new Vector();
		Long limitID=new Long(wID.getWriterID());
		Long wawID=null;
		String assignNum=null;
		String assignName=null;
		String draftNum=null;
		String firstName=null;
		String lastName=null;
		Vector writerAsWriterID=new Vector();
		try{
			//get all of the assignment ids for this course
			gaidq=new GetAssignIDQuery(courseID,null,null,null);
			ras=gaidq.execute();
			gaidq.free();
			while(ras.next()){
				//get all of the peer graded draft structure ids for this assignment
				assignID.clear();
				assignID.add(new Long(ras.getLong(1)));
				gdsidq=new GetDraftStructureIDQuery(null,assignID,"Peer",null);
				rds=gdsidq.execute();
				gdsidq.free();
				while(rds.next()){
					//get all of the writer as grader entries for this draft structure/writer as grader combo
					draftStructureID.clear();
					draftStructureID.add(new Long(rds.getLong(1)));
					gwagidq=new GetWriterAsGraderIDQuery(draftStructureID,writerID,null,courseID,"N");
					rws=gwagidq.execute();
					gwagidq.free();
					while(rws.next()){
						//for each of those, print out the stats of the paper
						rowID.clear();
						rowID.add(new Long(rws.getLong(1)));
						gq=new GetQuery(rowID,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_writer,limitID);
						rw=gq.execute();
						gq.free();
						//print nothing if, for whatever reason, the writer as grader table doesn't have what we want
						if(rw.next()){
							writerAsWriterID.clear();
							writerAsWriterID.add(new Long(rw.getLong("writerAsWriterID")));
							gq=new GetQuery(draftStructureID,PackagingConstants.TABLE_ds,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								draftNum=rf.getString("draftNum");
							}
							gq=new GetQuery(assignID,PackagingConstants.TABLE_assignment,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								assignNum=rf.getString("assignNum");
								assignName=rf.getString("name");
							}
							gq=new GetQuery(writerAsWriterID,PackagingConstants.TABLE_writer,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								firstName=rf.getString("firstName");
								lastName=rf.getString("lastName");
							}
								
							gpidq=new GetPaperIDQuery(null, writerAsWriterID, null, courseID, null, null, lastName, null, null, null, null, assignID, null, null);
							rf=gpidq.execute();
							gpidq.free();
							if(rf.next()){
								paperID=rf.getLong("paperID");
							}
							
							out.print("Draft number "+draftNum+" of assignment "+assignNum+": "+assignName+"<p>");
							out.print("Paper for: "+firstName+" "+lastName+"<p>");
							out.print("<FORM NAME=\"frmCheckout\" ACTION=\"StudentWebAccess\" METHOD=\"POST\">");
							out.print("<INPUT TYPE=\"hidden\" NAME=\"paperID\" VALUE=\""+paperID+"\">");
							out.print("<INPUT TYPE=\"hidden\" NAME=\"writerID\" VALUE=\""+wID.getWriterID()+"\">");
							out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"doCheckout\">");
							out.print("<INPUT TYPE=\"submit\" NAME=\"Checkout\" VALUE=\"Checkout\">");
							out.print("</FORM>");

							out.print("<FORM NAME=\"frmCheckin\" ACTION=\"StudentWebAccess\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">");
							out.print("Check in this paper:<p>");
							out.print("<INPUT TYPE=\"hidden\" NAME=\"paperID\" VALUE=\"pID"+paperID+"\">");				
							out.print("<INPUT TYPE=\"hidden\" NAME=\"writerID\" VALUE=\"wID"+wID.getWriterID()+"\">");
							out.print("<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"Checkin\">");
							out.print("<INPUT TYPE=\"file\" name=\"paper\" size=\"35\">");
							out.print("<INPUT TYPE=\"hidden\" name=\"draftNum\" value=\""+draftNum+"\"><p>");
							out.print("<INPUT TYPE=\"submit\" NAME=\"Checkin\" VALUE=\"Check In\"><p>");
							out.print("</FORM>");
							out.print("<br>");
						}
					}
				}
			}
		}catch(SQLException e){
			out.print("Database error getting pending papers.");
		}finally{
			if(gwagidq!=null){
				gwagidq.free();
			}
			if(gaidq!=null){
				gaidq.free();
			}
			if(gdsidq!=null){
				gdsidq.free();
			}
			if(gq!=null){
				gq.free();
			}
		}		

		out.print("<b>Completed:</b><p>");
		try{
			//get all of the assignment ids for this course
			gaidq=new GetAssignIDQuery(courseID,null,null,null);
			ras=gaidq.execute();
			gaidq.free();
			while(ras.next()){
				//get all of the peer graded draft structure ids for this assignment
				assignID.clear();
				assignID.add(new Long(ras.getLong(1)));
				gdsidq=new GetDraftStructureIDQuery(null,assignID,"Peer",null);
				rds=gdsidq.execute();
				gdsidq.free();
				while(rds.next()){
					//get all of the writer as grader entries for this draft structure/writer as grader combo
					draftStructureID.clear();
					draftStructureID.add(new Long(rds.getLong(1)));
					gwagidq=new GetWriterAsGraderIDQuery(draftStructureID,writerID,null,courseID,"Y");
					rws=gwagidq.execute();
					gwagidq.free();
					while(rws.next()){
						//for each of those, print out the stats of the paper
						rowID.clear();
						rowID.add(new Long(rws.getLong(1)));
						gq=new GetQuery(rowID,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_writer,limitID);
						rw=gq.execute();
						gq.free();
						//print nothing if, for whatever reason, the writer as grader table doesn't have what we want
						if(rw.next()){
							writerAsWriterID.clear();
							writerAsWriterID.add(new Long(rw.getLong("writerAsWriterID")));
							gq=new GetQuery(draftStructureID,PackagingConstants.TABLE_ds,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								draftNum=rf.getString("draftNum");
							}
							gq=new GetQuery(assignID,PackagingConstants.TABLE_assignment,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								assignNum=rf.getString("assignNum");
								assignName=rf.getString("name");
							}
							gq=new GetQuery(writerAsWriterID,PackagingConstants.TABLE_writer,PackagingConstants.LIMIT_writer,limitID);
							rf=gq.execute();
							gq.free();
							if(rf.next()){
								firstName=rf.getString("firstName");
								lastName=rf.getString("lastName");
							}
							out.print("Draft number "+draftNum+" of assignment "+assignNum+": "+assignName+"<p>");
							out.print("Paper for: "+firstName+" "+lastName+"<p><br>");
						}
					}
				}
			}
		}catch(SQLException e){
			out.print("Database error getting completed papers.");
		}finally{
			if(gwagidq!=null){
				gwagidq.free();
			}
			if(gaidq!=null){
				gaidq.free();
			}
			if(gdsidq!=null){
				gdsidq.free();
			}
			if(gq!=null){
				gq.free();
			}
		}		
				 
		out.print("<INPUT TYPE=\"hidden\" name=\"courseID\" value=\""+cID+"\">");		
		out.print("</TD></TR></TABLE><br>");
		
		//display general announcements, somehow
		out.print("<center><h4>Announcements:</h4></center>");
	}	

	/*Print the peer grading status*/
	private void printStatus(PrintWriter out,long assignID,long courseID){
		Vector vect=new Vector();
		Vector vecto=new Vector();
		GetWriterAsGraderIDQuery gwagIDQ=null;		
		GetQuery gwagq=null;
		long wagID;
		long writerID;
		Vector vw=new Vector();
		Vector w=new Vector();
		Vector v=new Vector();
		ResultSet rs=null;
		long dsID;
		Vector vec=new Vector();
		GetDraftStructureIDQuery gdsIDQ=null;
		boolean printStatus=true;

		//get the dsids for peer grading in this assignment		
		try{
			v.add(new Long(assignID));
			gdsIDQ=new GetDraftStructureIDQuery(null,v,"Peer",null);
			rs=gdsIDQ.execute();	
			while(rs.next()){
				dsID=rs.getLong(1);
				vec.add(new Long(dsID));
			}
		}catch(SQLException e){
			out.print("A database error has occurred when getting the drafts: "+e);
			return;
		}finally{
			gdsIDQ.free();
		}

		//only do this if there are peer graded draft structures
		if(vec!=null && !vec.isEmpty()){
			try{
				//find out which peer graders have graded the paper, and print them
				vect.add(new Long(wID.getWriterID()));
				vecto.add(new Long(courseID));
				//first get the rowIDs from the writer as grader table
				gwagIDQ=new GetWriterAsGraderIDQuery(vec,null,vect,vecto,"Y");
				rs=gwagIDQ.execute();
				while(rs.next()){
					wagID=rs.getLong(1);
					vw.add(new Long(wagID));
				}
			}catch(SQLException e){
				out.print("A database error has occurred when getting the peer grading IDs: "+e);
				return;
			}finally{
				gwagIDQ.free();
			}
		}
		
		if(vw!=null && !vw.isEmpty()){
			out.print("Status:<p>");
			printStatus=false;
			try{
				//then get the entire entry from said table, from which we extract the writerID of the peer grader
				gwagq=new GetQuery(vw,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
				rs=gwagq.execute();
				while(rs.next()){
					writerID=rs.getLong("writerAsGraderID");
					w.add(new Long(writerID));
				}
			}catch(SQLException e){
				out.print("A database error has occurred when getting the completed peer grader information: "+e);
				return;
			}finally{
				gwagq.free();
			}
			try{
				//then use those IDs to get the entries from the writer table, and thus the writers' names
				gwagq=new GetQuery(w,PackagingConstants.TABLE_writer,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
				rs=gwagq.execute();
				while(rs.next()){
					out.print("Graded by: "+rs.getString("firstName")+" "+rs.getString("lastName")+"<p>");
				}
				out.print("<p>");

			}catch(SQLException e){
				out.print("A database error has occurred when getting the completed peer graders' information: "+e);
				return;
			}finally{
				gwagq.free();
			}
		}
		
		//Don't search for writer as grader entries if there are no peer graded draft structures
		if(vec!=null && !vec.isEmpty()){
			try{			
				//find out which peer graders have not graded the paper, and print them
				//first get the rowIDs from the writer as grader table
				gwagIDQ=new GetWriterAsGraderIDQuery(vec,null,vect,vecto,"N");
				rs=gwagIDQ.execute();
				vw=new Vector();
				w=new Vector();
				while(rs.next()){
					wagID=rs.getLong(1);
					vw.add(new Long(wagID));
				}
			}catch(SQLException e){
				out.print("A database error has occurred when getting the pending peer grader IDs: "+e);	
				return;
			}finally{
				gwagIDQ.free();
			}
		}
		
		if(vw!=null && !vw.isEmpty()){
			if(printStatus){
				out.print("Status:<p>");
			}
			try{
				//then get the entire entry from said table, from which we extract the writerID of the peer grader
				gwagq=new GetQuery(vw,PackagingConstants.TABLE_wag,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
				rs=gwagq.execute();
				while(rs.next()){
					writerID=rs.getLong("writerAsGraderID");
					w.add(new Long(writerID));
				}
			}catch(SQLException e){
				out.print("A database error has occurred when getting the pending peer grader information: "+e);
				return;
			}finally{
				gwagq.free();
			}
			try{
				//then use those IDs to get the entries from the writer table, and thus the writers' names
				gwagq=new GetQuery(w,PackagingConstants.TABLE_writer,PackagingConstants.LIMIT_writer,new Long(wID.getWriterID()));
				rs=gwagq.execute();
				while(rs.next()){
					out.print("Ungraded by: "+rs.getString("firstName")+" "+rs.getString("lastName")+"<p>");
				}
			}catch(SQLException e){
				out.print("An error has occurred when getting the pending peer graders' information: "+e);
				return;
			}finally{
				gwagq.free();
			}
		}
	}
		
	/*the html header information*/
	private void printHeaderInfo(PrintWriter out,HttpServletRequest req){
		//may want this to have more information, such as have the section of the site listed in the title bar
		out.print("<HTML><HEAD><TITLE>Blaise Student Web Access</TITLE>");
		out.print("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"cssSheet.css\" TITLE=\"Default\"></HEAD><BODY>");
	}

	/*the html footer information*/	
	private void printFooterInfo(PrintWriter out,HttpServletRequest req){
		out.print("</BODY></HTML>");
	}
	
	/////////////////////////////////////////////////////////////
	//
	// edu.gwu.servlets required methods
	//
	/////////////////////////////////////////////////////////////
  
	public void shutdown ()
	{
		// Nothing to be done.
		return;
	}
	
	public void reset ()
	{
		// Nothing to be done.
		return;
	}
	
	public void save ()
	{
		// Nothing to be done.
		return;
	}
	
	public void test (PrintWriter out)
	{
		out.print ("<p> StudentWebAccess.test: successful </p>");
	}
}
