package edu.gwu.blaise.version2.client;

import java.util.Locale;
import java.util.ResourceBundle;
import java.util.Vector;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.*;

import com.apple.eawt.*;

import edu.gwu.blaise.version2.util.*;
import edu.gwu.blaise.version2.documents.*;

/**
 * The main entry point into the Blaise Editor.
 * @author Sean T. Hanlon
 * @author Michael Gaiman
 * @version 2 7/15/2004
 */
public class Blaise_Editor{
    protected Preferences prefs;
    private Application fApplication = new Application();
    
    private BlaiseSplitPane bsp=null;
    
    public Blaise_Editor() {
        try{
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }catch(Exception e){}
        //prefs = new Preferences();
        
        if(Constants.isOSX()){
            if(MacInstall.installNeeded()){//move user dirs out of app.
                MacInstall.doMacInstall();
            }
            //OSX double buffers natively, so swing doesn't need to.
            RepaintManager currentManager = RepaintManager.currentManager(null);
            currentManager.setDoubleBufferingEnabled(false);

            fApplication.setEnabledPreferencesMenu(false);
            fApplication.addApplicationListener(new com.apple.eawt.ApplicationAdapter() {
                public void handleOpenApplication(ApplicationEvent e) {
                    System.out.println("handleOpenApplication...");
                    bsp=new BlaiseSplitPane(BlaiseSplitPane.EDITOR,new Blaise_Paper());

                }
                public void handleOpenFile(ApplicationEvent e) {
                    System.out.println("handleOpenFile...");
                    
                    BlaiseEditorPane bep;
                    if(bsp!=null){
                        if(bsp.getMode()==BlaiseSplitPane.EDITOR){
                            bep=(BlaiseEditorPane)bsp.getBottom();
                            bep.openAction(e.getFilename());
                        }
                    }
                }
                /*public void handlePreferences(ApplicationEvent e) {
                        preferences(e);
                }*/
                
                public void handleAbout(ApplicationEvent e){
                
                    BlaiseEditorPane bep;
                    if(bsp!=null){
                        if(bsp.getMode()==BlaiseSplitPane.EDITOR){
                            bep=(BlaiseEditorPane)bsp.getBottom();
                            e.setHandled(true);
                            bep.aboutAction();
                        }
                    }
                }
                
                public void handleQuit(ApplicationEvent e) {
                    BlaiseEditorPane bep;
                    //if(bsp.getMode()==BlaiseSplitPane.EDITOR){ not needed really is it?
                        bep=(BlaiseEditorPane)bsp.getBottom();
                        bep.quitAction();
                    //}
                }
            });
        }//OSX
        else{//windows
            bsp=new BlaiseSplitPane(BlaiseSplitPane.EDITOR,new Blaise_Paper());
        }
    }

    /*public void preferences(ApplicationEvent e) {
        prefs.setResizable(false);
        WindowOpener.open(prefs,"Preferences");
    }*/

     public static void main(String args[]) {
        try{
            String file = "editorsplash.jpg";
            SplashScreen screen = new SplashScreen(file);
            screen.setVisible(true);
            //we should have enough work to do, that it is actually useful now.
            /*
            try{
                Thread.sleep(Constants.getDelay());
            } catch (Exception e) {}
            */

            new Blaise_Editor();
            screen.dispose();
        }
        catch(Exception e){}
     }

}