//LOC:50
package edu.gwu.blaise.version2.documents;

import java.awt.*;
import java.awt.geom.*;

/**
* A ScribbleLine is a line that composes a Scribble
 *
 * @author Sean T. Hanlon
 */
public class ScribbleLine extends Line2D.Double {
    
    /** Constructor */
    public ScribbleLine(double x1, double y1, double x2, double y2){
        super(x1,y1,x2,y2);
    }
    
    /** Gets String representation of line */
    public String getString(){
        return (x1+","+y1+","+x2+","+y2);
    }
    
    /** Adds an X and Y offset to the line */
    public void addOffset(double x, double y){
        x1 = x1 + x;
        x2 = x2 + x;
        
        y1 = y1 + y;
        y2 = y2 + y;
    }
    
    /** Prints Info */
    public void print(){
        System.out.println("ScribbleLine: "+x1+", "+y1+", "+x2+", "+y2);
    }
    
    /** Generates stored content of scribbleline --> x1*y1 */
    public String generateStoredContent(){
        
        StringBuffer output = new StringBuffer();
        
        output.append(getX1());
        output.append('*');
        output.append(getY1());
        
        return output.toString();
    }
}