//LOC:91
package edu.gwu.blaise.version2.grader;

import java.util.*;
import java.io.*;
import edu.gwu.blaise.version2.util.*;
import edu.gwu.blaise.version2.documents.*;

/**
* Briefcase is a repository for all doucments add to the briefcase
 * It is read from by the BriefCasePane and written into by the SearchPane
 */
public class BriefCase{
    
    private static boolean debug = false;
    private static Vector papers = new Vector();	//papers in briefcase
    
    /**
        * Adds a given paper to the briefcase
     *
     * @param paperToAdd Paper that is to be added to the briefcase
     */
    public static void addPaper(Blaise_Paper paperToAdd){
		//First, see if paper exists in briefcase already
        for(int i=0;i<papers.size();i++){
            if(((Blaise_Paper)papers.elementAt(i)).equals(paperToAdd)){
                return;
            }
        }
        papers.addElement(paperToAdd);	//add paper to briefcase vector
    }
    
    /**
        * Removes a paper based on index-value
     *
     * @param i Index of paper to remove from briefcase
     */
    public static void removePaper(int i){
        
        if(papers.size() < i){
            if(debug)System.out.println("TRIED TO ERASE A NON EXISTANT LOCATION!");
        }
        else{
            papers.removeElementAt(i);
        }
    }
    
    /**
        * Gets all papers currently in briefcase
     *
     * @return Vector of papers in briefcase
     */
    public static Vector getPapers(){
        return papers;
    }
    
    public static Vector getPaperHeaders(){
        
        Vector output = new Vector();
        
        for(int i=0;i<papers.size();i++){
            output.add(new Long(((Blaise_Paper)papers.elementAt(i)).getPaperID()));
        }
        
        return output;
    }
    
    /**
        * Gets a given paper
     *
     * @param i The index of the desired paper
     * @return The desired PGS_Document
     */
    public static Blaise_Paper getPaper(int i){
        return (Blaise_Paper)papers.elementAt(i);
    }
    
    /**
        * Returns the number of papers in briefcase
     *
     * @return Number of papers in briefcase
     */
    public static int numberInBrief(){
        return papers.size();
    }
    
    /**
        * Clears the briefcase
     */
    public static void clearBriefCase(){
        papers = new Vector();
    }
    
    /**
        * Displays the brifcase to the screen
     */
    public static void display(){
        for(int i=0;i<papers.size();i++){
            ((Blaise_Paper)papers.elementAt(i)).print();
        }
    }
}
