package edu.gwu.blaise.version2.grader;
/**
 * An interface of a object that is provided to the CheckinDialog
 * so that the caller may make changes to either the model or the view
 * of checked out papers.
 * @author Michael Gaiman
 * @version 1 6/27/2004
 */
public interface CheckinCallBack {
    /**
     * Note, as currently implemented, handlEntry is not called from
     * the event thread.
     */
    public void handleEntry(PaperStore.Entry entry);
    
    /**
     * Called once after papers have been checked in.
     * @param success true if all papers were checked in. false otherwise.
     */
    public void checkinDone(boolean success);
}
