//LOC:109
package edu.gwu.blaise.version2.recognizer;

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL;
import java.util.*;
import javax.swing.*;
import javax.swing.BorderFactory.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.plaf.*;

/**
 * GestureCreator is used to create a gesture
 *
 * @author Sean T. Hanlon
 */
public class GestureCreator extends JDialog {

	JDialog thisDialog;			//this dialog
	Vector gesture;				//the gesture
	JPanel pane;				//the pane the gesture is drawn on
	boolean isDone = false;		//isDone flag

	//Initialize current x and y mouse position
	int current_x = 0;
	int current_y = 0;

	/**
	 * Constructor
	 *
	 * @param parent The parent of this dialog
	 * @param name The name of the gesture
	 */
	public GestureCreator(JFrame parent, String name){
		super(parent, name, true);
		thisDialog = this;

		//Initialize pane
		pane = new JPanel();
		pane.setBackground(Color.WHITE);
		this.getContentPane().add(pane);

		//Add mouse listeners to pane to capture mouse movement
		pane.addMouseListener ( new MouseAdapter (){
			//When pressed initialize a new gesture
			public void mousePressed (MouseEvent m){
				pane.requestFocus();
				gesture = new Vector();
				int x = m.getX();
				int y = m.getY();
				current_x = x;
				current_y = y;
			}
		});

		pane.addMouseMotionListener (new MouseMotionAdapter () {
			//When dragged, capture and draw lines of gesture
		    public void mouseDragged (MouseEvent m){
		        pane.requestFocus();
		        int x = m.getX();
		        int y = m.getY();
		        Graphics2D g = (Graphics2D)pane.getGraphics();

				Line2D.Double line = new Line2D.Double((double)current_x, (double)current_y, (double)x, (double)y);
				g.draw(line);
				gesture.add(line);

		        current_x = x;
		        current_y = y;
		    }
	   	});

		pane.addMouseListener (new MouseAdapter () {
		    //When mouse up, mark as done and set as invisible
		    public void mouseReleased (MouseEvent m){
				isDone = true;
				thisDialog.setVisible(false);
			}
	    });

		setSize(500,500);
		setResizable(false);
		setVisible(true);
	}

	/**
	 * Returns if the gesture has been drawn
	 *
	 * @return <code>true</code> if the gesture is done begin created, false otherwise
	 */
	public boolean isDone(){
		return isDone;
	}

	/**
	 * Returns the gesture
	 *
	 * @return <code>Vector</code> of gesture
	 */
	public Vector getGesture(){
		this.dispose();
		return gesture;
	}
}