package edu.gwu.blaise.version2.tests;
import edu.gwu.blaise.version2.documents.*;
import java.io.*;
/**
 * A simple testing utility that allows you to load, view, and save
 * Bls files.
 * @author Michael Gaiman
 * @version 1 5/15/2004
 */
public class BlsTester {
    public static void main(String[] argv){
        String iFilename,oFilename;
        if(argv.length==0){
            System.out.print("Enter input filename for Bls file:");
            try{
                InputStreamReader isr = new InputStreamReader (System.in);
                LineNumberReader lr = new LineNumberReader (isr);
                iFilename=lr.readLine();
                System.out.print("Enter output filename for Bls file:");
                oFilename=lr.readLine();
            }catch(IOException e){
                System.out.println(e);
                return;
            }
        }
        else if(argv.length==2){
            iFilename=argv[0];
            oFilename=argv[1];
        }
        else{
            System.out.println("Usage: java BlsTester [input filename][output filename]");
            return;
        }
        File jarFile=new File(iFilename);
        Blaise_Paper paper=new Blaise_Paper();
        BasicFileHandler handler=new BackendFileHandler();
        //BasicFileHandler handler=new ClientFileHandler();
        final BlaiseFile bf=new BlaiseFile(paper,jarFile,handler);
        
        System.out.println("Opening File...");
        Thread openT=new Thread(new Runnable(){
            public void run(){
                try{
                    bf.openPaper();
                }catch(IOException e){
                    e.printStackTrace();
                    System.exit(0);
                }
            }
        });
        openT.start();
        String n=null;
        int p=0;
        while(bf.getProgress()<1000){
            if(p!=bf.getProgress() || n!=bf.getNote()){
                p=bf.getProgress();
                n=bf.getNote();
                System.out.println(p+": "+n);
            }
            try{
                Thread.sleep(1);
            }catch(InterruptedException e){}
        }
        
        System.out.println("Paper:");
        paper.print();
        
        /*try{
            //COMMENT OUT ONE OF THE TWO FOLLOWING BLOCKS:
            
            System.out.println("Saving paper to byte array...");
            byte[] ba=BlaiseFile.paperToByteArray(paper);
            System.out.println("byte array is "+ba.length+" bytes");
            System.out.println("Converting bytes back to paper...");
            Blaise_Paper baP=BlaiseFile.byteArrayToPaper(ba);
            System.out.println("Paper:");
            baP.print();
            
            System.out.println("Saving paper to file via stream methods...");
            BlaiseFile.paperToOutputStream(paper,new FileOutputStream(new File(oFilename)));
            System.out.println("done.\nOpening paper via stream methods...");
            Blaise_Paper isP=BlaiseFile.inputStreamToPaper(new FileInputStream(new File(oFilename)));
            System.out.println("The paper:");
            isP.print();
        }catch(IOException e){
            e.printStackTrace();
        }*/
        
        System.out.println("Saving File...");
        bf.newJob(paper,new File(oFilename),handler);
        Thread saveT=new Thread(new Runnable(){
            public void run(){
                try{
                    bf.savePaper();
                }catch(IOException e){
                    e.printStackTrace();
                    System.exit(0);
                }
            }
        });
        saveT.start();
        p=0;
        while(bf.getProgress()<1000){
            if(p!=bf.getProgress() || n!=bf.getNote()){
                p=bf.getProgress();
                n=bf.getNote();
                System.out.println(p+": "+n);
            }
            try{
                Thread.sleep(1);
            }catch(InterruptedException e){}
        }
        
        
        //delete the dir structure.
        /*try{
            ((ClientFileHandler)handler).closePaper();
        }catch(IOException e){
            e.printStackTrace();
            System.exit(0);
        }*/
    }
}
