package edu.gwu.blaise.version2.level1tests;
import edu.gwu.blaise.version2.transmission.*;
import edu.gwu.blaise.version2.util.*;
import edu.gwu.blaise.version2.documents.*;
import java.util.*;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.IOException;
import java.io.*;
/**
 * Performs a series of connectivity tests to determine the state of operation of the backend.
 * 
 * @author Michael Gaiman
 * @version 1 July 28, 2003
 */
public class GraderTester {
    //dumbledore's login data
    static final String dUserName="albus";
    static final String dPassword="hogwarts";
    static final String dUID="1";
    //McGonnagal login data
    static final String mUserName="McGon";
    static final String mPassword="transfigure";
    static final String mUID="1";
    //Lupin login data
    static final String lUserName="moony";
    static final String lPassword="wolf";
    static final String lUID="1";
    
    private static GraderLoginQuery glq;
    
    static public void main(String[] argv){
        int command=0;
        boolean trans;
        
        while (true){
            printMenu(1);
            command=getCommand();
            switch(command){
                case 1:
                    //login as dumbledore
                    System.out.println("Logging into system as Albus Dumbledore...");
                    if(TransmissionHandler.isOnline()){
                        glq=TransmissionHandler.getGraderLogin(dUserName,dPassword,dUID);
                        trans=glq.transmit();
                        if(!trans){//failure of some sort
                            printError(glq);
                            break;
                        }
                    }else{
                        System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                        break;
                    }
                    command=0;
                    while(true){
                        printMenu(2);
                        command=getCommand();
                        if(command==0){
                            break;//back to main menu
                        }
                        handleGraderMenu(command);
                    }
                    break;
                case 2:
                    //login as Minerva
                    System.out.println("Logging into system as Minerva McGonagall...");
                    if(TransmissionHandler.isOnline()){
                        glq=TransmissionHandler.getGraderLogin(mUserName,mPassword,mUID);
                        trans=glq.transmit();
                        if(!trans){//failure of some sort
                            printError(glq);
                            break;
                        }
                    }else{
                        System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                        break;
                    }
                    command=0;
                    while(true){
                        printMenu(3);
                        command=getCommand();
                        if(command==0){
                            break;//back to main menu
                        }
                        handleGraderMenu(command);
                    }
                    break;
                case 3:
                    //login as Minerva
                    System.out.println("Logging into system as Remus Lupin...");
                    if(TransmissionHandler.isOnline()){
                        glq=TransmissionHandler.getGraderLogin(lUserName,lPassword,lUID);
                        trans=glq.transmit();
                        if(!trans){//failure of some sort
                            printError(glq);
                            break;
                        }
                    }else{
                        System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                        break;
                    }
                    command=0;
                    while(true){
                        printMenu(6);
                        command=getCommand();
                        if(command==0){
                            break;//back to main menu
                        }
                        handleGraderMenu(command);
                    }
                    break;
                case 4:
                    //exit
                    return;
                    //break; //unreachable due to the return
                default:
                    System.out.println("Invalid menu choice");
                    break;
            }
        }
    }

    /**
     * Prints a menu to the screen.
     * @param menuNum which menu should be printed.
     * 1)The Main Menu
     * 2)Dumbledore's menu items
     * 3)McGonagall's menu items
     * 4)Error menu items
     * 5)View or Save downloaded paper
     * 6)Lupin's menu items
     */
    static private void printMenu(int menuNum){
        switch(menuNum){
            case 1:
                System.out.println("Main Menu ----------------------------------------------------------------------");
                System.out.println("  1) Login as Albus Dumbledore");
                System.out.println("  2) Login as Minerva McGonagall");
                System.out.println("  3) Login as Remus Lupin");
                System.out.println("  4) Exit");
                break;
            case 2:
                System.out.println("-- Albus Dumbledore Menu -------------------------------------------------------");
                System.out.println("    0) Previous Menu");
                System.out.println("    1) Display Grader Information");
                System.out.println("    2) Display Dumbledore's Courses");
                System.out.println("    3) Display all papers for Dumbledore (header only)");
                System.out.println("    4) Display ungraded papers for Dumbledore (header only)");
                System.out.println("    5) Display papers for Dumbledore to view only (full paper)");
                System.out.println("    6) Checkout an ungraded paper as Dumbledore");
                System.out.println("    7) Checkin a graded paper as Dumbledore");
                System.out.println("    8) Send a graded paper to the staging table");
                System.out.println("    9) Flush the staging table");
                break;
            case 3:
                System.out.println("-- Minerva McGonagall Menu -----------------------------------------------------");
                System.out.println("    0) Previous Menu");
                System.out.println("    1) Display Grader Information");
                System.out.println("    2) Display McGonagall's Courses");
                System.out.println("    3) Display all papers for McGonagall (header only)");
                System.out.println("    4) Display ungraded papers for McGonagall (header only)");
                System.out.println("    5) Display papers for McGonagall to view only (full paper)");
                System.out.println("    6) Checkout an ungraded paper as McGonagall");
                System.out.println("    7) Checkin a graded paper as McGonagall");
                System.out.println("    8) Send a graded paper to the staging table");
                System.out.println("    9) Flush the staging table");
                break;
            case 4:
                System.out.println("Error Menu ---------------------------------------------------------------------");
                System.out.println("  0) Previous Menu");
                System.out.println("  1) Display Full Error Body");
                System.out.println("  2) Exit");
                break;
            case 5:
                System.out.println("---- Download Paper Menu -------------------------------------------------------");
                System.out.println("      0) Previous Menu");
                System.out.println("      1) Display Downloaded Paper");
                System.out.println("      2) Save Downloaded Paper");
                break;
            case 6:
                System.out.println("-- Remus Lupin Menu ------------------------------------------------------------");
                System.out.println("    0) Previous Menu");
                System.out.println("    1) Display Grader Information");
                System.out.println("    2) Display Lupin's Courses");
                System.out.println("    3) Display all papers for Lupin (header only)");
                System.out.println("    4) Display ungraded papers for Lupin (header only)");
                System.out.println("    5) Display papers for Lupin to view only (full paper)");
                System.out.println("    6) Checkout an ungraded paper as Lupin");
                System.out.println("    7) Checkin a graded paper as Lupin");
                System.out.println("    8) Send a graded paper to the staging table");
                System.out.println("    9) Flush the staging table");
                break;
            default:
                break;
        }
    }
    
    /**
     * Prompts for an input, and gets that input
     * @return the number input
     */
    static private int getCommand(){
        InputStreamReader isr = new InputStreamReader (System.in);
        LineNumberReader lr = new LineNumberReader (isr);
        String inputLine;
        while(true){
            System.out.print("Please enter your command choice:");
            try{
                inputLine = lr.readLine ();
                return Integer.parseInt(inputLine);
            }catch(IOException e){
                System.out.println(e);
            }catch(NumberFormatException e){
                System.out.println("Invalid menu choice");
            }
        }
    }
    
    /**
     * Displays a message into the screen and then prompts for an answer.
     * @param s the message to display
     * @return the answer
     */
    static private String prompt(String s){
        System.out.print(s);
        InputStreamReader isr = new InputStreamReader (System.in);
        LineNumberReader lr = new LineNumberReader (isr);
        try{
            return lr.readLine();
        }catch(IOException e){
            System.out.println(e);
            return null;
        }
    }
    
    /**
     * It will print any message provided onto the screen
     */
    static private void printError(TransmissionQuery tq){
        System.out.println("A failure occurred.  Failure:"+tq.getMessage());
        int command;
        while(true){
            printMenu(4);
            command=getCommand();
            switch(command){
                case 0:
                    return;
                case 1:
                    System.out.println("-- Full Response Body ----------------------------------------------------------");
                    System.out.println(tq.getFullText());
                    break;
                case 2:
                    System.exit(0);
                    break;
                default:
                    System.out.println("Invalid menu choice");
                    break;
            }
        }
    }
    
    /**
     * Performs a paper search query and returns headers.
     * @param ungradedOnly Should it be limited to ungraded papers?
     * @return Vector of Blaise_Paper objects or null if error.
     */
    static private Vector getHeaders(boolean ungradedOnly){
        System.out.println("Downloading paper Headers...");
        if(TransmissionHandler.isOnline()){
            PaperSearchQuery psq=TransmissionHandler.getPaperSearch(ungradedOnly,null,null,null,null,TransmissionHandler.GRADER_TYPE,null,null,null);
//exception is thrown in next line
            boolean trans=psq.transmit();
            if(!trans){//failure of some sort
                printError(psq);
                return null;
            }
            return psq.getPapers();
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return null;
        }
    }
    
    /**
     * Performs a Get Paper Query and returns the papers.
     * @param pIDs a Vector containing the paperIDs in Long form
     * @return a Vector of Blaise_Paper objects
     */
    static private Vector getPapers(Vector pIDs){
        if(TransmissionHandler.isOnline()){
            PaperDownloadQuery pdq=TransmissionHandler.getPaperDownload(pIDs,TransmissionHandler.GRADER_TYPE);
            boolean trans=pdq.transmit();
            if(!trans){//failure of some sort
                printError(pdq);
                return null;
            }
            return pdq.getPapers();
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return null;
        }
    }
    
    /**
     * Handle the output of whatever level 2/3 (Dumbledore or McGonagall) choice the user chooses.
     * @param command The user's menu choice
     */
    static private void handleGraderMenu(int command){
        Vector v;
        Blaise_Paper bp;
        BlaiseFile bf;
        switch(command){
            case 0:
                break;
            case 1:
                System.out.println("---- Grader --------------------------------------------------------------------");
                Grader g=glq.getGrader();
                System.out.println("      graderID:"+g.getGraderID());
                System.out.println("      creationDate:"+g.getCreationDate());
                System.out.println("      universityID:"+g.getUniversityID());
                System.out.println("      firstName:"+g.getFirstName());
                System.out.println("      lastName:"+g.getLastName());
                System.out.println("      userName:"+g.getUserName());
                System.out.println("      email:"+g.getEmail());
                System.out.println("      status:"+g.getStatus());
                System.out.println("      similarityCheckedDate:"+g.getSimilarityCheckedDate());
                
                break;
            case 2:
                System.out.println("---- Courses -------------------------------------------------------------------");
                v=glq.getCourses();
                Course c;
                for(int i=0;i<v.size();i++){
                    c=(Course)v.get(i);
                    System.out.println("      Course "+(i+1));
                    System.out.println("        courseID:"+c.getCourseID());
                    System.out.println("        contactInfo:"+c.getContactInfo());
                    System.out.println("        universityID:"+c.getUniversityID());
                    System.out.println("        dept:"+c.getDept());
                    System.out.println("        number:"+c.getNumber());
                    System.out.println("        section:"+c.getSection());
                    System.out.println("        semester:"+c.getSemester());
                    System.out.println("        year:"+c.getYear());
                }
                break;
            case 3:
                v=getHeaders(false);
                if(v==null){
                    break;
                }
                for(int i=0;i<v.size();i++){
                    bp=(Blaise_Paper)v.get(i);
                    bp.print();
                }
                break;
            case 4:
                v=getHeaders(true);
                if(v==null){
                    break;
                }
                for(int i=0;i<v.size();i++){
                    bp=(Blaise_Paper)v.get(i);
                    bp.print();
                }
                break;
            case 5:
                String pID;
                while(true){
                    pID=prompt("Enter PaperID of Paper to download:");
                    try{
                        Long l=new Long(pID);
                        v=new Vector();
                        v.add(l);
                        break;
                    }catch(NumberFormatException e){
                        System.out.println("Invalid PaperID");
                    }
                }
                v=getPapers(v);
                if(v==null){
                    break;
                }
                //now check to see if they want to view or save the document.
                while(true){
                    printMenu(5);
                    int com=getCommand();
                    switch(com){
                        case 0:
                            return;
                            //break; <unreachable>
                        case 1:
                            for(int i=0;i<v.size();i++){
                                bp=(Blaise_Paper)v.get(i);
                                bp.print();
                            }
                            break;
                        case 2:
                            String filename=prompt("Enter the filename:");
                            if(v.size()==1){
                              bp=(Blaise_Paper)v.firstElement();
                              bf=new BlaiseFile(bp, new File(filename), new BackendFileHandler());
                              System.out.println("Saving file...");
                              try{
                                  bf.savePaper();
                              }catch(IOException e){
                                  System.out.println("Error occurred while saving the paper: "+e);
                              }
                            }
                            //I don't think this if/else statement is necessary, because I don't see how multiple papers could
                            //be entered in here
                            else{
                                System.out.println("Saving "+v.size()+" papers.");
                                //these two instructions aren't useful, but they are done to prevent the creation of
                                //multiple BlaiseFiles in the for loop
                                bp=(Blaise_Paper)v.firstElement();
                                bf=new BlaiseFile(bp, new File(filename), new BackendFileHandler());
                                for(int i=0;i<v.size();i++){
                                    bp=(Blaise_Paper)v.get(i);
                                    bf.newJob(bp, new File(filename+(i+1)), new BackendFileHandler());
                                    try{
                                        bf.savePaper();
                                    }catch(IOException e){
                                        System.out.println("Error occurred while saving the paper: "+e);
                                    }
                                }
                            }
                            break;
                        default:
                            System.out.println("Invalid menu choice");
                            break;
                    }
                }
                //break; <unreachable>
            case 6:
                doCheckout();
                break;
            case 7:
                doCheckin();
                break;
            case 8:
                doStaging();
                break;
            case 9:
                doFlush();
                break;
            default:
                System.out.println("Invalid menu choice");
                break;
        }
    }
    
    /**
     * Prompts for paperIDs and then checks out those papers, then prompts for a file to save to,
     * and then saves them.
     */
    private static void doCheckout(){
        System.out.println("---- Checkout Papers Menu ------------------------------------------------------");
        System.out.print("Please enter paperIDs, one paperID per line.  When finished type -1:");
        Vector pIDs=new Vector();
        String s;
        Long l;
        while(true){
            s=prompt("");
            try{
                l=new Long(s);
                if(l.intValue()==-1){
                    break;
                }
                pIDs.add(l);
            }catch(NumberFormatException e){
                System.out.println("Invalid paperID.");
                System.out.print("Please enter paperIDs, one paperID per line.  When finished type -1:");
            }
        }
        if(pIDs.isEmpty()){
            System.out.println("No paperIDs entered.");
            return;
        }
        System.out.println("Checking out papers...");
        
        CheckOutPapersQuery cpq=TransmissionHandler.getCheckOutPapers(pIDs,TransmissionHandler.GRADER_TYPE);
        if(TransmissionHandler.isOnline()){
            boolean trans=cpq.transmit();
            if(!trans){//failure of some sort
                printError(cpq);
                return;
            }
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return;
        }
        
        Vector papers=cpq.getPapers();
        
        String filename=prompt("Checkout successful.\nPlease enter a filename to save papers into:");
        //saves the group of papers into BlaiseFiles with the same name and numbers appended to the end
        Blaise_Paper bp;
        for(int i=0;i<papers.size();i++){
            bp=(Blaise_Paper)papers.get(i);
            BlaiseFile bf=new BlaiseFile(bp, new File(filename+(i+1)), new BackendFileHandler());
            try{
                bf.savePaper();
            }catch(IOException e){
                System.out.println("Error occurred while saving the paper: "+e);
            }
        }
        System.out.println("Papers have been saved.");
    }
    
    /**
     * Checks in graded papers to the server.
     */
    private static void doCheckin(){
        System.out.println("--- CheckIn Papers Menu --------------------------------------------------------");
        String filename=prompt("Please enter the filename of the graded papers file:");
        BlaiseFile bf = new BlaiseFile(new Blaise_Paper(), new File(filename), new BackendFileHandler());
        try{
            bf.openPaper();
        }catch(IOException e){
            System.out.println("Error occurred while opening the paper: "+e);
        }
        Vector papers=new Vector();
        papers.add(bf.getPaper());
        if(papers.isEmpty()){
            System.out.println("Invalid papers in file");
            return;
        }
        TransmissionQuery cpq;
        Blaise_Paper bp;
        boolean trans;
        for(int i=0;i<papers.size();i++){
            bp=(Blaise_Paper)papers.get(i);
            System.out.println("Checking in paper with paperID:"+bp.getPaperID());
            cpq=TransmissionHandler.getCheckInPapers(bp,TransmissionHandler.GRADER_TYPE);
            if(TransmissionHandler.isOnline()){
                trans=cpq.transmit();
                if(!trans){//failure of some sort
                    printError(cpq);
                    return;
                }
            }else{
                System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                return;
            }
            System.out.println("Check in was successful for paper with paperID:"+bp.getPaperID());
        }
    }

    /**
     * Checks in graded papers to the staging table.
     */
    private static void doStaging(){
        System.out.println("--- Stage Papers Menu --------------------------------------------------------");
        String filename=prompt("Please enter the filename of the graded papers file:");
        BlaiseFile bf = new BlaiseFile(new Blaise_Paper(), new File(filename), new BackendFileHandler());
        try{
            bf.openPaper();
        }catch(IOException e){
            System.out.println("Error occurred while opening the paper: "+e);
        }
        Vector papers=new Vector();
        papers.add(bf.getPaper());
        if(papers.isEmpty()){
            System.out.println("Invalid papers in file");
            return;
        }
        TransmissionQuery spq;
        Blaise_Paper bp;
        boolean trans;
        for(int i=0;i<papers.size();i++){
            bp=(Blaise_Paper)papers.get(i);
            System.out.println("Staging in paper with paperID:"+bp.getPaperID());
            spq=TransmissionHandler.getStagePapers(bp,TransmissionHandler.GRADER_TYPE);
            if(TransmissionHandler.isOnline()){
                trans=spq.transmit();
                if(!trans){//failure of some sort
                    printError(spq);
                    return;
                }
            }else{
                System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                return;
            }
            System.out.println("Staging was successful for paper with paperID:"+bp.getPaperID());
        }
    }
    
    /** 
     * Flushes the staging table, sending out all of the papers in it for the specified courses
     */
    private static void doFlush(){
        System.out.println("---- Send Staged Papers Menu ------------------------------------------------------");
        System.out.print("Please enter courseIDs, one courseID per line.  When finished type -1:");
        Vector pIDs=new Vector();
        String s;
        Long l;
        while(true){
            s=prompt("");
            try{
                l=new Long(s);
                if(l.intValue()==-1){
                    break;
                }
                pIDs.add(l);
            }catch(NumberFormatException e){
                System.out.println("Invalid courseID.");
                System.out.print("Please enter courseIDs, one courseID per line.  When finished type -1:");
            }
        }
        if(pIDs.isEmpty()){
            System.out.println("No courseIDs entered.");
            return;
        }
        System.out.println("Sending staged papers...");
        
        TransmissionQuery sspq=null;
        sspq=TransmissionHandler.getSendStagedPapers(pIDs, TransmissionHandler.GRADER_TYPE);
        if(TransmissionHandler.isOnline()){
            boolean trans=sspq.transmit();
            if(!trans){//failure of some sort
                printError(sspq);
                return;
            }
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return;
        }
        System.out.println("Sending of staged papers was successful");
    }
}
