package edu.gwu.blaise.version2.level1tests;
import java.net.*;
import java.io.*;
import java.util.*;
/**
 *  File: LoadTest.java
 *  Tests the load of a website by calling it many times.
 *  @Author: Michael Gaiman
 */
public class LoadTest {
  static final int NUM=100;
  static String[] sPool=new String[NUM];
  static int numReturn=0;
  public static void main (String[] argv)
  {
    for(int i=0; i<NUM;i++){
        new Thread(new GetPage(i)).start();
    }
    try{
        Thread.sleep(1000);
    }catch(InterruptedException e){}
  }
  
  static public synchronized void setString(int i,String s){
    sPool[i]=s;
    numReturn++;
    if(numReturn==NUM){
        for(int j=0;j<NUM;j++){
            System.out.println("Try: "+j);
            System.out.println(sPool[j]);
        }
    }
  }
}

class GetPage implements Runnable{
    StringBuffer sb=new StringBuffer();
    String stri=null;
    int i;
    public GetPage(int i){
        this.i=i;
    }
    public void run(){
        try {
            // Open a socket to a known webserver.  
            Socket soc = new Socket ("localhost", 8080);
            InetAddress remote_machine = soc.getInetAddress();
            sb.append ("Connection made to " + remote_machine + "\n");
            
            // Now create the output and input streams  
            OutputStream out_stream = soc.getOutputStream ();
            PrintWriter pw = new PrintWriter (out_stream);
            InputStream in_stream = soc.getInputStream();
            InputStreamReader isr = new InputStreamReader (in_stream);
            LineNumberReader lnr = new LineNumberReader (isr);
        
            // Ask for the index.html page.  
            stri=getGet();
            sb.append(stri);
            pw.print (stri);
            pw.print("\r\n");
            pw.flush ();
        
            // Get the page.  
            String s = lnr.readLine ();
            while (s != null) {
                sb.append (s+"\n");
                s = lnr.readLine ();
            }
        
            // Close the streams.  
            pw.close ();
            lnr.close ();
            soc.close ();
        }
        catch (IOException e) { System.out.println (e); }
        finally{
            LoadTest.setString(i,sb.toString());
        }
    }

    public static String getGet(){
        StringBuffer st=new StringBuffer("GET /blaise/");

        Random r=new Random();
        int i=10;
        i=r.nextInt(8);
        
        //do writer commands most often
        if(i<=4){
            st.append("Writer?passCode=3&version=2&");
            i=r.nextInt(25);
            switch(i){
                case 0:
                    st.append("myUserName=potter&myUniversityID=1&myEPass=345498686_206745417_536654610_1507986513_1543390805_1135477282_765468594_-1861922199_-120632956_698018118&writerID=1&");
                    break;
                case 1:
                    st.append("myUserName=hg&myUniversityID=1&myEPass=-1859049650_856563455_858731259_1614222179_67073958_-845312587&writerID=2&");
                    break;
                case 2:
                    st.append("myUserName=ron&myUniversityID=1&myEPass=895893921_14370061_2100115789_1335236291_-867473858_-1444922755_-1325211982_-299847961&writerID=3&");
                    break;
                case 3:
                    st.append("myUserName=draco&myUniversityID=1&myEPass=-1717725394_-474977010_1051590336_-415937329&writerID=4&");
                    break;
                case 4:
                    st.append("myUserName=brat&myUniversityID=2&myEPass=-2099679770_1690430062_82605240_120660082_1704190181_-253270844&writerID=5&");
                    break;
                case 5:
                    st.append("myUserName=thrillhouse&myUniversityID=2&myEPass=-486822064_-667787946_2060697026_603482168_-1616253567_-1876318034_-32744572_-1100207526&writerID=6&");
                    break;
                case 6:
                    st.append("myUserName=lewis&myUniversityID=2&myEPass=17674127_1281755937_1357981267_1392557415_1748281728_1469723822_-1735686732_2067673744_-676829340_-1713571857_1076924742_-1521746365&writerID=7&");
                    break;
                case 7:
                    st.append("myUserName=wendell&myUniversityID=2&myEPass=233090697_1709251616_-1164566358_-1290943721&writerID=8&");
                    break;
                case 8:
                    st.append("myUserName=smartkid&myUniversityID=2&myEPass=517571585_1484319826_-7310688_1437139322_1979336165_1375702714&writerID=9&");
                    break;
                case 9:
                    st.append("myUserName=nelson&myUniversityID=2&myEPass=-2082479765_-1974134716_-2082479765_-1974134716&writerID=10&");
                    break;
                case 10:
                    st.append("myUserName=lisa&myUniversityID=2&myEPass=-1460162320_948857699_78167474_-603092929_-102859267_-812520401_367844627_-1305826233_621328566_-2054755760_1691109354_1489832244&writerID=11&");
                    break;
                case 11:
                    st.append("myUserName=janey&myUniversityID=2&myEPass=2008504969_-2079083754_-1460162320_948857699_1748281728_1469723822_-1735686732_2067673744_-676829340_-1713571857_1076924742_-1521746365&writerID=12&");
                    break;
                case 12:
                    st.append("myUserName=ralf&myUniversityID=2&myEPass=-589979037_1729314321_825874210_-733976070_1956365421_-685096088&writerID=13&");
                    break;
                case 13:
                    st.append("myUserName=jimbo&myUniversityID=2&myEPass=1252330806_-813923368_621328566_-2054755760_1622291620_-1439973773&writerID=14&");
                    break;
                case 14:
                    st.append("myUserName=kearny&myUniversityID=2&myEPass=1252330806_-813923368_621328566_-2054755760_1622291620_-1439973773&writerID=15&");
                    break;
                case 15:
                    st.append("myUserName=lovejoy&myUniversityID=2&myEPass=-1913016759_-114515894_145698288_1892682791_-2086525235_1771028102&writerID=16&");
                    break;
                case 16:
                    st.append("myUserName=rod&myUniversityID=2&myEPass=-1869705037_887535701_-1557497819_-176496492_1691109354_1489832244&writerID=17&");
                    break;
                case 17:
                    st.append("myUserName=todd&myUniversityID=2&myEPass=-146610144_1072578464_769129860_1405365631_-32744572_-1100207526&writerID=18&");
                    break;
                case 18:
                    st.append("myUserName=sheri&myUniversityID=2&myEPass=1549194446_-935168920_-1748242532_-69704168_1979336165_1375702714&writerID=19&");
                    break;
                case 19:
                    st.append("myUserName=terri&myUniversityID=2&myEPass=-1419829315_-405145110_286943264_-661935793&writerID=20&");
                    break;
                case 20:
                    st.append("myUserName=dolph&myUniversityID=2&myEPass=-1011441217_19882674_1857571565_-1088525768&writerID=21&");
                    break;
                case 21:
                    st.append("myUserName=uter&myUniversityID=2&myEPass=-368110087_-105235313_-1323041624_558854938_536654610_1507986513&writerID=22&");
                    break;
                case 22:
                    st.append("myUserName=allison&myUniversityID=2&myEPass=777914918_-1658318875_-1417895799_349872736_980601173_244242865_-1038471255_180980065&writerID=23&");
                    break;
                case 23:
                    st.append("myUserName=alexis&myUniversityID=2&myEPass=367844627_-1305826233_-1701932341_-949794706_-867473858_-1444922755&writerID=24&");
                    break;
                case 24:
                    st.append("myUserName=earl&myUniversityID=1&myEPass=323e4&writerID=1&");
                    break;
            }
        }else if(i<=7){
            st.append("Grader?passCode=2&version=2&");
            i=r.nextInt(14);
            switch(i){
                case 0:
                    st.append("myUserName=albus&myUniversityID=1&myEPass=-159587882_930069002_-1553733051_-792364935_935387422_-1336214516_-1925722685_1366756611&graderID=1&");
                    break;
                case 1:
                    st.append("myUserName=McGon&myUniversityID=1&myEPass=1747907943_607436967_777914918_-1658318875_1748281728_1469723822_383803544_-101593676_1398757310_-2054846949_1691109354_1489832244&graderID=2&");
                    break;
                case 2:
                    st.append("myUserName=moony&myUniversityID=1&myEPass=372931572_1597876972_721828807_-1166255815&graderID=3&");
                    break;
                case 3:
                    st.append("myUserName=snape&myUniversityID=1&myEPass=1625145378_1530692693_-7310688_1437139322_621328566_-2054755760_-32744572_-1100207526&graderID=4&");
                    break;
                case 4:
                    st.append("myUserName=krabappel&myUniversityID=2&myEPass=286943264_-661935793_74856566_-2126262810_-1276865540_-701860367_-1859049650_856563455_1979336165_1375702714&graderID=5&");
                    break;
                case 5:
                    st.append("myUserName=hoover&myUniversityID=2&myEPass=1120982785_1855011705_286943264_-661935793_-1164566358_-1290943721_-1505790182_-1245754896&graderID=6&");
                    break;
                case 6:
                    st.append("myUserName=skinner&myUniversityID=2&myEPass=233090697_1709251616_-1859049650_856563455&graderID=7&");
                    break;
                case 7:
                    st.append("myUserName=music&myUniversityID=2&myEPass=1747907943_607436967_1144951757_282978850_-1649481981_-82910789_199094680_2045230061_-1505790182_-1245754896&graderID=8&");
                    break;
                case 8:
                    st.append("myUserName=substitute&myUniversityID=2&myEPass=-1091206567_1585796785_-1616253567_-1876318034_-1268165479_-611104948&graderID=9&");
                    break;
                case 9:
                    st.append("myUserName=glascock&myUniversityID=2&myEPass=345498686_206745417_2112987951_-1845106499&graderID=10&");
                    break;
                case 10:
                    st.append("myUserName=tito&myUniversityID=2&myEPass=-1460162320_948857699_1309688984_-1182004711_1951407454_-295910081&graderID=11&");
                    break;
                case 11:
                    st.append("myUserName=jasper&myUniversityID=2&myEPass=722560813_1938164421_-996216671_729361764_1391169243_79630761_1257177159_-802846634&graderID=12&");
                    break;
                case 12:
                    st.append("myUserName=marge&myUniversityID=2&myEPass=17674127_1281755937_1357981267_1392557415_-449942924_-1637443405_1144951757_282978850&graderID=13&");
                    break;
                case 13:
                    st.append("myUserName=me&myUniversityID=1&myEPass=5&graderID=10&");
                    break;
            }
        }else{
            st.append("Admin?passcode=4&version=2&");
            i=r.nextInt(15);
            //put in an occasional failed login
            if(i==0){
                st.append("myUserName=nobody&");
            }else if(i<=7){
                st.append("myUserName=chalmers&myEPass=-159587882_930069002_1945799024_1608851218_1951407454_-295910081&myUniversityID=2&");
            }else{
                st.append("myUserName=hagrid&myEPass=-1859049650_856563455_1357981267_1392557415_286943264_-661935793_1199055435_-1604209590&myUniversityID=2&");
            }
        }   
        
        //make all commands have equal probability, even though not all types can do all commands
        i=r.nextInt(29);
        
        switch (i){
            case 0:
                st.append("command=getWriterID");
                break;
            case 1:
                st.append("command=getPaperID");
                break;
            case 4:
                st.append("command=getGraderID");
                break;
            case 5:
                st.append("command=getCourseID");
                break;
            case 6:
                st.append("command=getUniversityID");
                break;
            case 2:
                st.append("command=getAdminID");
                break;
            case 7:
                st.append("command=getCourseToGraderID");
                break;
            case 8:
                st.append("command=getCourseToWriterID");
                break;
            case 9:
                st.append("command=getCheckoutID");
                break;
            case 10:
                st.append("command=getEmailQueueID");
                break;
            case 11:
                st.append("command=getWriterAsGraderID");
                break;
            case 12:
                st.append("command=getAssignID");
                break;
            case 13:
                st.append("command=getDraftStructureID");
                break;
            case 14:
                st.append("command=getStagingID");
                break;
            case 15:
                st.append("command=getWriter");
                break;
            case 16:
                st.append("command=getGrader");
                break;
            case 17:
                st.append("command=getCourse");
                break;
            case 18:
                st.append("command=getUniversity");
                break;
            case 19:
                st.append("command=getAdmin");
                break;
            case 20:
                st.append("command=getCourseToGrader");
                break;
            case 21:
                st.append("command=getCourseToWriter");
                break;
            case 22:
                st.append("command=getCheckout");
                break;
            case 23:
                st.append("command=getEmailQueue");
                break;
            case 24:
                st.append("command=getWriterAsGrader");
                break;
            case 25:
                st.append("command=getAssignment");
                break;
            case 26:
                st.append("command=getDraftStructure");
                break;
            case 27:
                st.append("command=getStaging");
                break;
            case 28:
                st.append("command=getPaperUngradedID");
                break;
            case 3:
                break;
        }             
        st.append(" HTTP/1.0\r\n");
        return st.toString();
    }
}
