package edu.gwu.blaise.version2.tests;
import java.io.*;
import edu.gwu.blaise.version2.documents.*;
/**
 * Tests the ability of BlaiseFile to serialize Blaise_Comments and Blaise_Drafts
 * @author Michael Gaiman
 * @version 1 6/04/2004
 */
public class SerialTester {
    public static void main(String[] argv){
        //do blaise draft tests:
        Blaise_Draft draft=new Blaise_Draft();
        draft.setDraftID("123");
        draft.setPaperID("234");
        draft.setDraftNumber("1");
        draft.setTitle("My super duper draft");
        draft.setBody("<html><body>la la la</body></html>");
        draft.addExternalFile(new ExternalFile("template.bls",null,null,new File("template.bls")));
        
        System.out.println("Blaise Draft:");
        draft.print();
        
        System.out.println("saving to byte array");
        byte[] ba;
        try{
            ba=BlaiseFile.draftToByteArray(draft);
            System.out.println("done.\nByte array is "+ba.length+" bytes long.");
            
            System.out.println("saving draft to draft.jar");
            FileOutputStream fos=new FileOutputStream(new File("draft.jar"));
            BlaiseFile.draftToOutputStream(draft, fos);
            
            System.out.println("converting back byte array...");
            Blaise_Draft baDraft=BlaiseFile.byteArrayToDraft(ba);
            
            System.out.println("Blaise Draft:");
            baDraft.print();

        }catch(IOException e){
            e.printStackTrace();
            return;
        }
        
        Blaise_Comment comment=new Blaise_Comment();
        comment.setCommentID("978");
        comment.setPaperID("1256");
        comment.setGraderID("546");
        comment.setDraftID("751");
        comment.setGraderName("bob");
        //do blaise comment tests:
        System.out.println("Blaise Comment");
        comment.print();
        System.out.println("saving to byte array");
        try{
            ba=BlaiseFile.commentToByteArray(comment);
            System.out.println("done.\nByte array is "+ba.length+" bytes long.");
            
            System.out.println("saving comment to comment.jar");
            FileOutputStream fos=new FileOutputStream(new File("comment.jar"));
            BlaiseFile.commentToOutputStream(comment, fos);
            
            System.out.println("converting back byte array...");
            Blaise_Comment baComment=BlaiseFile.byteArrayToComment(ba);
            
            System.out.println("Blaise Comment:");
            baComment.print();

        }
        catch(IOException e){
            e.printStackTrace();
            return;
        }
    }
}
