package edu.gwu.blaise.version2.level1tests;
import edu.gwu.blaise.version2.transmission.*;
import edu.gwu.blaise.version2.util.*;
import edu.gwu.blaise.version2.documents.*;
import java.util.*;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.IOException;
import java.io.File;
/**
 * Performs a series of connectivity tests to determine the state of operation of the backend.
 * 
 * @author Michael Gaiman
 * @version 1 July 26, 2003
 */
public class WriterTester {
    //harry's login data
    static final String harryUserName="potter";
    static final String harryPassword="quidditch";
    static final String harryUID="1";
    //hermione's login data
    static final String hermioneUserName="hg";
    static final String hermionePassword="magic";
    static final String hermioneUID="1";
    //ron's login data
    static final String ronUserName="ron";
    static final String ronPassword="scabbers";
    static final String ronUID="1";
    //other's login data (input by user)
    static String otherUserName;
    static String otherPassword;
    static String otherUID;
    
    private static WriterLoginQuery wlq;
    
    static public void main(String[] argv){
        int command=0;
        boolean trans;
        
        while (true){
            printMenu(1);
            command=getCommand();
            switch(command){
                case 1:
                    //login as harry
                    System.out.println("Logging into system as Harry Potter...");
                    if(TransmissionHandler.isOnline()){
                        wlq=TransmissionHandler.getWriterLogin(harryUserName,harryPassword,harryUID);
                        trans=wlq.transmit();
                        if(!trans){//failure of some sort
                            printError(wlq);
                            break;
                        }
                    }else{
                        System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                        break;
                    }
                    command=0;
                    while(true){
                        printMenu(2);
                        command=getCommand();
                        if(command==0){
                            break;//back to main menu
                        }
                        handleWriterMenu(command);
                    }
                    break;
                case 2:
                    //login as hermione
                    System.out.println("Logging into system as Hermione Granger...");
                    if(TransmissionHandler.isOnline()){
                        wlq=TransmissionHandler.getWriterLogin(hermioneUserName,hermionePassword,hermioneUID);
                        trans=wlq.transmit();
                        if(!trans){//failure of some sort
                            printError(wlq);
                            break;
                        }
                    }else{
                        System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                        break;
                    }
                    command=0;
                    while(true){
                        printMenu(3);
                        command=getCommand();
                        if(command==0){
                            break;//back to main menu
                        }
                        handleWriterMenu(command);
                    }
                    break;
                case 3:
                    //login as hermione
                    System.out.println("Logging into system as Ronald Weasley...");
                    if(TransmissionHandler.isOnline()){
                        wlq=TransmissionHandler.getWriterLogin(ronUserName,ronPassword,ronUID);
                        trans=wlq.transmit();
                        if(!trans){//failure of some sort
                            printError(wlq);
                            break;
                        }
                    }else{
                        System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                        break;
                    }
                    command=0;
                    while(true){
                        printMenu(7);
                        command=getCommand();
                        if(command==0){
                            break;//back to main menu
                        }
                        handleWriterMenu(command);
                    }
                    break;
                case 4:
                    //login as Other
                    getOtherLoginInfo();
                    System.out.println("Logging into system as Other...");
                    if(TransmissionHandler.isOnline()){
                        wlq=TransmissionHandler.getWriterLogin(otherUserName,otherPassword,otherUID);
                        trans=wlq.transmit();
                        if(!trans){//failure of some sort
                            printError(wlq);
                            break;
                        }
                    }else{
                        System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                        break;
                    }
                    command=0;
                    while(true){
                        printMenu(8);
                        command=getCommand();
                        if(command==0){
                            break;//back to main menu
                        }
                        handleWriterMenu(command);
                    }
                    break;
                case 5:
                    //exit
                    return;
                    //break; //unreachable due to the return
                default:
                    System.out.println("Invalid menu choice");
                    break;
            }
        }
    }

    /**
     * Prints a menu to the screen.
     * @param menuNum which menu should be printed.
     * 1)The Main Menu
     * 2)Harry Potter's menu items
     * 3)Hermione Granger's menu items
     * 4)Error menu items
     * 5)View or Save downloaded paper
     * 6)Post paper submission options
     * 7)Ron's menu items
     * 8)Other's menu items
     */
    static private void printMenu(int menuNum){
        switch(menuNum){
            case 1:
                System.out.println("Main Menu ----------------------------------------------------------------------");
                System.out.println("  1) Login as Harry Potter");
                System.out.println("  2) Login as Hermione Granger");
                System.out.println("  3) Login as Ronald Weasley");
                System.out.println("  4) Login as Other");
                System.out.println("  5) Exit");
                break;
            case 2:
                System.out.println("-- Harry Potter Menu -----------------------------------------------------------");
                System.out.println("    0) Previous Menu");
                System.out.println("    1) Display Writer Information");
                System.out.println("    2) Display Harry's Courses");
                System.out.println("    3) Display Harry's papers (header only)");
                System.out.println("    4) Download Harry's papers (full paper)");
                System.out.println("    5) Submit a paper as Harry Potter");
                System.out.println("    6) Display Harry's papers to grade (header only)");
                System.out.println("    7) Display Harry's peer grading papers (header only)");
                System.out.println("    8) Check out a paper");
                System.out.println("    9) Check in a paper");
                break;
            case 3:
                System.out.println("-- Hermione Granger Menu -------------------------------------------------------");
                System.out.println("    0) Previous Menu");
                System.out.println("    1) Display Writer Information");
                System.out.println("    2) Display Hermione's Courses");
                System.out.println("    3) Display Hermione's papers (header only)");
                System.out.println("    4) Download Hermione's papers (full paper)");
                System.out.println("    5) Submit a paper as Hermione Granger");
                System.out.println("    6) Display Hermione's papers to grade (header only)");
                System.out.println("    7) Display Hermione's peer grading papers (header only)");
                System.out.println("    8) Check out a paper");
                System.out.println("    9) Check in a paper");
                break;
            case 4:
                System.out.println("Error Menu ---------------------------------------------------------------------");
                System.out.println("  0) Previous Menu");
                System.out.println("  1) Display Full Error Body");
                System.out.println("  2) Exit");
                break;
            case 5:
                System.out.println("---- Download Paper Menu -------------------------------------------------------");
                System.out.println("      0) Previous Menu");
                System.out.println("      1) Display Downloaded Paper");
                System.out.println("      2) Save Downloaded Paper");
                break;
            case 6:
                System.out.println("---- Post-Submission Menu ------------------------------------------------------");
                System.out.println("      0) Previous Menu");
                System.out.println("      1) Display Updated Paper(s)");
                System.out.println("      2) Save Updated Paper(s)");
                break;
            case 7:
                System.out.println("-- Ronald Weasley Menu ---------------------------------------------------------");
                System.out.println("    0) Previous Menu");
                System.out.println("    1) Display Writer Information");
                System.out.println("    2) Display Ron's Courses");
                System.out.println("    3) Display Ron's papers (header only)");
                System.out.println("    4) Download Ron's papers (full paper)");
                System.out.println("    5) Submit a paper as Ronald Weasley");
                System.out.println("    6) Display Ron's papers to grade (header only)");
                System.out.println("    7) Display Ron's peer grading papers (header only)");
                System.out.println("    8) Check out a paper");
                System.out.println("    9) Check in a paper");
                break;
            case 8:
                Writer w=wlq.getWriter();
                String otherName=(w.getFirstName())+" "+(w.getLastName());
                System.out.println("-- "+otherName+" Menu -----------------------------------------------------------");
                System.out.println("    0) Previous Menu");
                System.out.println("    1) Display Writer Information");
                System.out.println("    2) Display "+w.getFirstName()+"'s Courses");
                System.out.println("    3) Display "+w.getFirstName()+"'s papers (header only)");
                System.out.println("    4) Download "+w.getFirstName()+"'s papers (full paper)");
                System.out.println("    5) Submit a paper as "+otherName);
                System.out.println("    6) Display "+w.getFirstName()+"'s papers to grade (header only)");
                System.out.println("    7) Display "+w.getFirstName()+"'s peer grading papers (header only)");
                System.out.println("    8) Check out a paper");
                System.out.println("    9) Check in a paper");
                break;
            default:
                break;
        }
    }
    
    /**
     * Prompts for an input, and gets that input
     * @return the number input
     */
    static private int getCommand(){
        InputStreamReader isr = new InputStreamReader (System.in);
        LineNumberReader lr = new LineNumberReader (isr);
        String inputLine;
        while(true){
            System.out.print("Please enter your command choice:");
            try{
                inputLine = lr.readLine ();
                return Integer.parseInt(inputLine);
            }catch(IOException e){
                System.out.println(e);
            }catch(NumberFormatException e){
                System.out.println("Invalid menu choice");
            }
        }
    }
    
    /**
     * Displays a message into the screen and then prompts for an answer.
     * @param s the message to display
     * @return the answer
     */
    static private String prompt(String s){
        System.out.print(s);
        InputStreamReader isr = new InputStreamReader (System.in);
        LineNumberReader lr = new LineNumberReader (isr);
        try{
            return lr.readLine();
        }catch(IOException e){
            System.out.println(e);
            return null;
        }
    }
    
    /**
     * Asks the user for the username, password, and universityID for the write to login as.
     */
    static private void getOtherLoginInfo(){
        otherUserName=prompt("Enter username:");
        otherPassword=prompt("Enter password:");
        otherUID=prompt("Enter UniversityID:");
    }
    
    /**
     * Handle the output of whatever level 2/3 (harry or hermione) choice the user chooses.
     * @param command The user's menu choice
     */
    static private void handleWriterMenu(int command){
        Vector v;
        Blaise_Paper bp;
        BlaiseFile bf;
        switch(command){
            case 0:
                break;
            case 1:
                System.out.println("---- Writer --------------------------------------------------------------------");
                Writer w=wlq.getWriter();
                System.out.println("      writerID:"+w.getWriterID());
                System.out.println("      universityID:"+w.getUniversityID());
                System.out.println("      studentIdentifier:"+w.getStudentIdent());
                System.out.println("      firstName:"+w.getFirstName());
                System.out.println("      lastName:"+w.getLastName());
                System.out.println("      userName:"+w.getUserName());
                System.out.println("      email:"+w.getEmail());
                System.out.println("      userNameType:"+w.getUserNameType());
                System.out.println("      creationDate:"+w.getCreationDate());
                System.out.println("      writerAsGraderIDs:"+w.getWriterAsGraderIDs());
                break;
            case 2:
                System.out.println("---- Courses -------------------------------------------------------------------");
                v=wlq.getCourses();
                Course c;
                for(int i=0;i<v.size();i++){
                    c=(Course)v.get(i);
                    System.out.println("      Course "+(i+1));
                    System.out.println("        courseID:"+c.getCourseID());
                    System.out.println("        contactInfo:"+c.getContactInfo());
                    System.out.println("        universityID:"+c.getUniversityID());
                    System.out.println("        dept:"+c.getDept());
                    System.out.println("        number:"+c.getNumber());
                    System.out.println("        section:"+c.getSection());
                    System.out.println("        semester:"+c.getSemester());
                    System.out.println("        year:"+c.getYear());
                    System.out.println("        assignments:"+c.getAssignments());
                }
                break;
            case 3:
                v=getHeaders();
                if(v==null){
                    break;
                }
                for(int i=0;i<v.size();i++){
                    bp=(Blaise_Paper)v.get(i);
                    bp.print();
                }
                break;
            case 4:
                String pID;
                while(true){
                    pID=prompt("Enter PaperID of Paper to download:");
                    try{
                        Long l=new Long(pID);
                        v=new Vector();
                        v.add(l);
                        break;
                    }catch(NumberFormatException e){
                        System.out.println("Invalid PaperID");
                    }
                }
                v=getPapers(v);
                if(v==null){
                    break;
                }
                //now check to see if they want to view or save the document.
                while(true){
                    printMenu(5);
                    int com=getCommand();
                    switch(com){
                        case 0:
                            return;
                            //break; <unreachable>
                        case 1:
                            for(int i=0;i<v.size();i++){
                                bp=(Blaise_Paper)v.get(i);
                                bp.print();
                            }
                            break;
                        case 2:
                            String filename=prompt("Enter the filename:");
                            if(v.size()==1){
                              bp=(Blaise_Paper)v.firstElement();
                              bf=new BlaiseFile(bp, new File(filename), new BackendFileHandler());
                              System.out.println("Saving file...");
                              try{
                                  bf.savePaper();
                              }catch(IOException e){
                                  System.out.println("An exception occurred when trying to save the paper: "+e);
                              }
                            }
                            //I don't think this if/else statement is necessary, because I don't see how multiple papers could
                            //be entered in here
                            else{
                                System.out.println("Saving "+v.size()+" papers.");
                                //these two instructions aren't useful, but they are done to prevent the creation of
                                //multiple BlaiseFiles in the for loop
                                bp=(Blaise_Paper)v.firstElement();
                                bf=new BlaiseFile(bp, new File(filename), new BackendFileHandler());
                                for(int i=0;i<v.size();i++){
                                    bp=(Blaise_Paper)v.get(i);
                                    bf.newJob(bp, new File(filename+(i+1)), new BackendFileHandler());
                                    try{
                                      bf.savePaper();
                                    }catch(IOException e){
                                      System.out.println("An exception occurred when trying to save the paper: "+e);
                                    }
                                }
                            }
                            break;
                        default:
                            System.out.println("Invalid menu choice");
                            break;
                    }
                }
                //break; <unreachable>
            case 5:
                System.out.println("---- Submit Paper ----------------------------------------------------------");
                System.out.println("Please note: There is no error checking on this paper.  Please verify that the writerID, universityID, etc are valid and correct before submitting.");
                String filename=prompt("Enter the filename of the Blaise Paper to submit:");
                bf=new BlaiseFile(new Blaise_Paper(), new File(filename), new BackendFileHandler());
                System.out.println("Opening file...");
                try{
                    bf.openPaper();
                }catch(IOException e){
                    System.out.println("An exception occurred when trying to open the paper: "+e);
                }
                v=new Vector();
                v.add(bf.getPaper());
                v=submitPapers(v);
                if(v==null){
                    return;
                }
                while(true){
                    printMenu(6);
                    int com=getCommand();
                    switch(com){
                        case 0:
                            return;
                            //break; <unreachable>
                        case 1:
                            for(int i=0;i<v.size();i++){
                                bp=(Blaise_Paper)v.get(i);
                                bp.print();
                            }
                            break;
                        case 2:
                            filename=prompt("Enter the filename:");
                            if(v.size()==1){
                              bp=(Blaise_Paper)v.firstElement();
                              bf=new BlaiseFile(bp, new File(filename), new BackendFileHandler());
                              System.out.println("Saving file...");
                              try{
                                bf.savePaper();
                              }catch(IOException e){
                                System.out.println("An exception occurred when trying to save the paper: "+e);
                              }
                            }
                            //I don't think this if/else statement is necessary, because I don't see how multiple papers could
                            //be entered in here
                            else{
                                System.out.println("Saving "+v.size()+" papers.");
                                //these two instructions aren't useful, but they are done to prevent the creation of
                                //multiple BlaiseFiles in the for loop
                                bp=(Blaise_Paper)v.firstElement();
                                bf=new BlaiseFile(bp, new File(filename), new BackendFileHandler());
                                for(int i=0;i<v.size();i++){
                                    bp=(Blaise_Paper)v.get(i);
                                    bf.newJob(bp, new File(filename+(i+1)), new BackendFileHandler());
                                    try{
                                        bf.savePaper();
                                    }catch(IOException e){
                                        System.out.println("An exception occurred when trying to save the paper: "+e);
                                    }
                                }
                            }
                            break;
                        default:
                            System.out.println("Invalid menu choice");
                            break;
                    }
                }
                //break; <unreachable>
            case 6:
                v=getUngradedHeaders();
                if(v==null){
                    break;
                }
                for(int i=0;i<v.size();i++){
                    bp=(Blaise_Paper)v.get(i);
                    bp.print();
                }
                break;
            case 7:
                v=getWAGHeaders();
                if(v==null){
                    break;
                }
                for(int i=0;i<v.size();i++){
                    bp=(Blaise_Paper)v.get(i);
                    bp.print();
                }
                break;
            case 8:
                doCheckout();
                break;
            case 9:
                doCheckin();
                break;
            default:
                System.out.println("Invalid menu choice");
                break;
        }
    }
    
    /**
     * It will print any message provided onto the screen
     */
    static private void printError(TransmissionQuery tq){
        System.out.println("A failure occurred.  Failure:"+tq.getMessage());
        int command;
        while(true){
            printMenu(4);
            command=getCommand();
            switch(command){
                case 0:
                    return;
                case 1:
                    System.out.println("-- Full Response Body ----------------------------------------------------------");
                    System.out.println(tq.getFullText());
                    break;
                case 2:
                    System.exit(0);
                    break;
                default:
                    System.out.println("Invalid menu choice");
                    break;
            }
        }
    }
    
    /**
     * Performs a paper search query and returns headers.
     * @return Vector of Blaise_Paper objects or null if error.
     */
    static private Vector getHeaders(){
        System.out.println("Downloading paper Headers...");
        if(TransmissionHandler.isOnline()){
            PaperSearchQuery psq=TransmissionHandler.getPaperSearch(false,null,null,null,null,TransmissionHandler.WRITER_TYPE,null,null,null);
            boolean trans=psq.transmit();
            if(!trans){//failure of some sort
                printError(psq);
                return null;
            }
            return psq.getPapers();
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return null;
        }
    }

    /**
     * Performs a paper search query and returns headers of ungraded papers that the writer is to grade.
     * @return Vector of Blaise_Paper objects or null if error.
     */
    static private Vector getUngradedHeaders(){
        System.out.println("Downloading paper Headers...");
        if(TransmissionHandler.isOnline()){
            Writer w=wlq.getWriter();
            Vector wag=w.getWriterAsGraderIDs();
            PaperSearchQuery psq=TransmissionHandler.getPaperSearch(true,null,null,null,null,TransmissionHandler.WRITER_TYPE,wag,null,null);
            boolean trans=psq.transmit();
            if(!trans){//failure of some sort
                printError(psq);
                return null;
            }
            return psq.getPapers();
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return null;
        }
    }

    /**
     * Performs a paper search query and returns the heads of ungraded papers that the writer is to grade.
     * @return Vector of Blaise_Paper objects or null if error.
     */
    static private Vector getWAGHeaders(){
        System.out.println("Downloading paper Headers...");
        if(TransmissionHandler.isOnline()){
            Writer w=wlq.getWriter();
            Vector wag=w.getWriterAsGraderIDs();
            PaperSearchQuery psq=TransmissionHandler.getPaperSearch(false,null,null,null,null,TransmissionHandler.WRITER_TYPE,wag,null,null);
            boolean trans=psq.transmit();
            if(!trans){//failure of some sort
                printError(psq);
                return null;
            }
            return psq.getPapers();
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return null;
        }
    }
    
    /**
     * Performs a Get Paper Query and returns the papers.
     * @param pIDs a Vector containing the paperIDs in Long form
     * @return a Vector of Blaise_Paper objects
     */
    static private Vector getPapers(Vector pIDs){
        if(TransmissionHandler.isOnline()){
            PaperDownloadQuery pdq=TransmissionHandler.getPaperDownload(pIDs,TransmissionHandler.WRITER_TYPE);
            boolean trans=pdq.transmit();
            if(!trans){//failure of some sort
                printError(pdq);
                return null;
            }
            return pdq.getPapers();
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return null;
        }
    }
    
    /**
     * Performs 1 or more paper submissions.
     * @param papers A Vector of Blaise_Paper objects.
     * @return The Vector containing the updated paper states (with any new IDs).
     */
    static private Vector submitPapers(Vector papers){

        //if the paperset has multiple papers, submit them all (with more feed back to user)
        if(TransmissionHandler.isOnline()){
            SubmitPaperQuery spq;
            boolean trans;
            int size=papers.size();
            if(size>1){
                for(int i=0;i<size;i++){
                    System.out.println("Submitting paper #"+(i+1));
                    spq=TransmissionHandler.getSubmitPaper((Blaise_Paper)papers.get(i));
                    trans=spq.transmit();
                    if(!trans){//failure of some sort
                        printError(spq);
                        return null;
                    }
                    //get the updated paper.
                    papers.set(i,spq.getUpdatedPaper());
                }
            }
            else if(size==1){
                System.out.println("Submitting paper");
                spq=TransmissionHandler.getSubmitPaper((Blaise_Paper)papers.firstElement());
                trans=spq.transmit();
                if(!trans){//failure of some sort
                    printError(spq);
                    return null;
                }
                //get the updated paper.
                papers.set(0,spq.getUpdatedPaper());
            }
            else{
                System.out.println("Invalid paper");
                return null;
            }
            System.out.println("Paper submission complete");
            return papers;
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return null;
        }
    }
    
    /**
     * Prompts for paperIDs and then checks out those papers, then prompts for a file to save to,
     * and then saves them.
     */
    private static void doCheckout(){
        System.out.println("---- Checkout Papers Menu ------------------------------------------------------");
        System.out.print("Please enter paperIDs, one paperID per line.  When finished type -1:");
        Vector pIDs=new Vector();
        String s;
        Long l;
        while(true){
            s=prompt("");
            try{
                l=new Long(s);
                if(l.intValue()==-1){
                    break;
                }
                pIDs.add(l);
            }catch(NumberFormatException e){
                System.out.println("Invalid paperID.");
                System.out.print("Please enter paperIDs, one paperID per line.  When finished type -1:");
            }
        }
        if(pIDs.isEmpty()){
            System.out.println("No paperIDs entered.");
            return;
        }
        System.out.println("Checking out papers...");
        
        CheckOutPapersQuery cpq=TransmissionHandler.getCheckOutPapers(pIDs,TransmissionHandler.WRITER_TYPE);
        if(TransmissionHandler.isOnline()){
            boolean trans=cpq.transmit();
            if(!trans){//failure of some sort
                printError(cpq);
                return;
            }
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return;
        }
        
        Vector papers=cpq.getPapers();
        
        String filename=prompt("Checkout successful.\nPlease enter a filename to save papers into:");
        //saves the group of papers into BlaiseFiles with the same name and numbers appended to the end
        Blaise_Paper bp;
        for(int i=0;i<papers.size();i++){
            bp=(Blaise_Paper)papers.get(i);
            BlaiseFile bf=new BlaiseFile(bp, new File(filename+(i+1)), new BackendFileHandler());
            try{
                bf.savePaper();
            }catch(IOException e){
                System.out.println("Error occurred while saving the paper: "+e);
            }
        }
        System.out.println("Papers have been saved.");
    }
    
    /**
     * Checks in graded papers to the server.
     */
    private static void doCheckin(){
        System.out.println("--- CheckIn Papers Menu --------------------------------------------------------");
        String filename=prompt("Please enter the filename of the graded papers file:");
        BlaiseFile bf = new BlaiseFile(new Blaise_Paper(), new File(filename), new BackendFileHandler());
        try{
            bf.openPaper();
        }catch(IOException e){
            System.out.println("Error occurred while opening the paper: "+e);
        }
        Vector papers=new Vector();
        papers.add(bf.getPaper());
        if(papers.isEmpty()){
            System.out.println("Invalid papers in file");
            return;
        }
        TransmissionQuery cpq;
        Blaise_Paper bp;
        boolean trans;
        for(int i=0;i<papers.size();i++){
            bp=(Blaise_Paper)papers.get(i);
            System.out.println("Checking in paper with paperID:"+bp.getPaperID());
            cpq=TransmissionHandler.getCheckInPapers(bp,TransmissionHandler.WRITER_TYPE);
            if(TransmissionHandler.isOnline()){
                trans=cpq.transmit();
                if(!trans){//failure of some sort
                    printError(cpq);
                    return;
                }
            }else{
                System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                return;
            }
            System.out.println("Check in was successful for paper with paperID:"+bp.getPaperID());
        }
    }
    /**
     * Checks in graded papers to the staging table.
     */
    private static void doStaging(){
        System.out.println("--- Stage Papers Menu --------------------------------------------------------");
        String filename=prompt("Please enter the filename of the graded papers file:");
        BlaiseFile bf = new BlaiseFile(new Blaise_Paper(), new File(filename), new BackendFileHandler());
        try{
            bf.openPaper();
        }catch(IOException e){
            System.out.println("Error occurred while opening the paper: "+e);
        }
        Vector papers=new Vector();
        papers.add(bf.getPaper());
        if(papers.isEmpty()){
            System.out.println("Invalid papers in file");
            return;
        }
        TransmissionQuery spq;
        Blaise_Paper bp;
        boolean trans;
        for(int i=0;i<papers.size();i++){
            bp=(Blaise_Paper)papers.get(i);
            System.out.println("Staging in paper with paperID:"+bp.getPaperID());
            spq=TransmissionHandler.getStagePapers(bp,TransmissionHandler.WRITER_TYPE);
            if(TransmissionHandler.isOnline()){
                trans=spq.transmit();
                if(!trans){//failure of some sort
                    printError(spq);
                    return;
                }
            }else{
                System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
                return;
            }
            System.out.println("Staging was successful for paper with paperID:"+bp.getPaperID());
        }
    }
    
    /** 
     * Flushes the staging table, sending out all of the papers in it for the specified courses
     */
    private static void doFlush(){
        System.out.println("---- Send Staged Papers Menu ------------------------------------------------------");
        System.out.print("Please enter courseIDs, one courseID per line.  When finished type -1:");
        Vector pIDs=new Vector();
        String s;
        Long l;
        while(true){
            s=prompt("");
            try{
                l=new Long(s);
                if(l.intValue()==-1){
                    break;
                }
                pIDs.add(l);
            }catch(NumberFormatException e){
                System.out.println("Invalid courseID.");
                System.out.print("Please enter courseIDs, one courseID per line.  When finished type -1:");
            }
        }
        if(pIDs.isEmpty()){
            System.out.println("No courseIDs entered.");
            return;
        }
        System.out.println("Sending staged papers...");
        
        TransmissionQuery sspq=null;
        sspq=TransmissionHandler.getSendStagedPapers(pIDs, TransmissionHandler.WRITER_TYPE);
        if(TransmissionHandler.isOnline()){
            boolean trans=sspq.transmit();
            if(!trans){//failure of some sort
                printError(sspq);
                return;
            }
        }else{
            System.out.println("Could not connect to the internet.  Please check internet settings and try again.");
            return;
        }
        System.out.println("Sending of staged papers was successful");
    }
}
