package edu.gwu.blaise.version2.transmission;
import java.util.Date;
import java.util.Vector;
/**
 * An encapsulation of an assignment.
 * @author Jared Kiraly
 * @version 2 6/15/2004
 */
public class Assignment{
    private long assignID;
    private long courseID;
    private String name;
    private int numDrafts;
    private int assignNum;
    private Vector ds;
    
    public Assignment(long assignID,
                      long courseID,
                      String name,
                      int numDrafts,
                      int assignNum,
                      Vector ds){
        this.assignID=assignID;
        this.courseID=courseID;
        this.name=name;
        this.numDrafts=numDrafts;
        this.assignNum=assignNum;
        this.ds=ds;
    }
    
    public long getAssignID(){return assignID;}
    public long getcourseID(){return courseID;}
    public String name(){return name;}
    public int numDrafts(){return numDrafts;}
    public int assignNum(){return assignNum;}
    public Vector getDraftStructure(){return ds;}
    public void addDraftStructure(DraftStructure d){
        if(ds==null){
            ds=new Vector();
        }
        ds.add(d);
    }
    public void removeDraftStructure(DraftStructure d){
        if(ds!=null){
            ds.remove(d);
        }
    }
    public void setDraftStructure(Vector v){
        ds=v;
    }
        
    public String toString(){
        StringBuffer sb=new StringBuffer("Assignment(");
        sb.append("assignID:");
        sb.append(assignID);
        sb.append(" courseID:");
        sb.append(courseID);
        sb.append(" name:");
        sb.append(name);
        sb.append(" numDrafts:");
        sb.append(numDrafts);
        sb.append(" assignNum:");
        sb.append(assignNum);
        sb.append("DraftStructure:");
        for(int i=0;i<ds.size();i++){
            sb.append(ds.elementAt(i).toString());
        }
        sb.append(")");
        return sb.toString();
    }
}
