package edu.gwu.blaise.version2.transmission;
import java.util.Vector;
/**
 * An ecapulation of a course.
 * @author Michael Gaiman
 * @version 2 1/25/2004
 */
public class Course {
    private long courseID;
    private String contactInfo;
    private int universityID;
    private String dept; 
    private String number; 
    private String section;
    private String semester;
    private int year;
    private Vector assignments;
    private String isCurrent;
    
    public Course(long courseID,
                     String contactInfo,
                     int universityID,
                     String dept,
                     String number,
                     String section,
                     String semester,
                     int year,
                     Vector assignments,
                     String isCurrent){
        this.courseID=courseID;
        this.contactInfo=contactInfo;
        this.universityID=universityID;
        this.dept=dept;
        this.number=number;
        this.section=section;
        this.semester=semester;
        this.year=year;
        this.assignments=assignments;
        this.isCurrent=isCurrent;
    }
    
    public long getCourseID(){ return courseID;}
    public String getContactInfo(){ return contactInfo;}
    public int getUniversityID(){ return universityID;}
    public String getDept(){ return dept;}
    public String getNumber(){ return number;}
    public String getSection(){ return section;} 
    public String getSemester(){ return semester;}
    public int getYear(){ return year;}
    public Vector getAssignments(){return assignments;}
    
    public void addAssignment(Assignment a){
        if(assignments==null){
            assignments=new Vector();
        }
        assignments.add(a);
    }
    public void removeAssignment(Assignment a){
        assignments.removeElement(a);
    }
    
    public String getIsCurrent(){return isCurrent;}
    
    public String toString(){
        StringBuffer sb=new StringBuffer("Course(");
        sb.append("courseID:");
        sb.append(courseID);
        sb.append(" contactInfo:");
        sb.append(contactInfo);
        sb.append(" universityID:");
        sb.append(universityID);
        sb.append(" dept:");
        sb.append(dept);
        sb.append(" number:");
        sb.append(number);
        sb.append(" section:");
        sb.append(section);
        sb.append(" semester:");
        sb.append(semester);
        sb.append(" year:");
        sb.append(year);
        sb.append(" assignments:");
        sb.append(assignments);
        sb.append(" isCurrent:");
        sb.append(isCurrent);
        sb.append(")");
        return sb.toString();
    }
}
