package edu.gwu.blaise.version2.transmission;
/**
 * This class is what is used to perform all of the grader login actions.
 * It will also get basic data that is needed at the beginning of a session.
 * @author Michael Gaiman
 * @version 2 1/25/2004
 */
import java.util.*;
public interface GraderLoginQuery extends TransmissionQuery{
    /**
     * @return a Vector containing {@link Course} of all the grader's current courses.
     */
    public Vector getCourses();

    /**
     * @return a Vector containing {@link Course} of all the grader's past courses.
     */
    public Vector getPastCourses();

    /**
     * @return a Vector containing {@link Course} of all the grader's courses.
     */
    public Vector getAllCourses();
    
    /**
     * @return all of the information about a grader (excluding the grader's password.)
     */
    public Grader getGrader();
    
}
