package edu.gwu.blaise.version2.transmission;
/**
 * <p><code>TransmissionConstants</code> includes various constants that are used in the
 * transmission of data between the clients and the backend.</p>
 *
 * @author Michael Gaiman
 * @version 2 1/25/2004
 */

public class TransmissionConstants {

	//public constants
	/** Used to separate the minor datafields in the transmitted string representation*/
	public static final String COL_SEPARATOR=":::";
	/** Used to find separate minor datafields (RX: regex)*/
	static final String COL_SEPARATOR_RX="\\:\\:\\:";
	/** Used to separate the major datafields in the transmitted string representation*/
	public static final String ROW_SEPARATOR="|||";
	/** Used to find separate major datafields (RX: regex)*/
	static final String ROW_SEPARATOR_RX="\\|\\|\\|";
	/** Used to seperate IDs when they are transmitted.*/
	public static final String ID_SEPARATOR=",,,";
	/** Used to find separate IDs (RX: regex)*/
	static final String ID_SEPARATOR_RX="\\,\\,\\,";
	/**Used to separate entries in the debug file*/
	public static final String DebugEntrySeparator="---------------------------------------------------------------------";

	//the commands (organized by type)
	/*NOTE: adding a command here is not enough to make the backend work with the command.
			You also need to add the command to the Servlet that will be processing it, and
			to the packaging class that will be executing and packaging it.
	*/
	public static final String getWriterID="getWriterID";
	public static final String getGraderID="getGraderID";
	public static final String getCourseID="getCourseID";
	public static final String getPaperID="getPaperID";
	public static final String getUniversityID="getUniversityID";
	public static final String getAdminID="getAdminID";
	public static final String getCourseToGraderID="getCourseToGraderID";
	public static final String getCourseToWriterID="getCourseToWriterID";
	public static final String getCheckoutID="getCheckoutID";
	public static final String getEmailQueueID="getEmailQueueID";
	public static final String getAssignID="getAssignID";
	public static final String getWriterAsGraderID="getWriterAsGraderID";
	public static final String getDraftStructureID="getDraftStructureID";
	public static final String getStagingID="getStagingID";
	public static final String getPaperUngradedID="getPaperUngradedID";
	
	public static final String getWriter="getWriter";
	public static final String getGrader="getGrader";
	public static final String getCourse="getCourse";
	public static final String getUniversity="getUniversity";
	public static final String getAdmin="getAdmin";
	public static final String getCourseToGrader="getCourseToGrader";
	public static final String getCourseToWriter="getCourseToWriter";
	public static final String getCheckout="getCheckout";
	public static final String getEmailQueue="getEmailQueue";
	public static final String getStaging="getStaging";
	public static final String getWriterAsGrader="getWriterAsGrader";
	public static final String getDraftStructure="getDraftStructure";
	public static final String getAssignment="getAssignment";
	
	public static final String getPaperFull="getPaperFull";
	public static final String getPaperHeader="getPaperHeader";
	public static final String checkOutPaper="checkOutPaper";
	public static final String checkInPaper="checkInPaper";
	public static final String submitPaper="submitPaper";
	public static final String stagePaper="stagePaper";
	public static final String sendStagedPaper="sendStagedPaper";
	
	public static final String validateGraderLogin="validateGraderLogin";
	public static final String validateWriterLogin="validateWriterLogin";
	public static final String validateAdminLogin="validateAdminLogin";
	
	public static final String deleteWriter="deleteWriter";
	public static final String deleteGrader="deleteGrader";
	public static final String deleteCourse="deleteCourse";
	public static final String deleteUniversity="deleteUniversity";
	public static final String deleteCourseToGrader="deleteCourseToGrader";
	public static final String deleteCourseToWriter="deleteCourseToWriter";
	public static final String deleteAssignment="deleteAssignment";
	public static final String deleteDraftStructure="deleteDraftStructure";
	public static final String deleteWriterAsGrader="deleteWriterAsGrader";
	public static final String deleteStaging="deleteStaging";

	public static final String newWriter="newWriter";
	public static final String newGrader="newGrader";
	public static final String newCourse="newCourse";
	public static final String newUniversity="newUniversity";
	public static final String newCourseToGrader="newCourseToGrader";
	public static final String newCourseToWriter="newCourseToWriter";
	public static final String newAssignment="newAssignment";
	public static final String newDraftStructure="newDraftStructure";
	public static final String newWriterAsGrader="newWriterAsGrader";
	public static final String newStaging="newStaging";

	public static final String editWriter="editWriter";
	public static final String editGrader="editGrader";
	public static final String editCourse="editCourse";
	public static final String editUniversity="editUniversity";
	public static final String editCourseToGrader="editCourseToGrader";
	public static final String editCourseToWriter="editCourseToWriter";
	public static final String editAssignment="editAssignment";
	public static final String editDraftStructure="editDraftStructure";
	public static final String editWriterAsGrader="editWriterAsGrader";

	//used for staging
	public static final String INCOMPLETE="INCOMPLETE";
	public static final String COMPLETE="COMPLETE";
	
	//package constants
	public static final String SUCCESS="SUCCESS";
	public static final String FAILURE="FAILURE";

	/**the break inbetween status/format and format/body in results*/
	static final String BREAK="\n";
	static final String BREAK_RX="\n";

	public static final String GRADER_PASS_CODE="2";
	public static final String WRITER_PASS_CODE="3";

	public static final String GRADER_FORWARD_ADDRESS="http://128.164.201.98:8080/blaise/graderForward.txt";
	public static final String WRITER_FORWARD_ADDRESS="http://128.164.201.98:8080/blaise/writerForward.txt";

	public static final String dateFormat="yyyy-MM-dd H:m:s";
	
	/*used to print error messages to the debug file*/
	public static final String debugFile="/usr/local/jakarta-tomcat-5.0.28/webapps/blaise/WEB-INF/logs/remoteDebug.txt";
	public static final String DEBUG_FORWARD_ADDRESS="http://128.164.201.98:8080/blaise/debugForward.txt";
	
	public static final String StudentWebAccess="http://128.164.201.98:8080/StudentWebAccess";
	public static final String logoFileLocation="blaiselogosmall.png";
}
