package edu.gwu.blaise.version2.transmission;
import java.util.*;
/**
 * This class is what is used to perform all of the writer login actions.
 * It will also get basic data that is needed at the beginning of a session.
 * @author Michael Gaiman
 * @version 2 1/25/2004
 */
public interface WriterLoginQuery extends TransmissionQuery{
    /**
     * @return a Vector containing {@link Course} of all the writer's current courses.
     */
    public Vector getCourses();

    /**
     * @return a Vector containing {@link Course} of all the writer's past courses.
     */
    public Vector getPastCourses();

    /**
     * @return a Vector containing {@link Course} of all the writer's courses.
     */
    public Vector getAllCourses();
    
    /**
     * @return all of the information about a writer (excluding the writer's password.)
     */
    public Writer getWriter();
}
