//LOC:68
package edu.gwu.blaise.version2.util;

import javax.swing.*;
import javax.swing.table.*;

/**
 * Model to store table formatting information
 *
 * @author Sean T. Hanlon
 */
public class BlaiseTableColumnModel extends DefaultTableColumnModel {

	/** Adds a column to a table - sets widths of columns*/
	public void addColumn(TableColumn tc){

		String col = (String)tc.getHeaderValue();

		if(col.equals("SSN")){
			tc.setPreferredWidth(75);
		}
		else if(col.equals("First")){
			tc.setPreferredWidth(125);
		}
		else if(col.equals("Last")){
			tc.setPreferredWidth(125);
		}
		else if(col.equals("Most Recent Title")){
			//tc.setMinWidth(300);
			tc.setPreferredWidth(300);
		}
		else if(col.equals("Course")){
			DefaultTableCellRenderer defaultTableCellRenderer = new DefaultTableCellRenderer();
			defaultTableCellRenderer.setHorizontalAlignment(SwingConstants.CENTER);
			tc.setCellRenderer(defaultTableCellRenderer);

			tc.setPreferredWidth(125);
		}
		else if(col.equals("Draft Count")){
			DefaultTableCellRenderer defaultTableCellRenderer = new DefaultTableCellRenderer();
			defaultTableCellRenderer.setHorizontalAlignment(SwingConstants.CENTER);
			tc.setCellRenderer(defaultTableCellRenderer);

			tc.setPreferredWidth(75);
		}
		else{
			tc.setPreferredWidth(75);
		}
		super.addColumn(tc);
	}
}