//LOC:157
package edu.gwu.blaise.version2.util;

import javax.swing.table.*;
import java.util.*;
import edu.gwu.blaise.version2.documents.*;

/**
 * Model to store table data
 *
 * @author Sean T. Hanlon
 */
public class BlaiseTableModel extends AbstractTableModel {

	Vector papers;		//the papers
	int type;			//type to display
	int colCount;		//number of columns
	String[] headers;	//column headers

	/** Constructor */
	public BlaiseTableModel(){
		this.type = type;

		colCount = 6;
		String[] temp = {"SSN","First","Last","Draft Count","Most Recent Title", "Course"};
		headers = temp;

		papers = new Vector();	//initialize papers
	}

	public BlaiseTableModel(Vector paperVec){
		this();
		papers = paperVec;
	}

	/** Get the column name at a given index */
	public String getColumnName(int i) {
		return headers[i];
	}

	/** Get the column count */
	public int getColumnCount(){
		return colCount;
	}

	/** Get the number of rows */
	public int getRowCount(){

		if(papers != null) return papers.size();
		else return 0;
	}

	/** Get a value based on row and column position */
	public Object getValueAt(int i, int j){

		Blaise_Paper paperAt = (Blaise_Paper)papers.elementAt(i);

		if (j==0){
			return paperAt.getStudentIdentifier();
		}
		else if(j==1){
			return paperAt.getFirst();
		}
		else if(j==2){
			return paperAt.getLast();
		}
		else if(j==3){
			int count = Integer.parseInt(paperAt.draftCount());
			count--;
			return new Integer(count);
		}
		else if(j==4){
			/* return paperAt.getMostRecentTitle(); */
			return null;
		}
		else if(j==5){
			return (paperAt.getDept()+" "+paperAt.getNumber()+"-"+paperAt.getSection());
		}
		else{
			return "ERROR";
		}
	}

	/** Set table with given Vector or paper */
	public void setTable(Vector results){
		papers = results;
		fireTableChanged(null);
	}
}
