package edu.gwu.blaise.version2.util;
import edu.gwu.blaise.version2.documents.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.util.Vector;
/**
 * A class to hold generic utility methods that don't fit in anywhere else.
 * @author Michael Gaiman
 * @version 1 7/12/2004
 */
public class BlaiseUtilities {
    public static JTree getPaperTreeView(Blaise_Paper paper){
        DefaultMutableTreeNode root=new DefaultMutableTreeNode("Paper");
        DefaultMutableTreeNode n=new DefaultMutableTreeNode("Writer: "+paper.getFirst()+' '+paper.getLast());
        n.add(new DefaultMutableTreeNode("Student ID: "+paper.getStudentIdentifier()));
        n.add(new DefaultMutableTreeNode("Email Address: "+paper.getEmail()));
        root.add(n);
        String dateS;
        if(paper.getSemester().equals("")){
            dateS="";
        }
        else{
            dateS=" ("+paper.getSemester()+' '+paper.getYear()+')';
        }
        root.add(new DefaultMutableTreeNode("Course: "+paper.getDept()+' '+paper.getNumber()+'-'+paper.getSection()+dateS));
        n=new DefaultMutableTreeNode("Assignment: "+paper.getAssignmentNumber());
        n.add(new DefaultMutableTreeNode(paper.getAssignmentName()));
        root.add(n);
        Vector drafts=paper.getDrafts();
        int nDrafts=drafts.size(),nComments;
        DefaultMutableTreeNode dN=new DefaultMutableTreeNode(nDrafts+((nDrafts==1)?" Draft":" Drafts"));
        root.add(dN);
        
        Blaise_Draft draft;
        Blaise_Comment comment;
        Vector comments;
        DefaultMutableTreeNode m;
        int i,j;

        for(i=0;i<nDrafts;i++){
            draft=(Blaise_Draft)drafts.elementAt(i);
            n=new DefaultMutableTreeNode("Draft "+(i+1)+": "+draft.getTitle());
            dN.add(n);
            if(!draft.getTurninDate().equals("")){
                n.add(new DefaultMutableTreeNode("Turn-in Date: "+draft.getTurninDate()));
            }
            n.add(new DefaultMutableTreeNode("Document Type: "+(draft.hasExternalBody()?"External Document":"Blaise Document")));
            comments=draft.getComments();
            nComments=comments.size();
            m=new DefaultMutableTreeNode(nComments+((nComments==1)?" Grader":" Graders"));
            n.add(m);
            for(j=0;j<nComments;j++){
                comment=(Blaise_Comment)comments.elementAt(j);
                m.add(new DefaultMutableTreeNode("Grader: "+comment.getGraderName()));
            }
        }
        
        //make the tree
        JTree tree=new JTree(root);
        tree.expandRow(0);//root expanded by default.
        return tree;
    }
}
