package edu.gwu.blaise.version2.util;
import java.util.Properties;
import java.io.*;
import java.nio.ByteBuffer;
import com.apple.eio.*;
import edu.gwu.blaise.version2.documents.DocumentUtilities;
/**
 * Rewrites the blaise properties file to point to ~/Application Support/Blaise/ 
 * for the data storing directories.
 * @author Michael Gaiman
 * @version 1 7/24/2004
 */ 
public class MacInstall{

    public static boolean installNeeded(){
        /*MacInstall hacks around the properties file to allow multi-user support in OSX.
         *The way it works is to keep internal tabs (via the properties file)
         *of the current user that the properties file points to.
         *If the current user is not that user, an install is needed.
         */
         
         String user=Constants.getUser();
         if(user==null){
            return true;//fresh install
         }
         else{
            if(user.equals(System.getProperty("user.name"))){
                return false;//not needed, same user.
            }
            else{
                return true;//different user rewrite for the moment.
            }
         }
    }

    public static void doMacInstall(){
        //get the directory
        String asup=null;
        try{
            asup=FileManager.findFolder((short)-32763,1634956656);//1634956656 is 'asup' in c
        }catch(FileNotFoundException e){
            e.printStackTrace();
        }
        System.out.println("asup:"+asup);
        
        String blaiseDir=asup+File.separator+"Blaise"+File.separator;
        System.out.println(blaiseDir);
        //make it if necessary
        File dir=new File(blaiseDir);
        if(!dir.exists()){
            if(!dir.mkdirs()){
                System.out.println("Couldn't create Blaise Application Support Directories.  Aborting");
                return;
            }
        }
        
        Constants.reWritePropsFile(blaiseDir);
        //now reimport them.
        Constants.parsePropsFile(Constants.file);
    }
    
    public static void main(String[] argv){
        doMacInstall();
    }
}