package edu.gwu.blaise.version2.util;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;

import edu.gwu.blaise.version2.transmission.*;
/**
 * @depricated replaced by new client.SubmissionWizard
 */
public class PaperSubmissionDisplay extends JDialog {

	JDialog thisDialog;
	JFrame parent;		//parent frame
	JPanel pane;				//overall panel
	WriterLoginQuery login;
	JComboBox courseBox;
	Course selected;
	Vector courses;

	/**
	 * Constructor
	 *
	 */
	public PaperSubmissionDisplay(JFrame parent, WriterLoginQuery login){
		super(parent, "Authentication Successful", true);

		this.parent = parent;
		thisDialog = this;
		pane = new JPanel(new BorderLayout());
		JPanel top = new JPanel(new GridLayout(2,2,4,4));

		edu.gwu.blaise.version2.transmission.Writer writer = login.getWriter();
		top.add(new JLabel("Username", SwingConstants.CENTER));
		top.add(new JLabel(writer.getUserName(), SwingConstants.CENTER));
		top.add(new JLabel("Course", SwingConstants.CENTER));
		courseBox = new JComboBox();
		courses = login.getCourses();
		for(int i=0;i<courses.size();i++){
			Course current = (Course)courses.elementAt(i);
			courseBox.addItem(current.getDept()+" "+current.getNumber()+"-"+current.getSection());
		}
		top.add(courseBox);

		pane.add(top, BorderLayout.CENTER);
	}

	public Object getCourse(){
		return selected;
	}

	public void determineCourse(){

		JButton ok = new JButton("Submit");
		JButton cancel = new JButton("Cancel");

		//On ok - user selected
		ok.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent rv){
					int index = courseBox.getSelectedIndex();
					selected = (Course)courses.elementAt(index);
					thisDialog.setVisible(false);
			}
		});

		//On cancel - user wishes to give-up logging in
		cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent rv){
				selected = null;
				thisDialog.setVisible(false);
			}
		});

		//Create panel for buttons and add them to it
		JPanel buttons = new JPanel(new FlowLayout());
		buttons.add(ok);
		buttons.add(cancel);
		pane.add(buttons, BorderLayout.SOUTH);

		this.getContentPane().add(pane);
		this.setSize(350,130);
		this.setVisible(true);
	}
}