package edu.gwu.blaise.version2.util.contextmenu;
import javax.swing.JMenuItem;
/**
 * Classes that are interested in bringing up a contextual menu (also known as a right
 * click or popup menu) should implement this interface, and register themselves with 
 * ContextMenuManager.
 * The ContextMenuManager will then use the implemented method to build a combined JPopupMenu.
 * @see ContextMenuManager
 * @see ContextMenuEvent
 *
 * @author Michael Gaiman mgaiman@gwu.edu
 * @version 1.1 3/15/2004
 * @history 1.0 3/15/2004 Initial version
 *          1.1 3/16/2004 Blaise packaging
 */
public interface ContextMenuListener{
    /**
     * When given a ContextMenuEvent this method returns an array of items
     * that will be added to the contextual menu that is displayed.
     */
    public JMenuItem[] getContextMenuItems(ContextMenuEvent e);
}