package edu.gwu.servlets;
/**
 *	Classes that would like to be notified of
 *	property changes should implement this interface.
 *	
 *	Implementors need to register for property change
 *	notifications by calling StaticContext.
 *
 *	Please note: the value can be null.  This occurs when
 *	a property has been removed and indicates that a default value
 *	should be used instead.
 *
 *	@Author Michael Gaiman
 *	@Version 1.0 6/2/2003
 */
interface PropertyChangeListener {
    void propertyChangeNotification(String property, String value);
}
